title 'Generate a Chi-Square table';
options ls=110;
%let df=  1 to 20,
         25 to 50 by 5,
         60 to 100 by 10,
        200 to 400 by 50;
%let np=12;   %*-- Number of p-values;
%let pvalue=.25 .10 .09 .08 .07 .06 .05 .025 .01 .005 .0025 .001;
%let divisor = 1;     *-- Chi-square values;
*let divisor = df;    *-- Chi-square / df values;

data chisq;
	array pr(*) p1-p&np   (&pvalue); 
	keep df p c;
	label p='Upper Tail Prob'
			df='df';
   do k = 1 to dim(pr);        /* for each P-value */
	 	p = 100*pr(k);
		do df = &df;
         c = cinv(1-pr(k), df) / &divisor;
			output;
         end;
      end;

proc sort;
	by df;
proc transpose out=chi2tab;
	by df; var c;

%*-- Generate variable labels;
%macro lab(k, prefix, values);
	%do i=1 %to &k;
		&&prefix.&i = "%scan(&values,&i,%str( ))"
		%end;
%mend;

proc format;
	picture cvalue low-<100  = '00.00'
		            100-high  = '000.0';
data chi2tab;
	set chi2tab;
	drop _name_;
	format col1-col&np cvalue. df 4.;
	label	%lab(&np, COL, &pvalue);
proc print label;
	id df;
*snip;
*sas2tex(data=chi2prob, 
	id=df, var=col1-col12,
	texalone=Y, tabenv=\small);
