 /*-----------------------------------------------------------------*
  |     Name: madfit.sas                                            |
  |    Title: Illustrate GOODFIT and ROOTGRAM macros                |
  | ----------------------------------------------------------------|
  |    Procs: print                                                 |
  |   Macros: goodfit rootgram                                      |
  | Datasets: compare                                               |
  | ----------------------------------------------------------------|
  |   Author: Michael Friendly               <friendly@yorku.ca>    |
  |  Created: 16 Jun 2000 14:15:30                                  |
  *-----------------------------------------------------------------*/
title 'Illustrate GOODFIT and ROOTGRAM macros';
%include goptions;
goptions htext=3pct htitle=5pct vsize=6in hsize=8in;

title "Instances of 'may' in Federalist papers" ;
%include catdata(madison);

*-- fit a Poisson;
%goodfit(data=madison, var=count, freq=blocks, dist=poisson, out=fit);

title;
%rootgram(data=fit, var=count, obs=blocks, btype=0, func=none);  /* a */
%rootgram(data=fit, var=count, obs=blocks, btype=0);             /* b */
%rootgram(data=fit, var=count, obs=blocks);                      /* c */
%rootgram(data=fit, var=count, obs=blocks, btype=dev);           /* d */

*-- fit a Negative Binomial;
%goodfit(data=madison, var=count, freq=blocks, dist=negbin, out=fit2);
%rootgram(data=fit2, var=count, obs=blocks, btype=dev);

*-- compare the fitted values;
data compare;
	merge fit(keep=count blocks exp)
	      fit2(rename=(exp=exp2));

proc print data=compare;
	id count;
	var blocks exp exp2;
