/*
  Name: arrests.sas
 Title: Arrests for Marijuana Possession
 Source: Toronto Star; effects package

Data  on  police  treatment  of  individuals  arrested  in  Toronto  for  simple
possession of small quantities of marijuana. The response is whether an individual
was released with a summons vs. some harsher treatment. 
The data are part of a larger  data
set featured in a series of articles in the Toronto Star newspaper. 

*/

data arrests;
   infile cards dlm="," DSD ;
   informat released $3. ;
   informat colour $5. ;
   informat year best32. ;
   informat age best32. ;
   informat sex $7. ;
   informat employed $3. ;
   informat citizen $3. ;
   informat checks best32. ;
   input   released $   colour $   year   age   sex $   employed $   citizen $   checks;
datalines;
Yes,White,2002,21,Male,Yes,Yes,3
No,Black,1999,17,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,3
No,Black,2000,46,Male,Yes,Yes,1
Yes,Black,1999,27,Female,Yes,Yes,1
Yes,Black,1998,16,Female,Yes,Yes,0
Yes,White,1999,40,Male,No,Yes,0
Yes,White,1998,34,Female,Yes,Yes,1
Yes,Black,2000,23,Male,Yes,Yes,4
Yes,White,2001,30,Male,Yes,Yes,3
Yes,White,1999,18,Male,Yes,No,0
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,1
Yes,Black,1997,42,Male,Yes,Yes,0
Yes,Black,1999,26,Male,No,Yes,2
Yes,White,2001,25,Male,No,Yes,3
No,White,2001,45,Male,No,Yes,4
No,White,2002,20,Male,Yes,Yes,5
Yes,White,2001,32,Female,No,Yes,3
No,White,1998,14,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,No,0
Yes,White,2001,15,Male,No,Yes,2
Yes,White,2001,16,Male,Yes,Yes,0
No,White,2000,27,Female,No,Yes,3
Yes,White,2000,49,Male,Yes,Yes,0
Yes,White,2001,21,Male,No,Yes,3
Yes,Black,2001,29,Male,Yes,Yes,3
Yes,White,2000,28,Male,Yes,No,0
Yes,White,2000,19,Male,No,Yes,0
Yes,White,1999,28,Male,Yes,Yes,3
Yes,White,2000,19,Female,Yes,Yes,0
Yes,White,2001,30,Male,Yes,No,3
No,White,2001,15,Male,No,Yes,2
No,White,1999,35,Male,Yes,Yes,3
Yes,White,1998,20,Female,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,1998,16,Male,No,No,0
Yes,White,2000,24,Male,Yes,Yes,1
No,Black,2000,21,Male,No,No,4
No,White,1998,17,Male,Yes,No,0
Yes,White,2001,27,Male,No,Yes,2
Yes,Black,2001,18,Male,Yes,Yes,1
Yes,White,1997,39,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,0
No,White,1997,21,Male,Yes,No,1
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,4
Yes,White,1997,26,Female,Yes,Yes,0
No,Black,2001,26,Male,Yes,Yes,4
Yes,Black,2000,20,Male,Yes,Yes,3
Yes,Black,2000,21,Male,Yes,No,3
Yes,White,1997,18,Male,Yes,Yes,4
Yes,White,2000,17,Female,Yes,Yes,0
Yes,White,2001,19,Male,Yes,No,3
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,42,Male,Yes,Yes,3
Yes,Black,2001,19,Male,No,Yes,3
Yes,White,1998,25,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,Black,2002,21,Male,Yes,Yes,1
Yes,White,1997,53,Male,Yes,No,3
Yes,Black,2000,19,Male,Yes,Yes,4
No,Black,1999,40,Male,Yes,No,2
Yes,White,2000,30,Male,No,No,3
Yes,White,1998,21,Male,Yes,Yes,0
No,White,1998,17,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
No,Black,2000,19,Male,Yes,Yes,4
Yes,Black,1997,30,Female,Yes,Yes,2
Yes,White,1998,15,Female,Yes,Yes,0
Yes,White,2000,16,Female,Yes,Yes,1
Yes,Black,2000,17,Male,Yes,Yes,1
Yes,White,1999,23,Female,Yes,Yes,0
No,Black,2000,18,Male,No,Yes,3
Yes,White,2001,16,Female,Yes,Yes,0
No,Black,2000,22,Male,No,Yes,5
Yes,White,1998,40,Male,No,Yes,3
No,White,1997,44,Male,Yes,No,0
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1998,14,Male,Yes,Yes,0
Yes,Black,1999,18,Male,Yes,Yes,4
Yes,White,1999,30,Male,Yes,Yes,2
No,White,1999,22,Male,No,Yes,5
Yes,Black,2001,29,Male,No,No,2
No,White,1998,15,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,3
Yes,White,2001,33,Male,Yes,Yes,2
Yes,White,2001,22,Male,Yes,Yes,0
Yes,Black,2001,22,Male,Yes,Yes,4
Yes,White,2001,44,Male,Yes,Yes,2
Yes,White,1999,19,Male,Yes,Yes,4
Yes,Black,1998,24,Male,No,Yes,3
Yes,White,2001,15,Male,Yes,Yes,0
No,White,1997,17,Male,No,No,4
Yes,White,1999,22,Male,Yes,Yes,0
Yes,Black,2001,48,Male,Yes,Yes,3
Yes,White,2001,15,Male,Yes,Yes,0
No,White,2001,20,Male,Yes,Yes,0
Yes,White,1997,21,Male,Yes,Yes,3
Yes,White,1999,33,Male,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,2
No,White,2001,25,Male,Yes,No,2
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,2001,27,Male,Yes,Yes,0
Yes,White,2002,17,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,Yes,3
No,White,1999,17,Male,Yes,Yes,2
No,White,2000,20,Male,No,Yes,4
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,1997,17,Male,Yes,Yes,0
Yes,Black,2000,30,Male,Yes,Yes,1
Yes,White,2001,36,Female,No,Yes,3
Yes,White,1999,16,Male,Yes,Yes,2
No,White,1997,19,Male,Yes,No,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,40,Male,Yes,Yes,3
Yes,White,2000,23,Male,Yes,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,3
Yes,White,1998,21,Male,Yes,Yes,0
Yes,Black,1998,38,Male,Yes,Yes,3
Yes,Black,2000,25,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,4
Yes,White,2000,17,Female,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,1
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,3
Yes,Black,2001,20,Male,Yes,Yes,1
No,Black,1999,29,Female,No,No,4
No,Black,2001,22,Male,Yes,Yes,3
Yes,White,2001,38,Female,No,Yes,3
Yes,White,1999,17,Female,Yes,Yes,0
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,1997,21,Male,Yes,No,3
No,White,2001,21,Male,Yes,No,4
Yes,White,1999,31,Male,Yes,Yes,1
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,1997,24,Male,No,No,0
Yes,Black,2001,18,Male,Yes,Yes,2
Yes,Black,2001,35,Male,Yes,Yes,2
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,1999,17,Male,Yes,Yes,2
Yes,Black,2000,24,Female,Yes,Yes,0
Yes,White,1998,41,Male,Yes,Yes,2
Yes,White,1999,15,Male,Yes,Yes,1
No,Black,2000,19,Male,Yes,Yes,3
Yes,Black,2000,15,Male,Yes,Yes,2
Yes,White,2000,26,Male,Yes,Yes,0
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,1998,28,Male,Yes,Yes,1
No,White,2002,17,Male,No,Yes,0
No,White,1999,39,Male,No,Yes,4
Yes,White,1999,26,Male,Yes,Yes,4
Yes,White,2002,19,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,No,0
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,3
Yes,White,1999,20,Male,No,Yes,4
Yes,White,2001,19,Male,Yes,Yes,2
No,Black,1997,21,Male,No,No,2
No,Black,1997,21,Male,No,No,2
No,Black,1998,18,Male,No,Yes,3
Yes,White,1998,20,Male,Yes,Yes,3
Yes,White,2000,31,Male,Yes,Yes,3
Yes,White,1997,18,Male,Yes,No,4
Yes,White,1997,21,Male,No,No,4
No,White,2001,37,Male,Yes,No,0
Yes,White,1999,20,Male,No,Yes,3
Yes,Black,2001,34,Male,Yes,Yes,2
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,4
No,White,1999,24,Male,Yes,Yes,3
No,White,1999,32,Male,Yes,Yes,4
Yes,White,2000,22,Male,Yes,Yes,1
Yes,White,1997,14,Female,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,5
Yes,Black,1998,27,Male,Yes,No,0
Yes,White,2002,24,Male,Yes,Yes,1
Yes,Black,2000,31,Male,Yes,Yes,0
Yes,White,1998,20,Male,No,Yes,1
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,1
Yes,White,2000,22,Male,Yes,Yes,1
Yes,White,2001,12,Male,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,0
No,White,1999,21,Male,No,Yes,1
No,Black,2001,15,Male,Yes,Yes,5
Yes,Black,2001,20,Male,No,Yes,3
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1999,24,Male,Yes,No,0
Yes,Black,1997,18,Male,Yes,No,4
No,White,1999,37,Female,No,Yes,2
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,2
Yes,Black,2000,22,Male,Yes,Yes,3
No,White,1997,17,Male,No,Yes,2
Yes,Black,2001,21,Male,Yes,No,0
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,2
Yes,White,1998,36,Female,Yes,Yes,4
Yes,White,2000,19,Male,Yes,Yes,0
Yes,Black,2001,17,Male,No,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1998,24,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,1997,24,Male,No,Yes,5
Yes,White,1998,18,Male,Yes,Yes,1
Yes,White,1998,22,Male,Yes,Yes,3
Yes,White,1999,23,Male,Yes,Yes,4
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,3
Yes,Black,2000,24,Female,Yes,Yes,2
Yes,White,1998,26,Male,Yes,Yes,3
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,1
Yes,Black,2001,19,Male,No,Yes,5
Yes,White,2001,21,Male,No,Yes,1
No,White,1998,15,Male,Yes,Yes,3
Yes,White,1997,16,Male,Yes,No,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,Black,2002,24,Male,Yes,Yes,1
Yes,White,1997,40,Male,Yes,No,0
Yes,Black,1997,29,Male,Yes,No,4
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1999,24,Male,Yes,Yes,3
Yes,White,2001,17,Male,Yes,Yes,0
Yes,Black,2000,27,Male,Yes,No,3
Yes,White,1998,28,Male,Yes,Yes,4
Yes,White,1999,19,Female,Yes,Yes,0
Yes,Black,1998,24,Male,Yes,Yes,3
Yes,White,2000,22,Male,No,Yes,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,2001,36,Male,Yes,Yes,1
No,Black,1997,43,Male,No,No,0
Yes,White,2000,18,Male,Yes,Yes,2
Yes,Black,1998,26,Male,Yes,Yes,3
Yes,White,2000,16,Female,Yes,Yes,0
Yes,White,2000,26,Male,Yes,Yes,1
No,White,2000,17,Male,No,Yes,4
Yes,Black,1999,21,Male,Yes,No,0
Yes,White,2000,17,Male,Yes,Yes,3
Yes,Black,2001,37,Male,Yes,Yes,0
Yes,White,1999,32,Male,Yes,Yes,0
No,White,2000,42,Male,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,2000,15,Female,Yes,Yes,0
Yes,Black,1998,17,Male,Yes,Yes,0
Yes,White,1999,34,Male,No,Yes,0
Yes,White,2001,19,Male,Yes,Yes,3
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,2001,16,Male,Yes,Yes,0
Yes,Black,2000,38,Male,Yes,Yes,2
Yes,White,2000,44,Male,Yes,Yes,3
Yes,White,1999,14,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,3
Yes,White,2001,15,Male,Yes,Yes,0
No,White,1999,19,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,1
Yes,White,2000,28,Male,Yes,Yes,3
Yes,Black,2000,22,Male,Yes,Yes,1
Yes,White,1998,14,Male,Yes,Yes,2
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,3
Yes,White,2002,23,Male,Yes,Yes,1
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,3
Yes,White,1999,23,Male,Yes,Yes,3
No,Black,2000,23,Male,Yes,Yes,0
Yes,Black,2001,31,Female,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,3
Yes,Black,1999,14,Male,Yes,Yes,0
No,White,1999,19,Female,Yes,Yes,0
Yes,Black,1997,22,Male,Yes,No,4
Yes,White,1998,26,Male,Yes,Yes,0
Yes,White,1999,21,Female,No,Yes,0
No,Black,1999,37,Male,Yes,No,2
Yes,White,2001,29,Male,Yes,Yes,2
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,3
Yes,Black,2001,18,Male,No,Yes,3
Yes,White,1998,18,Male,Yes,Yes,3
No,Black,2000,19,Male,Yes,Yes,4
Yes,Black,2000,17,Female,Yes,Yes,2
Yes,White,2001,34,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,Black,1999,25,Male,Yes,Yes,1
Yes,White,2000,26,Male,Yes,Yes,0
Yes,White,1998,21,Male,No,Yes,3
Yes,Black,2001,24,Male,Yes,Yes,3
Yes,White,2001,25,Male,Yes,Yes,0
Yes,Black,2001,21,Male,Yes,Yes,2
Yes,Black,1999,22,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2002,16,Female,Yes,Yes,0
Yes,White,2000,18,Male,Yes,No,4
Yes,White,1997,14,Male,Yes,No,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,3
Yes,White,1999,17,Male,Yes,Yes,3
Yes,White,1999,18,Male,Yes,Yes,2
Yes,White,1999,32,Male,Yes,Yes,4
Yes,White,2002,16,Male,Yes,Yes,0
No,Black,1998,19,Male,No,Yes,4
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,2001,20,Male,Yes,Yes,2
No,White,1998,14,Male,Yes,Yes,1
Yes,White,2001,20,Male,Yes,Yes,0
No,White,2000,45,Male,Yes,Yes,4
Yes,White,1999,26,Male,Yes,Yes,2
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,1997,17,Male,Yes,Yes,0
Yes,White,1998,52,Male,Yes,Yes,4
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,1998,27,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,0
No,Black,2002,29,Female,No,Yes,4
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,4
Yes,White,1997,21,Male,No,No,2
Yes,White,1997,18,Female,Yes,Yes,0
No,White,2001,40,Male,No,Yes,3
Yes,Black,1999,22,Male,Yes,Yes,4
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,2001,30,Male,Yes,Yes,2
Yes,Black,2001,41,Female,No,Yes,2
Yes,White,1998,33,Male,Yes,Yes,3
Yes,White,1999,21,Male,Yes,No,1
Yes,Black,2002,22,Male,No,Yes,1
No,White,2000,24,Male,Yes,Yes,1
No,Black,1998,16,Male,Yes,No,1
Yes,White,1999,43,Male,No,Yes,2
No,Black,2001,23,Male,No,Yes,2
Yes,White,1998,24,Male,Yes,Yes,2
Yes,White,2001,35,Male,Yes,Yes,2
Yes,White,1998,23,Male,Yes,Yes,0
Yes,Black,1998,29,Male,Yes,Yes,4
Yes,White,1999,21,Male,No,Yes,1
Yes,White,2000,19,Female,No,Yes,1
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,1998,22,Male,Yes,Yes,4
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,1997,18,Male,Yes,Yes,1
Yes,White,1998,21,Male,No,Yes,3
Yes,White,2001,22,Male,No,No,0
Yes,White,1998,32,Male,No,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,33,Male,Yes,Yes,1
Yes,White,2000,22,Male,Yes,Yes,0
Yes,Black,2001,19,Male,Yes,Yes,4
Yes,Black,1999,36,Female,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,1997,34,Male,Yes,No,0
Yes,Black,1998,19,Male,Yes,Yes,4
Yes,White,2001,21,Male,No,Yes,1
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2000,34,Male,Yes,Yes,1
Yes,White,1997,32,Male,Yes,Yes,2
Yes,White,1997,16,Male,No,No,0
Yes,White,2000,49,Male,Yes,Yes,3
Yes,White,2000,26,Male,No,Yes,3
Yes,White,2000,43,Male,Yes,Yes,0
No,Black,2002,20,Male,No,Yes,4
No,Black,1998,21,Male,No,No,4
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1997,16,Male,No,No,0
Yes,Black,1998,21,Female,No,Yes,0
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,2001,31,Male,No,Yes,3
Yes,Black,2000,25,Male,Yes,Yes,1
No,Black,2001,20,Male,Yes,Yes,3
No,White,2000,41,Male,No,Yes,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,2000,25,Male,Yes,No,0
Yes,Black,2001,33,Male,No,Yes,5
No,White,2001,27,Male,No,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
No,White,2000,21,Male,No,Yes,4
Yes,White,1998,20,Male,Yes,Yes,0
No,White,2000,30,Male,No,Yes,1
Yes,White,1998,25,Male,Yes,Yes,0
No,White,2001,53,Male,Yes,Yes,4
No,White,1998,19,Male,Yes,Yes,3
No,White,1999,33,Female,No,Yes,1
Yes,White,2001,22,Male,Yes,Yes,2
Yes,White,2001,17,Female,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,1999,23,Male,No,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2002,20,Male,Yes,Yes,2
Yes,White,2002,22,Male,Yes,Yes,3
No,Black,1998,28,Male,No,Yes,2
Yes,Black,2001,20,Male,Yes,Yes,2
Yes,White,2001,15,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2002,15,Male,Yes,Yes,0
Yes,Black,1999,23,Male,No,Yes,4
Yes,White,2000,41,Male,Yes,Yes,2
No,White,1999,34,Male,Yes,Yes,4
No,Black,1997,26,Male,Yes,No,4
Yes,White,2002,15,Male,Yes,Yes,0
No,White,1997,27,Male,No,No,4
No,White,2001,38,Male,Yes,Yes,4
Yes,Black,1998,21,Male,Yes,Yes,5
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1997,17,Male,Yes,No,3
No,White,1997,18,Male,Yes,No,4
Yes,White,2001,20,Female,Yes,Yes,0
Yes,Black,1999,28,Male,Yes,Yes,2
Yes,White,2001,34,Male,Yes,Yes,1
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,4
Yes,White,2000,37,Male,Yes,Yes,0
Yes,White,1999,15,Female,Yes,Yes,0
Yes,White,2000,31,Male,Yes,Yes,0
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,2001,53,Male,Yes,Yes,1
Yes,White,1998,19,Male,No,Yes,3
Yes,White,1999,40,Male,Yes,Yes,3
Yes,White,1998,23,Male,Yes,No,0
Yes,White,1998,16,Male,Yes,Yes,4
Yes,White,2000,19,Female,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,0
No,White,1997,41,Male,Yes,No,1
Yes,White,2001,19,Male,Yes,Yes,3
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,1
Yes,White,1998,40,Male,No,Yes,3
Yes,White,2001,23,Male,Yes,No,3
Yes,White,2001,19,Male,Yes,Yes,0
No,Black,1998,23,Male,Yes,Yes,3
Yes,Black,1999,16,Male,Yes,No,2
Yes,White,2001,32,Male,Yes,Yes,0
No,White,1997,42,Male,Yes,Yes,4
No,White,2000,43,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,0
Yes,Black,2000,17,Male,Yes,Yes,4
No,Black,2000,18,Male,Yes,Yes,2
Yes,White,2002,20,Male,Yes,Yes,2
Yes,White,2000,30,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,No,1
No,Black,2001,26,Male,No,No,3
No,White,1999,21,Male,Yes,Yes,3
Yes,White,2002,27,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,2002,43,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1997,17,Male,Yes,No,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1999,47,Male,Yes,Yes,0
Yes,Black,1999,17,Male,Yes,Yes,0
Yes,Black,1999,18,Male,Yes,Yes,1
No,White,2001,54,Male,Yes,Yes,0
Yes,Black,1999,21,Male,No,No,0
Yes,White,1999,21,Male,Yes,Yes,2
Yes,White,2001,17,Male,Yes,Yes,0
Yes,Black,1999,18,Male,No,No,1
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,1999,21,Female,Yes,Yes,0
Yes,White,1998,20,Male,Yes,Yes,3
Yes,White,1998,21,Male,Yes,Yes,2
Yes,White,2000,14,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,1
Yes,White,2000,19,Male,No,Yes,1
Yes,White,1998,17,Male,Yes,Yes,0
No,White,2001,21,Male,Yes,No,2
Yes,White,2001,36,Male,Yes,Yes,2
Yes,Black,2002,25,Male,Yes,Yes,1
Yes,White,1998,18,Female,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,4
Yes,Black,1999,31,Male,No,Yes,2
No,White,1997,37,Male,No,No,5
Yes,White,1997,32,Male,Yes,No,2
Yes,Black,2001,16,Male,Yes,Yes,0
Yes,White,1997,31,Male,No,No,0
Yes,Black,1999,22,Male,Yes,Yes,1
Yes,Black,2000,28,Male,Yes,Yes,0
Yes,White,2001,25,Male,Yes,Yes,0
No,Black,1998,25,Male,Yes,No,4
Yes,White,1998,49,Male,Yes,Yes,0
Yes,White,1997,44,Male,No,Yes,3
No,Black,2001,28,Male,Yes,Yes,4
Yes,White,1997,33,Male,No,Yes,4
Yes,White,1998,19,Male,Yes,Yes,2
Yes,Black,2001,32,Male,Yes,Yes,2
Yes,White,1997,16,Male,Yes,No,0
No,White,1997,28,Male,Yes,No,4
Yes,White,1998,16,Male,Yes,Yes,2
Yes,White,1999,16,Male,Yes,Yes,2
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,1999,26,Male,Yes,Yes,2
Yes,White,1997,20,Female,Yes,No,0
Yes,White,1999,22,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
No,White,2000,15,Female,Yes,Yes,4
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2000,23,Male,No,Yes,3
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,1
Yes,White,2001,39,Male,No,Yes,3
Yes,White,2000,31,Male,Yes,Yes,0
Yes,White,1999,34,Male,Yes,Yes,0
No,White,2002,19,Male,Yes,Yes,3
Yes,White,1997,21,Male,Yes,No,4
No,Black,2001,24,Male,No,Yes,3
Yes,Black,2001,39,Male,Yes,No,3
No,Black,2000,19,Male,No,Yes,3
Yes,Black,2000,34,Male,No,Yes,1
Yes,White,1999,22,Male,Yes,Yes,4
No,White,2001,48,Male,Yes,Yes,4
Yes,Black,2001,26,Male,No,Yes,3
Yes,White,2000,39,Male,Yes,Yes,0
No,White,2001,16,Male,Yes,Yes,3
Yes,White,1997,29,Male,Yes,Yes,1
Yes,White,2000,25,Male,Yes,Yes,3
Yes,White,2001,15,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,1
Yes,Black,2000,21,Male,Yes,Yes,1
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,1998,14,Male,Yes,Yes,0
No,White,2000,18,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,4
Yes,White,1997,18,Male,Yes,No,2
Yes,White,2000,18,Male,Yes,Yes,1
No,White,1999,19,Male,Yes,Yes,0
Yes,Black,1999,17,Male,Yes,Yes,1
Yes,White,1997,17,Male,Yes,No,0
Yes,Black,2000,31,Male,Yes,Yes,4
Yes,Black,2001,28,Male,Yes,Yes,1
No,White,1998,20,Male,Yes,No,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,Black,1999,20,Male,Yes,No,0
Yes,White,2001,15,Female,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,1
Yes,Black,2001,16,Male,Yes,Yes,3
No,White,2001,43,Male,Yes,Yes,3
Yes,White,2000,16,Female,Yes,Yes,0
No,Black,1998,22,Male,No,Yes,0
Yes,White,2001,27,Male,Yes,Yes,4
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,2001,33,Male,Yes,Yes,0
Yes,White,2000,39,Male,No,Yes,0
No,White,2000,27,Male,Yes,Yes,3
No,White,1998,16,Female,No,Yes,2
Yes,White,2000,30,Male,Yes,Yes,4
Yes,Black,1999,19,Male,Yes,Yes,3
Yes,White,1999,26,Male,No,Yes,3
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,1999,21,Male,No,Yes,4
Yes,White,2000,25,Male,No,No,1
Yes,White,2001,18,Male,Yes,Yes,4
Yes,White,2000,13,Male,No,Yes,4
Yes,White,2001,32,Female,No,Yes,3
No,White,2000,45,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,3
Yes,White,2002,16,Male,Yes,Yes,0
Yes,Black,1998,32,Male,Yes,Yes,1
Yes,White,1998,17,Male,Yes,Yes,2
Yes,White,1999,46,Female,Yes,No,2
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1998,22,Male,No,Yes,1
Yes,White,2001,21,Male,Yes,Yes,4
Yes,White,1997,27,Male,Yes,No,0
Yes,White,1999,18,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,2000,45,Male,Yes,Yes,0
No,White,2000,16,Male,Yes,Yes,0
Yes,Black,2001,21,Male,No,Yes,3
Yes,White,1998,15,Male,Yes,Yes,2
Yes,White,2001,26,Male,Yes,Yes,0
No,Black,1998,17,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1999,37,Male,No,Yes,1
Yes,Black,1998,18,Male,Yes,Yes,2
Yes,Black,2002,25,Male,Yes,No,2
Yes,Black,1997,20,Male,Yes,No,0
Yes,White,1998,29,Female,Yes,Yes,0
Yes,Black,2001,23,Male,No,Yes,1
Yes,White,2000,20,Male,Yes,Yes,3
Yes,Black,2001,18,Male,Yes,Yes,3
Yes,Black,1997,14,Male,Yes,No,0
Yes,White,2000,28,Male,Yes,Yes,0
No,Black,2000,31,Male,Yes,No,0
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1999,18,Male,Yes,Yes,0
No,Black,1999,15,Male,Yes,Yes,3
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,4
Yes,White,1999,27,Male,Yes,Yes,1
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,2001,33,Male,Yes,Yes,0
No,White,1997,47,Male,Yes,No,1
Yes,White,2001,16,Female,No,Yes,0
Yes,White,2001,24,Male,Yes,Yes,1
Yes,White,2000,41,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2000,22,Male,No,Yes,0
Yes,White,1997,22,Male,No,No,4
Yes,White,1999,54,Male,Yes,Yes,2
Yes,White,2000,15,Male,Yes,Yes,1
No,White,2001,35,Male,No,Yes,4
Yes,White,2000,19,Male,Yes,No,0
Yes,White,1997,31,Male,No,No,4
Yes,White,1999,21,Female,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
Yes,Black,2000,22,Male,Yes,Yes,4
Yes,Black,1997,15,Male,Yes,No,2
Yes,Black,1998,38,Male,Yes,No,1
Yes,White,1997,19,Male,Yes,Yes,3
Yes,Black,2001,17,Male,Yes,Yes,1
No,Black,2001,19,Male,No,Yes,5
Yes,Black,1999,40,Male,No,No,3
Yes,White,2001,21,Male,Yes,Yes,1
Yes,White,2000,26,Male,Yes,Yes,1
Yes,White,1997,18,Male,Yes,No,3
Yes,White,1997,26,Male,Yes,Yes,2
No,Black,2000,17,Male,No,Yes,4
Yes,White,1998,44,Male,Yes,Yes,0
Yes,White,1998,25,Male,No,Yes,0
Yes,Black,2000,18,Male,No,No,4
Yes,White,2002,19,Male,Yes,Yes,0
Yes,White,1999,31,Male,No,Yes,1
Yes,White,2001,26,Female,Yes,Yes,0
Yes,White,2001,35,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,3
Yes,White,2000,16,Male,Yes,Yes,0
Yes,Black,1997,15,Male,Yes,No,5
Yes,White,1997,26,Male,Yes,No,0
Yes,White,2001,20,Male,No,Yes,3
Yes,White,2000,24,Male,Yes,Yes,0
No,White,1999,28,Male,Yes,Yes,3
Yes,White,1999,24,Male,Yes,Yes,2
No,Black,1999,26,Male,No,No,3
Yes,White,1997,30,Male,Yes,No,4
Yes,White,1999,16,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,1
Yes,Black,2001,35,Male,Yes,Yes,1
Yes,Black,2000,26,Male,No,Yes,3
No,White,2000,27,Male,Yes,Yes,3
Yes,White,1997,27,Male,Yes,Yes,2
No,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,42,Male,Yes,Yes,3
Yes,White,1999,37,Male,Yes,Yes,2
Yes,Black,2001,40,Male,Yes,Yes,1
No,Black,1998,17,Male,Yes,Yes,1
No,White,2000,20,Female,Yes,Yes,5
Yes,White,2001,19,Female,Yes,Yes,0
Yes,White,2000,30,Male,No,Yes,1
Yes,White,1998,16,Male,Yes,No,0
Yes,White,1997,19,Male,Yes,No,4
Yes,White,1999,17,Male,No,Yes,4
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1998,14,Male,No,Yes,0
Yes,Black,1998,14,Male,Yes,Yes,3
Yes,White,2001,24,Male,Yes,Yes,0
Yes,Black,1999,19,Male,No,Yes,4
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,2000,27,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,3
Yes,White,1998,20,Male,Yes,Yes,2
Yes,Black,2000,36,Male,Yes,Yes,1
Yes,Black,2001,17,Male,No,Yes,4
No,White,2000,37,Male,Yes,No,1
Yes,Black,2000,32,Male,Yes,Yes,0
Yes,White,2000,15,Male,Yes,Yes,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,5
Yes,White,1998,18,Male,Yes,Yes,2
Yes,Black,2000,23,Male,Yes,No,0
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,1998,16,Male,Yes,Yes,2
No,Black,2000,16,Male,Yes,Yes,3
Yes,White,1998,20,Male,Yes,Yes,1
Yes,White,2001,16,Male,No,Yes,4
No,White,2000,19,Male,No,Yes,4
No,White,2000,19,Male,No,Yes,4
No,White,2000,24,Male,Yes,Yes,5
No,White,1999,19,Female,Yes,Yes,2
No,White,2001,22,Female,No,No,0
No,White,2001,22,Female,No,No,0
No,White,1999,39,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,16,Male,Yes,Yes,2
Yes,Black,2001,18,Male,No,Yes,1
No,White,1998,46,Male,Yes,Yes,4
No,White,2000,20,Male,No,Yes,4
Yes,White,1999,19,Male,Yes,Yes,1
Yes,White,1999,29,Male,Yes,Yes,2
No,White,1998,21,Male,Yes,Yes,0
Yes,White,2001,18,Female,Yes,Yes,2
No,White,2001,22,Male,Yes,Yes,4
Yes,Black,2001,28,Male,Yes,Yes,3
Yes,White,1998,23,Male,Yes,Yes,1
No,White,2001,34,Male,No,Yes,0
Yes,Black,2000,21,Male,No,Yes,2
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,0
Yes,Black,2001,18,Male,Yes,Yes,1
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,1997,22,Male,Yes,No,0
Yes,White,1998,36,Male,Yes,Yes,0
No,White,2000,18,Female,Yes,Yes,0
Yes,White,2001,18,Male,No,Yes,3
Yes,White,1998,25,Male,Yes,Yes,1
No,Black,1998,25,Male,Yes,No,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,34,Male,Yes,Yes,1
Yes,Black,2001,22,Male,No,Yes,3
Yes,White,2002,21,Male,No,Yes,0
Yes,White,2000,23,Male,Yes,Yes,2
Yes,White,2001,21,Female,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,No,0
No,White,1999,33,Male,No,Yes,3
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1999,29,Male,No,No,1
No,Black,1999,18,Male,Yes,Yes,4
Yes,Black,1999,34,Male,No,No,0
Yes,Black,2001,20,Male,Yes,Yes,4
Yes,White,2001,54,Male,Yes,Yes,3
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,1997,20,Male,Yes,No,0
Yes,White,2000,33,Female,No,Yes,4
Yes,White,1999,34,Male,Yes,Yes,4
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,2001,28,Male,Yes,Yes,1
Yes,White,1999,21,Male,Yes,Yes,2
Yes,Black,1998,47,Male,No,No,2
No,White,2001,15,Male,Yes,Yes,3
Yes,White,2002,17,Male,Yes,No,4
Yes,White,2001,38,Male,Yes,Yes,4
Yes,White,1997,30,Male,No,Yes,3
No,White,2002,22,Male,Yes,Yes,4
Yes,White,2001,16,Male,Yes,Yes,2
Yes,White,2002,20,Female,Yes,Yes,0
Yes,Black,2001,14,Male,Yes,Yes,1
Yes,Black,1998,33,Male,Yes,Yes,2
Yes,White,1999,29,Male,No,No,1
Yes,Black,1998,27,Male,Yes,Yes,4
No,White,2002,36,Male,Yes,Yes,3
Yes,Black,2002,24,Male,Yes,Yes,4
Yes,White,2000,18,Male,Yes,Yes,2
Yes,White,2001,19,Female,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,2000,18,Male,No,Yes,0
Yes,White,1999,29,Male,Yes,Yes,1
Yes,White,2001,29,Male,No,Yes,0
Yes,White,1999,22,Male,Yes,Yes,2
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1998,24,Male,Yes,Yes,1
Yes,Black,1999,29,Male,Yes,Yes,0
No,White,1997,29,Female,Yes,Yes,0
Yes,White,1999,34,Male,No,Yes,1
Yes,White,1997,19,Male,Yes,No,2
Yes,White,1997,17,Male,Yes,No,5
Yes,White,2001,37,Male,Yes,Yes,3
Yes,White,1997,16,Female,Yes,No,3
Yes,White,1999,19,Male,Yes,Yes,4
Yes,Black,2000,26,Male,Yes,Yes,1
Yes,White,1998,17,Male,Yes,Yes,0
Yes,Black,2000,23,Male,Yes,Yes,0
Yes,White,1999,15,Male,No,Yes,0
No,Black,1999,22,Male,No,Yes,0
Yes,White,1997,20,Male,Yes,No,1
Yes,Black,2001,31,Male,Yes,No,0
No,Black,2000,20,Male,Yes,Yes,3
Yes,Black,2001,30,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,3
Yes,White,1998,18,Male,No,Yes,2
Yes,White,2000,41,Male,Yes,Yes,2
Yes,Black,1999,15,Male,Yes,Yes,2
Yes,White,1997,29,Male,No,No,4
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,2001,20,Male,Yes,Yes,0
No,White,2000,21,Female,No,Yes,4
Yes,Black,2000,23,Male,Yes,Yes,1
No,Black,2001,21,Male,Yes,No,3
Yes,White,2002,21,Male,Yes,No,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,1999,35,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,3
Yes,Black,1999,28,Male,Yes,No,0
Yes,Black,2000,21,Female,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,1
Yes,White,1999,26,Male,Yes,Yes,0
Yes,Black,1998,26,Male,Yes,No,3
Yes,Black,2001,29,Male,Yes,No,2
No,White,2002,45,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,2
No,White,2001,16,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,3
Yes,White,1999,29,Female,Yes,Yes,1
Yes,White,1998,14,Male,Yes,Yes,3
Yes,White,2000,22,Male,No,Yes,2
Yes,White,2000,23,Male,Yes,Yes,3
Yes,White,1998,25,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,16,Male,Yes,No,0
Yes,Black,2001,26,Male,Yes,Yes,0
No,White,1998,27,Female,Yes,Yes,0
No,White,1999,41,Male,Yes,Yes,3
No,White,1999,41,Male,Yes,Yes,3
Yes,White,1997,36,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,1
Yes,White,1998,14,Male,Yes,Yes,1
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,2
No,White,2001,26,Male,Yes,Yes,1
No,Black,1999,20,Male,No,Yes,3
Yes,Black,1998,21,Male,Yes,Yes,1
No,White,2001,16,Male,Yes,Yes,1
Yes,White,1999,17,Male,Yes,Yes,0
No,White,1997,36,Male,No,Yes,4
Yes,White,1999,19,Male,Yes,Yes,0
No,White,1999,28,Male,Yes,Yes,1
Yes,White,1999,18,Male,Yes,Yes,2
Yes,Black,1998,38,Male,Yes,No,0
Yes,White,2000,20,Female,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,1
Yes,White,1999,20,Male,Yes,Yes,0
No,Black,1998,15,Male,Yes,Yes,4
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,2000,24,Male,Yes,Yes,3
No,Black,1999,18,Male,Yes,Yes,4
Yes,Black,1997,19,Male,Yes,No,2
No,Black,1999,18,Male,No,Yes,4
No,White,2001,19,Male,No,Yes,4
Yes,White,1998,20,Male,Yes,Yes,4
Yes,White,1999,24,Female,Yes,Yes,4
Yes,White,2002,16,Female,Yes,Yes,0
No,White,2001,27,Male,Yes,No,3
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,No,0
Yes,White,2001,64,Male,Yes,No,3
Yes,White,2001,31,Male,No,Yes,1
Yes,White,1998,20,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,1
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,2000,22,Male,Yes,No,1
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2000,19,Male,No,Yes,4
Yes,White,1998,42,Male,Yes,Yes,0
Yes,White,1999,38,Male,Yes,Yes,3
Yes,Black,2001,19,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,2
Yes,Black,1999,31,Male,Yes,Yes,5
Yes,White,1998,22,Male,No,Yes,4
Yes,White,2001,19,Male,No,Yes,2
Yes,White,1997,32,Female,No,Yes,2
Yes,White,2000,20,Male,Yes,No,2
Yes,Black,1998,18,Male,Yes,No,2
Yes,Black,2000,26,Male,No,Yes,2
Yes,Black,2002,27,Male,Yes,Yes,3
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,1999,23,Male,No,Yes,0
Yes,White,1997,18,Male,Yes,No,3
Yes,White,2001,18,Male,No,Yes,3
Yes,White,2000,20,Male,Yes,No,4
Yes,White,2001,20,Male,Yes,Yes,3
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,1997,18,Male,Yes,No,0
Yes,Black,1997,22,Male,No,Yes,1
Yes,Black,2002,20,Male,Yes,Yes,0
Yes,White,2000,17,Male,No,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,2
Yes,Black,1997,47,Male,Yes,No,2
Yes,White,1999,38,Male,Yes,Yes,4
Yes,Black,1999,36,Female,Yes,No,0
No,White,1998,25,Male,Yes,Yes,0
No,White,1999,29,Male,No,Yes,3
No,Black,1999,17,Male,Yes,Yes,0
No,White,2000,15,Male,Yes,Yes,3
Yes,White,2000,25,Male,Yes,Yes,1
Yes,White,1997,18,Male,Yes,Yes,1
Yes,Black,2001,20,Male,No,Yes,0
No,White,2001,29,Male,No,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
No,Black,1999,18,Male,Yes,Yes,0
Yes,White,2000,30,Male,No,Yes,2
Yes,White,2001,23,Male,Yes,Yes,2
Yes,Black,2000,51,Male,No,Yes,4
No,Black,2001,35,Male,Yes,Yes,4
No,White,1999,41,Male,No,Yes,3
Yes,White,2000,18,Male,Yes,Yes,4
Yes,White,1999,26,Male,Yes,Yes,2
Yes,White,2000,22,Male,Yes,Yes,3
Yes,Black,2001,23,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,0
Yes,Black,2001,38,Male,Yes,Yes,3
Yes,White,2000,27,Male,Yes,Yes,2
No,White,1997,22,Male,Yes,No,3
No,White,1999,20,Male,No,Yes,3
Yes,White,1997,51,Male,Yes,No,2
Yes,White,1999,21,Male,No,No,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2000,33,Male,Yes,Yes,3
Yes,White,1998,38,Female,Yes,Yes,0
Yes,Black,2000,33,Male,No,No,4
No,White,2001,19,Male,Yes,Yes,4
No,White,1998,34,Male,No,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1998,37,Male,No,Yes,3
Yes,White,2002,19,Male,No,Yes,0
Yes,White,2001,22,Male,Yes,Yes,3
No,White,2000,17,Male,Yes,Yes,4
Yes,White,1997,21,Male,Yes,No,3
Yes,Black,1999,24,Male,Yes,Yes,2
Yes,White,2001,39,Male,No,Yes,2
Yes,White,2001,14,Male,Yes,Yes,1
Yes,Black,1998,23,Male,Yes,Yes,2
Yes,White,2000,24,Male,Yes,Yes,1
Yes,White,1998,22,Male,Yes,No,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1999,24,Male,Yes,Yes,0
No,Black,1998,25,Male,No,No,4
Yes,White,2000,49,Female,Yes,Yes,0
Yes,White,2001,26,Male,Yes,Yes,0
Yes,Black,2001,18,Male,Yes,Yes,1
Yes,White,1998,18,Male,Yes,Yes,4
Yes,Black,1998,50,Male,Yes,Yes,0
No,White,2001,28,Female,Yes,Yes,3
No,White,2002,17,Female,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,Black,2000,19,Male,No,Yes,2
Yes,Black,2002,18,Male,Yes,Yes,3
No,White,1997,19,Male,No,No,5
Yes,White,1998,17,Female,Yes,Yes,2
No,White,2000,18,Male,Yes,No,3
Yes,White,1998,32,Male,Yes,Yes,3
Yes,Black,2001,51,Male,No,No,3
No,Black,2000,27,Male,Yes,Yes,0
Yes,White,1998,23,Male,Yes,Yes,0
Yes,Black,1999,24,Male,Yes,Yes,3
Yes,Black,1998,17,Male,Yes,No,0
Yes,White,1998,17,Male,Yes,Yes,4
No,Black,2000,19,Female,No,Yes,2
Yes,White,1999,33,Male,Yes,Yes,3
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,3
No,White,1997,19,Male,Yes,No,1
Yes,White,2001,40,Female,No,Yes,3
Yes,White,1997,25,Male,No,No,3
Yes,White,1997,18,Male,No,Yes,2
Yes,White,2000,39,Male,Yes,Yes,1
Yes,White,1998,16,Male,No,Yes,1
Yes,White,1999,25,Female,Yes,Yes,4
Yes,White,2000,30,Male,Yes,Yes,0
Yes,Black,2001,17,Male,Yes,Yes,0
Yes,Black,2001,16,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,1997,33,Male,Yes,No,3
No,Black,2001,22,Female,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,2000,38,Male,No,Yes,1
Yes,White,1999,31,Female,Yes,Yes,1
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,4
Yes,White,1997,16,Male,Yes,Yes,0
Yes,White,1999,19,Male,No,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,Yes,3
Yes,Black,2002,18,Male,Yes,No,3
Yes,White,2002,51,Male,No,Yes,0
Yes,White,2001,45,Male,Yes,Yes,3
Yes,White,1998,19,Male,Yes,Yes,5
Yes,White,2002,19,Male,Yes,Yes,3
Yes,White,1998,32,Male,No,Yes,2
Yes,White,1997,21,Male,Yes,Yes,2
Yes,White,2002,26,Male,Yes,Yes,0
Yes,White,2002,15,Male,Yes,Yes,2
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,2
No,White,2000,18,Male,Yes,No,0
No,White,2000,19,Male,Yes,Yes,0
Yes,White,2000,20,Male,No,Yes,0
Yes,Black,2000,22,Male,No,No,3
Yes,White,2001,20,Female,Yes,Yes,0
Yes,White,1998,19,Male,No,Yes,4
Yes,Black,2000,28,Male,Yes,Yes,2
Yes,White,2001,34,Male,Yes,Yes,0
Yes,White,2001,16,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1998,39,Female,Yes,Yes,1
No,Black,2001,22,Male,No,No,4
Yes,White,2002,41,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,3
Yes,White,2002,20,Female,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,2001,26,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,2
No,Black,2002,36,Male,Yes,Yes,3
Yes,White,2001,18,Male,No,Yes,1
Yes,White,1999,19,Male,No,Yes,0
Yes,White,2001,23,Male,Yes,Yes,2
Yes,White,1998,20,Female,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,40,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,0
Yes,Black,2001,16,Female,Yes,Yes,0
Yes,Black,2000,66,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,1
Yes,White,1998,24,Male,Yes,No,1
Yes,White,2000,16,Female,Yes,Yes,5
Yes,White,1999,32,Male,Yes,Yes,4
Yes,White,2000,24,Male,Yes,No,3
Yes,Black,1998,38,Female,No,Yes,1
Yes,Black,2000,20,Male,No,Yes,4
Yes,White,1999,22,Male,Yes,Yes,2
No,Black,2000,66,Male,Yes,Yes,2
Yes,White,1998,24,Male,Yes,Yes,0
Yes,White,2001,21,Male,No,Yes,2
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1998,17,Female,Yes,Yes,3
Yes,White,1998,17,Male,No,Yes,2
No,White,2000,21,Male,Yes,Yes,4
Yes,White,2000,21,Male,Yes,Yes,3
Yes,White,2001,59,Male,Yes,Yes,3
Yes,White,1998,25,Male,Yes,Yes,0
Yes,White,1998,45,Male,Yes,Yes,0
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1998,22,Male,No,Yes,3
Yes,Black,2001,23,Male,Yes,Yes,1
Yes,White,1998,17,Male,Yes,Yes,0
Yes,Black,1999,30,Male,Yes,No,6
Yes,Black,2000,18,Male,Yes,Yes,4
Yes,White,2000,44,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,1
Yes,Black,2000,34,Male,No,Yes,3
Yes,Black,1999,39,Male,Yes,Yes,0
No,White,1998,21,Male,No,Yes,3
No,White,2001,16,Male,Yes,Yes,3
No,Black,1999,30,Male,Yes,Yes,4
No,Black,1999,39,Male,No,Yes,5
No,Black,1997,16,Male,No,No,4
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,2001,19,Male,No,No,1
Yes,White,2000,23,Male,Yes,Yes,3
Yes,White,1998,39,Male,Yes,Yes,2
Yes,Black,1999,23,Male,Yes,No,4
Yes,White,1997,16,Male,No,Yes,3
Yes,White,2001,20,Male,No,Yes,2
Yes,Black,2000,22,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2000,21,Male,No,Yes,3
Yes,White,1999,28,Male,Yes,Yes,0
Yes,White,1998,26,Male,Yes,Yes,4
No,Black,1999,30,Male,Yes,Yes,1
Yes,Black,2002,21,Male,No,Yes,1
Yes,Black,1999,19,Female,Yes,Yes,2
Yes,White,1999,37,Male,No,Yes,4
Yes,White,1999,16,Male,Yes,Yes,0
Yes,White,1997,20,Male,No,Yes,3
No,White,2000,17,Male,Yes,Yes,5
Yes,White,2000,39,Male,Yes,Yes,4
Yes,White,2000,26,Male,Yes,Yes,3
No,White,2000,34,Male,Yes,No,0
Yes,White,2000,38,Male,No,Yes,3
Yes,White,2001,34,Male,No,Yes,4
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,2001,25,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,2
Yes,Black,2001,14,Male,Yes,Yes,1
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,2001,53,Female,Yes,Yes,0
Yes,Black,1998,28,Male,No,No,1
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,34,Male,Yes,Yes,2
No,Black,2000,41,Male,Yes,Yes,3
Yes,White,1997,19,Male,Yes,No,2
Yes,Black,2000,18,Male,Yes,Yes,4
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,1998,31,Male,Yes,Yes,3
No,White,2000,36,Male,Yes,Yes,3
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,2000,18,Female,Yes,Yes,1
Yes,White,2000,38,Male,No,Yes,4
Yes,Black,2000,41,Male,No,No,3
Yes,White,2002,41,Male,Yes,Yes,0
Yes,White,1999,28,Male,Yes,Yes,0
No,Black,1998,28,Male,No,No,3
Yes,Black,1999,27,Male,Yes,Yes,4
Yes,White,1999,38,Male,Yes,Yes,2
Yes,White,1998,18,Male,Yes,Yes,0
No,Black,1999,27,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,1999,46,Male,Yes,Yes,2
Yes,Black,1997,19,Male,Yes,No,0
Yes,White,1998,21,Male,Yes,Yes,1
Yes,Black,2002,15,Male,No,Yes,0
Yes,White,2001,36,Male,Yes,No,1
No,White,2000,20,Male,No,Yes,4
Yes,Black,1999,24,Male,Yes,No,2
Yes,Black,2000,54,Male,Yes,No,0
Yes,Black,2001,17,Male,Yes,Yes,4
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,1999,18,Male,No,No,0
Yes,White,1999,27,Male,Yes,Yes,3
No,White,2001,38,Male,Yes,Yes,3
Yes,Black,2001,25,Male,Yes,Yes,0
Yes,White,1997,21,Male,No,Yes,3
Yes,White,1998,19,Female,Yes,Yes,1
Yes,White,1998,33,Male,Yes,Yes,0
Yes,Black,2000,24,Male,No,Yes,4
Yes,Black,2000,20,Male,Yes,Yes,0
Yes,White,2000,22,Male,No,Yes,4
Yes,White,1997,18,Male,Yes,Yes,0
No,White,2001,19,Male,Yes,Yes,1
Yes,Black,2001,18,Male,Yes,No,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,2002,18,Male,Yes,Yes,0
Yes,Black,2001,31,Male,Yes,No,4
Yes,White,2000,14,Male,Yes,Yes,3
Yes,White,1997,19,Male,Yes,Yes,0
Yes,White,2001,22,Male,No,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,1998,20,Male,Yes,Yes,2
No,White,2001,17,Male,No,Yes,0
Yes,White,2001,14,Male,Yes,Yes,1
Yes,White,2002,22,Male,No,Yes,4
Yes,Black,2001,15,Male,Yes,Yes,1
Yes,White,2001,43,Female,No,Yes,4
Yes,White,2000,21,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,28,Male,Yes,Yes,0
Yes,White,2000,14,Male,Yes,Yes,1
Yes,Black,1999,24,Male,No,No,2
Yes,White,1999,28,Female,No,Yes,0
Yes,White,1998,16,Male,Yes,Yes,4
Yes,White,1999,20,Male,Yes,Yes,2
Yes,White,2001,28,Male,Yes,Yes,2
Yes,Black,1998,20,Male,Yes,Yes,2
Yes,White,1997,23,Male,Yes,No,4
Yes,Black,2001,42,Male,No,Yes,4
Yes,White,2001,17,Male,Yes,Yes,0
No,White,2000,17,Male,No,Yes,3
Yes,White,2000,24,Male,Yes,Yes,1
Yes,White,1998,18,Male,Yes,Yes,4
No,Black,2001,20,Male,Yes,No,0
Yes,White,2001,45,Male,Yes,Yes,1
Yes,White,1999,45,Male,Yes,Yes,0
Yes,White,2002,20,Male,Yes,Yes,0
No,White,2001,19,Male,Yes,Yes,5
Yes,Black,1999,19,Male,No,Yes,2
Yes,Black,1997,39,Male,No,No,4
No,White,1999,33,Male,Yes,Yes,0
Yes,Black,2002,23,Male,Yes,Yes,4
Yes,White,1999,18,Male,No,Yes,0
Yes,White,2001,15,Male,Yes,Yes,1
Yes,Black,2000,36,Male,Yes,Yes,3
Yes,White,2002,28,Male,Yes,Yes,1
Yes,White,1999,37,Male,Yes,Yes,2
Yes,White,1997,22,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,0
Yes,White,2001,26,Female,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,2002,20,Male,Yes,Yes,4
Yes,Black,2000,17,Male,Yes,Yes,4
Yes,White,1999,21,Male,Yes,Yes,1
No,Black,2000,15,Male,Yes,Yes,0
No,White,2000,15,Male,No,Yes,1
Yes,White,1997,20,Male,No,Yes,3
No,White,2000,50,Male,Yes,Yes,3
No,White,1997,19,Male,Yes,No,1
Yes,White,2001,22,Male,Yes,Yes,0
Yes,Black,1998,44,Male,Yes,Yes,3
Yes,Black,2000,18,Male,No,No,5
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,2001,34,Male,Yes,Yes,3
Yes,White,2001,21,Male,No,Yes,4
No,White,1999,16,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,4
Yes,White,1998,41,Female,Yes,Yes,0
No,White,2000,21,Male,Yes,Yes,4
Yes,White,1999,43,Female,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,1997,21,Male,Yes,No,5
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,2000,21,Female,No,Yes,4
Yes,White,1998,39,Male,Yes,Yes,3
No,Black,2000,21,Male,Yes,Yes,3
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,2000,18,Female,Yes,Yes,0
Yes,Black,2001,20,Male,Yes,Yes,3
Yes,White,2002,16,Male,Yes,Yes,0
Yes,White,2000,45,Male,Yes,Yes,3
Yes,Black,2001,31,Male,Yes,Yes,3
Yes,White,2001,27,Female,Yes,Yes,0
Yes,White,1999,20,Male,No,Yes,2
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,No,0
No,White,2001,36,Male,No,Yes,3
Yes,White,1997,17,Male,Yes,Yes,0
Yes,White,1997,28,Male,Yes,No,0
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,2000,17,Male,No,Yes,0
Yes,Black,2001,18,Male,No,Yes,2
Yes,White,1998,21,Male,Yes,Yes,3
Yes,White,2001,38,Male,No,Yes,2
No,White,1998,20,Male,Yes,Yes,3
Yes,White,2001,17,Male,Yes,Yes,0
No,Black,1997,23,Male,No,No,4
No,White,2001,18,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,1998,30,Male,Yes,Yes,2
Yes,White,1998,36,Female,Yes,Yes,0
Yes,White,1999,35,Male,Yes,Yes,0
Yes,White,1998,14,Male,Yes,Yes,2
Yes,Black,1999,19,Female,Yes,No,1
No,White,2001,27,Male,Yes,Yes,1
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,2001,32,Female,No,Yes,0
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,2000,22,Female,Yes,Yes,0
Yes,White,2000,48,Male,Yes,Yes,1
No,White,1999,33,Male,Yes,Yes,3
Yes,Black,2001,18,Male,Yes,Yes,2
No,White,2001,17,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
No,White,1997,18,Male,Yes,Yes,0
No,White,2001,40,Male,No,Yes,3
Yes,Black,2001,22,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,1
Yes,Black,2000,24,Male,Yes,Yes,4
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,1997,21,Male,No,Yes,0
Yes,White,2000,15,Male,Yes,No,0
No,White,1998,20,Male,No,Yes,4
Yes,White,1998,19,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,3
Yes,Black,2002,21,Male,No,Yes,3
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,2000,43,Male,Yes,Yes,3
Yes,White,2000,21,Male,No,Yes,0
No,Black,1997,19,Male,Yes,Yes,3
Yes,White,1998,17,Male,No,Yes,3
Yes,White,1999,37,Male,Yes,Yes,0
No,White,2000,15,Male,Yes,Yes,1
Yes,White,1997,23,Male,Yes,No,0
Yes,White,2000,33,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,No,0
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,1997,23,Male,Yes,No,1
Yes,Black,1998,16,Male,Yes,Yes,4
Yes,White,1999,43,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1999,26,Male,Yes,Yes,1
Yes,Black,1998,19,Male,Yes,Yes,2
Yes,White,1998,25,Female,Yes,Yes,0
No,Black,1999,17,Male,Yes,No,1
No,Black,1999,15,Male,No,Yes,1
Yes,White,1999,17,Female,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,0
Yes,Black,2002,38,Male,Yes,No,1
No,White,1997,16,Male,Yes,No,2
No,Black,1997,24,Male,No,No,2
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,2001,21,Male,Yes,Yes,2
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,2001,32,Male,No,Yes,4
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,2001,30,Male,Yes,No,0
Yes,White,1999,18,Male,Yes,Yes,4
Yes,White,1998,39,Male,Yes,Yes,2
Yes,White,2001,24,Male,Yes,Yes,0
No,Black,1998,35,Male,No,Yes,4
Yes,Black,2000,18,Male,Yes,Yes,1
No,Black,1997,17,Male,Yes,No,0
Yes,White,2002,26,Male,Yes,Yes,0
Yes,Black,1999,51,Male,No,No,4
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,1998,26,Male,No,Yes,3
Yes,White,1998,14,Female,Yes,Yes,0
Yes,Black,1999,21,Male,No,No,4
Yes,White,2002,16,Male,Yes,Yes,2
Yes,White,2001,16,Male,Yes,Yes,1
Yes,Black,1999,18,Male,Yes,Yes,2
No,Black,2000,26,Male,Yes,No,3
Yes,White,2001,26,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,1998,28,Male,Yes,Yes,3
Yes,White,1999,28,Male,Yes,Yes,0
Yes,White,1998,20,Male,Yes,Yes,0
Yes,Black,2002,18,Male,Yes,Yes,0
Yes,Black,2002,16,Male,Yes,No,0
Yes,White,2002,19,Male,Yes,Yes,2
Yes,White,2001,25,Female,No,Yes,1
Yes,White,1997,18,Male,Yes,No,4
Yes,Black,2002,16,Male,Yes,Yes,1
Yes,White,1999,21,Male,No,Yes,1
Yes,White,2002,36,Male,Yes,Yes,3
Yes,White,1997,21,Female,Yes,Yes,0
Yes,White,1997,32,Male,No,Yes,3
Yes,White,1998,17,Male,Yes,Yes,0
No,White,2001,14,Male,Yes,Yes,0
No,White,2001,21,Male,Yes,Yes,4
Yes,White,2000,18,Male,Yes,Yes,0
Yes,Black,2002,19,Male,Yes,Yes,1
Yes,White,1998,18,Male,Yes,Yes,4
Yes,Black,2001,19,Male,No,Yes,3
Yes,Black,2000,20,Male,Yes,Yes,2
No,White,1999,18,Male,Yes,Yes,3
Yes,Black,1997,29,Female,No,No,1
Yes,White,1999,30,Male,Yes,Yes,0
Yes,Black,2000,20,Male,Yes,No,0
Yes,White,2000,20,Male,Yes,Yes,3
Yes,Black,1997,18,Male,Yes,No,3
Yes,White,2000,36,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,0
Yes,Black,1998,18,Male,Yes,Yes,2
No,White,2001,15,Male,No,Yes,3
Yes,Black,1999,16,Male,Yes,Yes,3
Yes,Black,1999,19,Male,Yes,Yes,2
Yes,Black,2002,29,Male,Yes,No,3
Yes,Black,1998,22,Male,Yes,No,0
Yes,White,1997,41,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,46,Male,Yes,Yes,2
Yes,White,2000,20,Female,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,29,Male,Yes,No,0
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1999,28,Female,Yes,Yes,0
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,Black,2001,16,Male,Yes,Yes,4
Yes,Black,2000,27,Male,Yes,Yes,3
Yes,White,1998,24,Male,Yes,Yes,0
Yes,White,1998,15,Female,Yes,Yes,0
No,Black,1998,20,Male,No,Yes,1
Yes,White,2001,28,Male,No,Yes,1
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,1997,24,Male,Yes,No,0
Yes,White,2001,23,Male,Yes,Yes,0
Yes,Black,1999,21,Male,Yes,Yes,1
No,Black,1997,32,Male,No,No,0
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,1999,16,Female,Yes,Yes,2
Yes,White,1999,19,Male,Yes,Yes,3
Yes,White,2000,39,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,31,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1999,18,Male,No,Yes,4
Yes,Black,2001,24,Male,No,No,1
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1999,28,Male,Yes,Yes,0
No,Black,2000,19,Male,Yes,Yes,3
No,Black,2001,42,Male,No,Yes,3
Yes,Black,2000,36,Male,No,No,3
Yes,White,2002,25,Male,No,Yes,1
Yes,White,1998,15,Male,Yes,No,2
Yes,White,1997,27,Male,Yes,Yes,2
Yes,White,2000,24,Male,Yes,Yes,1
No,White,1997,39,Male,Yes,Yes,2
Yes,White,2001,36,Male,No,Yes,3
Yes,White,2000,21,Male,No,Yes,4
No,Black,1998,19,Female,No,Yes,2
Yes,White,1998,21,Female,Yes,Yes,3
Yes,White,2001,24,Male,Yes,Yes,3
Yes,White,1999,18,Male,Yes,Yes,0
Yes,Black,1997,22,Male,Yes,No,4
No,White,2001,23,Male,Yes,Yes,2
Yes,White,2001,33,Female,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1999,35,Male,Yes,Yes,4
Yes,White,2001,21,Female,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2000,33,Male,Yes,Yes,0
Yes,Black,2001,24,Male,Yes,Yes,0
Yes,Black,2000,18,Male,Yes,No,0
Yes,Black,1998,26,Male,No,Yes,5
Yes,Black,1999,19,Male,No,Yes,5
Yes,White,2001,24,Female,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2001,21,Male,No,Yes,0
Yes,White,2000,23,Male,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,No,0
Yes,White,2002,20,Male,Yes,Yes,0
Yes,Black,2002,36,Male,Yes,Yes,2
Yes,White,2000,19,Female,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,3
Yes,White,2000,33,Male,Yes,Yes,0
No,White,1999,13,Male,Yes,Yes,0
Yes,White,2000,16,Female,Yes,Yes,0
Yes,White,1998,24,Male,Yes,Yes,2
Yes,White,2001,19,Female,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1998,22,Female,No,Yes,3
No,White,2000,21,Male,No,Yes,5
Yes,White,1999,24,Male,Yes,Yes,0
No,White,1999,37,Male,Yes,Yes,3
No,White,1998,16,Male,Yes,Yes,0
No,White,2001,45,Male,Yes,Yes,2
Yes,Black,2001,20,Male,No,Yes,0
Yes,White,1998,39,Male,No,Yes,3
No,White,2000,16,Female,No,Yes,3
Yes,White,1998,18,Male,No,Yes,4
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,1999,19,Male,No,Yes,0
No,White,2001,31,Male,No,Yes,3
No,White,1998,17,Male,Yes,Yes,0
Yes,Black,1999,31,Male,Yes,No,2
Yes,White,1997,15,Male,Yes,Yes,0
No,White,1999,18,Male,No,Yes,4
Yes,Black,2001,22,Male,No,Yes,3
No,Black,1999,19,Male,No,No,0
Yes,White,2000,24,Male,Yes,Yes,0
Yes,Black,2001,23,Male,Yes,Yes,0
No,Black,1998,24,Female,Yes,Yes,0
Yes,White,2001,21,Male,No,Yes,1
Yes,White,2000,28,Male,No,Yes,0
Yes,White,2001,44,Male,No,Yes,2
Yes,White,1997,18,Male,No,No,0
Yes,White,1998,19,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,3
Yes,White,2000,19,Male,No,Yes,0
Yes,Black,2001,20,Male,Yes,Yes,3
Yes,Black,2000,25,Male,Yes,No,1
Yes,White,2000,34,Male,Yes,Yes,4
No,Black,1999,28,Male,Yes,Yes,2
Yes,Black,2000,22,Male,Yes,Yes,2
Yes,Black,2000,25,Male,Yes,Yes,2
Yes,Black,2001,34,Male,No,Yes,3
Yes,White,2001,20,Male,Yes,Yes,4
Yes,White,1998,23,Male,Yes,Yes,1
Yes,White,2000,17,Male,No,Yes,0
No,White,2001,19,Male,Yes,Yes,3
Yes,White,1998,21,Male,Yes,No,0
No,White,2001,17,Male,Yes,Yes,3
No,Black,1999,48,Male,No,No,1
No,Black,1999,48,Male,No,No,1
Yes,White,2001,33,Male,Yes,Yes,1
Yes,White,1999,16,Male,No,Yes,4
No,Black,1998,16,Male,No,Yes,1
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,2
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2001,26,Male,Yes,Yes,1
Yes,White,2001,24,Male,Yes,Yes,0
Yes,Black,1997,26,Male,Yes,Yes,2
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,5
No,Black,2000,22,Male,Yes,Yes,3
Yes,White,1997,37,Male,Yes,No,4
Yes,Black,2000,19,Male,Yes,No,0
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,1999,30,Female,Yes,Yes,1
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,5
Yes,White,1999,18,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,1999,22,Male,No,Yes,3
Yes,White,1999,25,Male,Yes,Yes,4
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2000,15,Male,No,Yes,0
Yes,White,2001,17,Female,Yes,Yes,0
Yes,White,2000,29,Female,No,Yes,0
Yes,White,1999,15,Male,Yes,Yes,5
Yes,White,2000,22,Male,Yes,Yes,1
No,Black,2000,18,Male,No,No,2
No,Black,2002,23,Male,Yes,No,4
Yes,White,2000,23,Male,Yes,Yes,2
Yes,Black,1998,43,Male,Yes,Yes,2
No,White,1998,16,Male,Yes,Yes,4
No,White,2001,24,Male,No,No,3
Yes,White,1999,14,Male,Yes,Yes,4
No,White,2000,15,Male,Yes,Yes,5
Yes,Black,1999,13,Male,Yes,Yes,0
Yes,Black,1998,18,Male,No,No,3
Yes,White,2000,14,Male,Yes,Yes,0
No,White,1999,13,Male,No,Yes,5
Yes,White,1999,19,Female,Yes,Yes,1
Yes,White,2001,30,Female,Yes,Yes,0
Yes,White,2002,19,Male,No,No,1
Yes,White,1999,22,Male,Yes,Yes,2
Yes,Black,1999,24,Male,No,Yes,3
No,White,1999,39,Male,Yes,Yes,4
Yes,White,1997,18,Male,Yes,No,4
Yes,Black,1998,28,Male,Yes,Yes,2
Yes,Black,2000,30,Male,Yes,Yes,4
Yes,White,2001,37,Male,Yes,No,1
Yes,White,2001,18,Male,No,Yes,2
No,White,2000,34,Male,Yes,Yes,5
Yes,White,1999,22,Male,No,Yes,5
No,White,2001,18,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2001,26,Male,Yes,Yes,0
Yes,White,2000,16,Female,Yes,Yes,3
Yes,White,2001,13,Male,Yes,Yes,1
Yes,White,2001,17,Female,Yes,Yes,1
No,White,1999,18,Male,Yes,Yes,1
Yes,Black,2000,17,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,1
Yes,Black,2001,16,Male,Yes,Yes,1
Yes,White,1998,22,Male,No,Yes,0
Yes,White,2001,20,Male,Yes,No,0
Yes,Black,2000,33,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,1997,15,Male,Yes,No,3
Yes,White,2001,26,Male,No,Yes,0
Yes,Black,2001,19,Male,Yes,Yes,2
Yes,White,2000,27,Male,Yes,Yes,3
Yes,White,2001,33,Male,No,Yes,3
No,White,2001,18,Male,No,Yes,2
Yes,White,2001,24,Male,No,Yes,1
Yes,Black,1999,41,Male,Yes,No,2
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,2002,21,Male,Yes,Yes,0
Yes,Black,1998,21,Male,No,Yes,4
No,White,2001,31,Male,Yes,Yes,4
Yes,White,2001,27,Male,Yes,Yes,3
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,1998,17,Male,Yes,Yes,3
Yes,Black,2002,26,Male,Yes,Yes,3
Yes,Black,1997,13,Male,Yes,No,2
No,Black,1999,26,Male,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2000,20,Male,Yes,Yes,1
Yes,Black,2002,24,Male,No,Yes,3
Yes,White,1999,29,Male,Yes,Yes,0
Yes,White,2000,16,Female,Yes,Yes,0
Yes,White,2000,15,Male,Yes,Yes,1
Yes,White,2001,27,Male,No,Yes,4
Yes,Black,2000,40,Male,No,Yes,3
Yes,White,1999,21,Female,Yes,Yes,1
No,Black,1997,21,Male,No,No,2
Yes,Black,1998,15,Male,Yes,Yes,0
No,Black,1998,25,Male,No,Yes,1
No,Black,2002,19,Male,No,Yes,5
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,2
Yes,White,1997,28,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,3
Yes,White,2000,16,Male,Yes,Yes,0
No,White,2000,16,Male,No,Yes,2
Yes,White,2000,16,Male,Yes,Yes,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,1
Yes,Black,2001,32,Male,No,Yes,2
Yes,White,1997,15,Male,Yes,No,1
Yes,White,1999,17,Male,Yes,Yes,4
Yes,White,2001,30,Male,No,Yes,2
Yes,White,1998,49,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,0
No,White,2000,38,Male,Yes,Yes,3
No,Black,2001,13,Male,Yes,Yes,2
Yes,Black,2000,40,Male,Yes,No,2
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,2002,14,Female,Yes,Yes,3
Yes,White,2001,21,Female,Yes,Yes,0
Yes,Black,1998,21,Male,Yes,No,0
Yes,Black,1998,33,Male,Yes,Yes,1
Yes,White,1997,16,Male,Yes,No,0
Yes,Black,1997,19,Male,Yes,No,4
Yes,White,1997,29,Male,Yes,Yes,3
No,White,1998,20,Male,No,Yes,1
Yes,White,1999,24,Male,Yes,Yes,1
Yes,White,1998,19,Male,Yes,Yes,3
No,White,1999,32,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,4
Yes,White,2002,19,Male,No,Yes,2
Yes,White,1999,34,Male,Yes,Yes,2
Yes,White,2000,25,Male,No,Yes,1
Yes,White,2000,18,Male,Yes,Yes,0
No,White,1998,18,Male,Yes,Yes,4
Yes,White,1998,38,Male,Yes,Yes,3
Yes,Black,1999,30,Male,Yes,No,4
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2001,44,Female,No,Yes,1
Yes,White,1999,35,Male,Yes,No,0
Yes,White,1998,49,Male,No,Yes,3
Yes,Black,2001,19,Male,No,Yes,3
Yes,Black,1997,20,Male,Yes,No,3
Yes,Black,1997,28,Male,Yes,No,4
Yes,White,2001,20,Male,Yes,Yes,1
Yes,Black,2002,24,Male,Yes,Yes,4
Yes,Black,2000,18,Male,Yes,Yes,0
Yes,White,2000,29,Male,Yes,Yes,1
No,White,1999,23,Male,No,Yes,3
No,White,2000,16,Male,Yes,Yes,0
Yes,Black,2002,20,Male,No,Yes,3
No,White,1997,21,Male,No,No,2
Yes,Black,2001,31,Male,Yes,Yes,2
No,White,2000,24,Male,No,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
No,White,2001,16,Male,No,Yes,1
No,White,2000,18,Male,No,Yes,5
Yes,White,2000,17,Male,Yes,Yes,0
No,White,1998,20,Male,Yes,Yes,3
Yes,White,1997,17,Male,Yes,No,2
Yes,White,2000,19,Female,No,Yes,4
No,White,2000,21,Male,Yes,No,4
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,1999,26,Male,No,Yes,4
No,White,2000,19,Male,Yes,Yes,4
Yes,White,1998,20,Male,Yes,No,5
Yes,White,1998,18,Male,Yes,Yes,0
Yes,Black,2001,39,Male,No,No,3
Yes,White,1998,29,Male,Yes,Yes,2
Yes,White,1999,19,Male,No,Yes,1
Yes,White,1999,34,Male,No,Yes,2
Yes,Black,1999,28,Male,Yes,Yes,4
No,Black,2001,30,Male,Yes,No,0
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1999,36,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,1999,36,Male,Yes,Yes,1
Yes,White,1998,18,Male,No,Yes,0
Yes,Black,2001,40,Male,Yes,No,4
Yes,White,2000,19,Male,No,Yes,4
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,0
No,White,1998,19,Male,Yes,Yes,3
Yes,White,1999,30,Male,Yes,Yes,3
No,Black,2000,29,Male,No,No,5
Yes,White,2002,21,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,4
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,1997,27,Male,Yes,Yes,0
Yes,White,2002,29,Male,No,Yes,3
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,2001,21,Male,No,Yes,4
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,1997,44,Male,No,Yes,3
No,White,1997,27,Male,No,Yes,3
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2000,36,Male,Yes,Yes,3
No,Black,2001,37,Male,Yes,No,3
No,Black,1998,19,Female,Yes,Yes,0
Yes,White,2001,28,Male,Yes,Yes,0
Yes,Black,2000,38,Male,Yes,Yes,1
No,White,1999,15,Male,Yes,No,0
No,White,1999,15,Male,Yes,No,0
No,White,1999,18,Male,Yes,No,3
Yes,Black,2001,19,Male,Yes,Yes,1
Yes,White,1999,20,Male,Yes,Yes,1
Yes,White,1998,14,Male,Yes,Yes,0
No,White,2000,15,Male,Yes,Yes,3
Yes,White,1998,45,Female,No,Yes,0
Yes,White,1999,17,Female,Yes,Yes,0
Yes,Black,2000,24,Male,Yes,No,4
Yes,White,2001,27,Female,No,Yes,2
Yes,White,1999,31,Male,Yes,Yes,0
No,White,1997,21,Male,No,No,3
Yes,White,2002,31,Male,Yes,Yes,2
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,0
No,White,2000,33,Male,Yes,Yes,3
Yes,White,1999,31,Male,Yes,Yes,4
Yes,White,1997,17,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2000,16,Male,Yes,Yes,0
Yes,Black,2000,26,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,1
Yes,Black,2001,22,Male,Yes,Yes,2
No,White,1999,15,Male,Yes,Yes,4
No,Black,1997,27,Male,No,No,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,Black,1997,20,Male,Yes,No,1
Yes,Black,2000,21,Male,Yes,Yes,4
No,Black,2001,34,Male,Yes,No,3
Yes,White,2001,22,Male,Yes,No,0
No,Black,1999,16,Male,No,Yes,3
Yes,Black,2000,18,Male,Yes,Yes,0
Yes,Black,2000,18,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,No,4
Yes,White,1998,22,Male,Yes,Yes,1
No,White,1999,17,Female,No,Yes,2
Yes,Black,2001,32,Male,Yes,No,3
Yes,White,2001,26,Male,Yes,Yes,0
No,Black,2002,24,Male,Yes,Yes,3
No,White,2002,26,Male,No,Yes,1
Yes,White,1998,26,Male,Yes,Yes,1
Yes,Black,2002,14,Male,Yes,Yes,4
No,White,2000,33,Male,No,Yes,5
Yes,Black,2001,18,Male,Yes,Yes,5
No,White,2001,45,Male,Yes,Yes,3
Yes,White,1999,33,Male,Yes,Yes,2
No,Black,1998,41,Male,No,No,4
No,Black,1998,24,Male,Yes,No,4
Yes,White,2001,37,Male,Yes,Yes,2
Yes,White,2000,18,Male,No,Yes,5
Yes,White,1997,32,Male,Yes,No,0
Yes,Black,2000,22,Male,Yes,Yes,3
Yes,White,2000,30,Female,Yes,No,1
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2001,18,Male,No,Yes,1
Yes,White,2000,23,Male,No,Yes,5
Yes,Black,1999,19,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1998,21,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,Yes,0
No,White,1998,18,Male,Yes,Yes,2
Yes,Black,1998,23,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,2001,23,Male,No,Yes,2
No,Black,2002,18,Male,Yes,Yes,4
Yes,White,2000,19,Male,No,Yes,2
No,White,1999,17,Female,No,Yes,2
Yes,White,1999,22,Male,Yes,Yes,0
Yes,Black,1998,26,Male,Yes,No,2
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
No,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,20,Male,No,Yes,1
Yes,White,1998,16,Male,No,Yes,1
Yes,Black,2001,18,Male,No,Yes,3
Yes,White,1997,22,Male,No,Yes,2
Yes,White,1999,17,Male,Yes,Yes,1
Yes,Black,2001,20,Male,Yes,Yes,2
Yes,White,1997,15,Male,Yes,No,0
Yes,White,2001,30,Male,Yes,Yes,0
No,White,2001,21,Male,Yes,Yes,2
Yes,White,2001,29,Female,No,No,0
Yes,Black,2001,41,Male,No,No,3
Yes,Black,1999,21,Male,Yes,Yes,4
Yes,White,1998,36,Female,Yes,Yes,1
Yes,White,2000,16,Male,Yes,Yes,4
Yes,White,1999,19,Male,Yes,Yes,4
Yes,White,1999,25,Male,Yes,Yes,1
Yes,White,1997,16,Male,No,Yes,0
Yes,White,2000,31,Female,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,3
Yes,White,2001,22,Female,Yes,Yes,0
Yes,White,2000,30,Male,Yes,Yes,3
Yes,White,2000,19,Male,Yes,Yes,1
No,Black,1999,26,Male,Yes,Yes,4
Yes,White,2001,26,Male,No,Yes,1
Yes,White,2000,34,Male,No,Yes,3
Yes,White,2001,24,Male,No,Yes,2
Yes,White,1997,20,Male,Yes,Yes,0
Yes,White,2002,14,Male,Yes,Yes,0
Yes,White,1998,26,Male,Yes,Yes,3
Yes,White,1999,16,Female,Yes,Yes,1
Yes,White,1998,25,Male,Yes,Yes,3
Yes,Black,1999,21,Male,Yes,Yes,1
Yes,Black,2001,19,Male,Yes,Yes,0
No,White,1998,21,Male,No,Yes,4
Yes,White,2000,33,Female,Yes,Yes,0
Yes,White,2001,30,Male,No,Yes,4
Yes,Black,1998,37,Male,Yes,Yes,3
Yes,White,1998,33,Male,Yes,Yes,3
Yes,White,1998,34,Male,Yes,Yes,2
No,White,1999,29,Male,No,Yes,1
Yes,White,1998,34,Male,Yes,Yes,3
No,White,2002,20,Male,No,Yes,3
Yes,Black,1997,17,Male,Yes,Yes,5
No,White,2001,47,Female,No,Yes,3
Yes,White,1999,15,Female,Yes,Yes,0
No,White,2001,20,Male,No,Yes,3
Yes,White,2002,25,Male,Yes,No,0
Yes,White,1997,18,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2001,40,Male,Yes,Yes,2
No,Black,2000,40,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,Black,2001,33,Male,Yes,No,0
Yes,White,1999,23,Male,Yes,Yes,0
No,White,2000,24,Male,Yes,Yes,3
Yes,Black,1998,34,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,No,1
No,Black,1997,22,Male,No,Yes,3
Yes,Black,2000,30,Male,No,No,0
No,Black,1998,18,Male,No,No,4
Yes,White,2000,24,Male,Yes,Yes,0
Yes,Black,1997,27,Male,No,Yes,5
Yes,White,1999,47,Male,Yes,Yes,0
Yes,White,1999,33,Male,Yes,Yes,4
Yes,Black,1998,37,Male,Yes,Yes,2
Yes,Black,2001,33,Male,Yes,No,1
Yes,White,1998,22,Male,Yes,Yes,4
No,White,2001,32,Male,Yes,Yes,1
Yes,Black,2001,17,Male,Yes,Yes,2
Yes,White,2000,20,Male,Yes,Yes,4
Yes,White,2000,16,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,0
No,Black,1999,19,Male,Yes,Yes,4
Yes,White,2000,17,Female,No,Yes,5
Yes,White,1998,39,Male,Yes,Yes,0
Yes,White,1999,20,Male,No,Yes,0
Yes,White,2000,37,Male,Yes,Yes,0
Yes,Black,1999,20,Male,Yes,No,0
Yes,White,2000,20,Male,No,Yes,0
Yes,White,2000,21,Male,Yes,Yes,3
Yes,White,2001,38,Male,No,Yes,3
No,White,1999,16,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,5
No,Black,1999,23,Male,Yes,Yes,0
Yes,White,1999,16,Female,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,17,Female,Yes,Yes,0
Yes,White,2001,42,Male,Yes,Yes,0
Yes,Black,2000,40,Male,Yes,No,1
No,White,1997,16,Male,No,No,4
Yes,Black,2000,18,Male,Yes,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,0
Yes,White,1999,16,Male,Yes,Yes,3
Yes,White,2002,32,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,25,Male,Yes,Yes,4
Yes,White,1999,29,Female,Yes,Yes,0
Yes,White,1998,20,Female,Yes,Yes,1
Yes,Black,2001,24,Male,Yes,Yes,2
Yes,Black,2001,19,Male,Yes,Yes,1
Yes,Black,2000,21,Male,No,Yes,4
Yes,White,1997,21,Male,Yes,No,4
Yes,White,1999,24,Female,Yes,Yes,0
Yes,White,1999,27,Male,Yes,No,0
Yes,White,1999,16,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2000,25,Male,No,Yes,2
Yes,White,2000,49,Male,No,Yes,1
Yes,White,1999,21,Male,Yes,Yes,2
Yes,White,1998,34,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2000,27,Male,Yes,Yes,2
No,Black,1999,22,Male,No,No,3
No,Black,1998,22,Male,No,Yes,3
Yes,White,1998,30,Male,Yes,Yes,3
Yes,White,2001,38,Male,No,Yes,4
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2001,36,Male,No,Yes,4
Yes,White,1998,26,Male,Yes,Yes,2
Yes,White,2000,27,Male,No,Yes,4
Yes,Black,1997,14,Male,Yes,Yes,0
No,White,1998,24,Male,No,No,3
Yes,White,1997,21,Male,Yes,No,0
Yes,White,2001,36,Male,Yes,Yes,3
Yes,White,1999,20,Male,Yes,No,0
Yes,White,2001,28,Male,Yes,Yes,0
Yes,Black,2001,23,Male,Yes,Yes,1
Yes,White,2000,17,Female,Yes,Yes,0
Yes,Black,2000,17,Male,Yes,Yes,1
No,White,2001,24,Male,Yes,Yes,2
Yes,White,1999,25,Male,Yes,Yes,0
Yes,White,2000,34,Male,Yes,Yes,2
Yes,Black,1997,21,Male,Yes,Yes,3
No,Black,1998,24,Male,Yes,No,0
Yes,White,2000,15,Male,Yes,Yes,1
No,Black,2001,16,Male,No,Yes,3
Yes,White,1998,34,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,0
No,Black,1999,21,Male,No,Yes,1
Yes,White,2001,20,Male,Yes,Yes,3
Yes,White,2000,38,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,0
No,Black,2000,24,Male,No,Yes,2
No,Black,2001,23,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,No,0
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2000,30,Male,Yes,Yes,2
Yes,White,1998,28,Male,Yes,Yes,3
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2001,18,Female,Yes,Yes,1
No,White,1999,25,Male,No,Yes,4
No,White,2000,42,Male,No,Yes,3
No,White,1997,16,Male,Yes,Yes,1
Yes,Black,2002,17,Male,No,Yes,5
Yes,White,1997,21,Male,Yes,Yes,4
Yes,White,1998,29,Male,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,2
Yes,White,1999,20,Female,Yes,Yes,1
Yes,Black,1999,29,Male,Yes,Yes,2
Yes,White,1997,20,Male,Yes,No,4
Yes,Black,2001,16,Male,Yes,No,0
Yes,Black,2000,20,Male,No,Yes,4
Yes,Black,1997,45,Male,Yes,Yes,3
Yes,White,1998,20,Male,Yes,Yes,5
Yes,White,1997,17,Male,Yes,No,1
No,White,2002,17,Male,Yes,Yes,3
Yes,White,2001,23,Male,Yes,Yes,2
Yes,Black,2001,36,Male,Yes,Yes,2
No,White,2001,15,Male,Yes,Yes,3
Yes,Black,2000,21,Male,Yes,Yes,0
Yes,White,1997,34,Male,Yes,No,2
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,2002,28,Male,Yes,Yes,2
Yes,White,1999,18,Male,Yes,Yes,2
Yes,White,2000,15,Male,Yes,Yes,1
Yes,White,1998,16,Male,Yes,Yes,1
Yes,Black,2001,21,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,3
Yes,White,2001,21,Male,Yes,Yes,0
No,White,1998,16,Male,Yes,Yes,3
Yes,Black,1997,19,Male,Yes,No,0
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,1997,22,Male,No,No,2
Yes,White,1998,20,Female,Yes,Yes,0
Yes,White,2000,30,Male,Yes,Yes,3
Yes,Black,2001,27,Male,Yes,Yes,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,Black,1998,17,Male,Yes,Yes,2
Yes,Black,2001,35,Male,No,Yes,5
Yes,White,2001,43,Male,Yes,No,0
Yes,White,2001,48,Male,Yes,Yes,0
No,Black,1999,20,Male,No,Yes,1
Yes,White,2000,17,Male,Yes,Yes,4
Yes,White,1999,21,Female,No,Yes,4
Yes,Black,1998,33,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1999,22,Male,Yes,Yes,0
No,Black,1998,22,Male,Yes,Yes,5
Yes,White,1998,21,Male,Yes,Yes,0
No,Black,2001,24,Male,Yes,Yes,3
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,4
No,White,2001,33,Male,Yes,Yes,3
Yes,White,1999,45,Male,No,Yes,1
Yes,White,2000,25,Male,No,Yes,0
Yes,Black,1998,19,Male,No,Yes,2
Yes,White,2000,30,Male,Yes,No,0
Yes,White,1998,30,Male,Yes,Yes,2
Yes,White,2000,20,Male,Yes,No,0
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,2
Yes,Black,1998,18,Male,No,No,0
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,3
No,White,2001,18,Male,Yes,Yes,3
Yes,White,2002,23,Male,Yes,Yes,0
Yes,White,1999,21,Male,No,Yes,3
Yes,White,1999,29,Male,Yes,Yes,4
Yes,Black,2001,41,Male,Yes,Yes,0
Yes,White,2000,27,Male,Yes,No,0
Yes,White,2002,40,Male,Yes,Yes,3
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,2002,15,Male,Yes,Yes,3
No,White,2001,45,Male,No,Yes,4
Yes,White,2001,35,Male,No,Yes,2
No,White,1999,18,Male,No,No,3
Yes,White,1999,54,Male,No,Yes,0
Yes,White,1999,39,Male,Yes,Yes,0
Yes,White,2001,35,Male,Yes,Yes,1
Yes,Black,2000,31,Male,Yes,Yes,5
Yes,White,1998,20,Male,Yes,Yes,4
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,2
Yes,Black,2000,19,Male,No,Yes,4
Yes,White,2000,20,Male,Yes,Yes,1
No,Black,2001,14,Male,No,Yes,4
Yes,Black,2001,23,Male,Yes,Yes,3
Yes,Black,2001,22,Male,Yes,Yes,0
Yes,Black,1998,14,Male,Yes,Yes,0
Yes,White,1999,17,Male,No,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1999,16,Female,Yes,No,0
Yes,White,2000,35,Male,Yes,Yes,1
Yes,Black,1999,32,Male,Yes,Yes,4
Yes,White,1998,16,Male,Yes,Yes,0
Yes,Black,1999,42,Male,Yes,Yes,4
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,1999,36,Female,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
Yes,Black,1998,37,Male,Yes,No,2
Yes,White,1997,20,Male,Yes,No,0
Yes,White,1999,21,Male,Yes,No,2
Yes,White,1999,23,Male,Yes,Yes,4
Yes,White,1999,29,Male,Yes,Yes,0
Yes,Black,2001,22,Male,Yes,No,1
Yes,White,2000,20,Male,Yes,Yes,1
No,Black,2000,23,Male,No,Yes,1
Yes,White,1997,48,Male,No,No,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,19,Female,Yes,Yes,2
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,3
Yes,Black,1998,24,Male,Yes,Yes,2
Yes,White,1999,23,Male,Yes,Yes,0
No,White,1998,16,Male,Yes,Yes,0
Yes,Black,2000,19,Male,No,Yes,3
Yes,White,1997,36,Male,Yes,No,4
No,Black,2001,20,Male,Yes,Yes,4
Yes,Black,1998,22,Male,No,Yes,1
Yes,White,1998,19,Male,Yes,Yes,2
Yes,White,1998,19,Male,Yes,Yes,0
Yes,Black,1999,17,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,Black,1997,24,Male,Yes,No,3
No,Black,2000,23,Male,No,Yes,4
No,White,2000,18,Male,No,Yes,4
Yes,White,1997,19,Male,No,No,4
Yes,White,2000,18,Female,No,Yes,0
Yes,White,2001,25,Male,Yes,Yes,2
Yes,White,2000,15,Male,Yes,Yes,1
No,White,2000,19,Male,Yes,No,2
Yes,Black,1998,36,Male,No,Yes,4
Yes,Black,2000,40,Male,Yes,No,2
Yes,White,1998,17,Male,Yes,Yes,4
Yes,Black,1998,42,Male,No,No,3
Yes,White,1999,36,Male,Yes,Yes,1
No,White,2000,23,Male,No,Yes,4
Yes,White,1998,31,Female,No,Yes,4
Yes,White,1999,29,Male,No,Yes,1
No,White,2001,23,Male,Yes,Yes,0
Yes,White,1998,37,Male,Yes,Yes,3
Yes,Black,2001,24,Male,Yes,Yes,2
Yes,White,1998,17,Male,No,Yes,4
Yes,White,1998,22,Male,No,Yes,0
Yes,White,1999,29,Male,No,Yes,4
Yes,Black,1999,32,Male,Yes,Yes,3
Yes,White,1999,18,Male,No,Yes,0
Yes,White,2001,21,Male,Yes,Yes,2
Yes,White,1997,20,Male,Yes,No,5
No,White,2000,60,Male,Yes,Yes,0
Yes,White,2001,21,Male,No,Yes,0
Yes,White,2000,19,Female,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,1
Yes,White,2000,40,Male,Yes,Yes,3
Yes,Black,2000,23,Male,No,No,6
Yes,White,1999,22,Male,Yes,Yes,1
Yes,Black,2000,23,Male,No,No,3
Yes,White,1997,27,Male,Yes,No,0
Yes,White,1998,22,Male,Yes,Yes,1
Yes,White,2000,31,Male,Yes,No,0
Yes,White,1998,16,Male,Yes,Yes,3
Yes,White,2000,15,Male,No,Yes,3
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,1999,28,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,3
No,White,2001,21,Male,Yes,Yes,3
No,Black,2000,19,Male,No,Yes,4
Yes,White,2001,21,Male,No,Yes,1
Yes,White,2001,25,Male,Yes,No,1
Yes,White,2001,18,Male,No,Yes,1
No,White,1999,25,Female,No,Yes,1
Yes,White,2000,16,Male,Yes,Yes,3
Yes,White,1999,21,Male,No,Yes,5
Yes,Black,2001,19,Male,Yes,Yes,0
Yes,White,2001,20,Male,No,Yes,5
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,20,Female,No,Yes,0
Yes,White,1997,23,Male,No,Yes,1
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1999,14,Male,Yes,Yes,0
Yes,White,1998,30,Male,Yes,Yes,1
Yes,Black,2000,23,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,Black,1998,30,Male,Yes,Yes,1
Yes,Black,1998,30,Male,Yes,Yes,1
No,Black,1998,22,Male,Yes,No,4
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,1
Yes,Black,2001,15,Male,Yes,Yes,5
Yes,White,2002,21,Male,Yes,Yes,2
No,White,1999,19,Female,No,Yes,2
Yes,Black,2002,17,Male,No,Yes,0
Yes,White,2001,42,Male,Yes,Yes,3
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,1998,30,Female,No,Yes,0
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,2001,18,Male,No,Yes,0
Yes,White,1999,42,Male,No,Yes,1
No,Black,2001,19,Male,Yes,Yes,4
No,Black,2001,20,Male,Yes,Yes,4
Yes,White,2001,19,Male,Yes,Yes,4
Yes,White,2000,20,Female,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,40,Male,Yes,Yes,0
Yes,Black,1998,21,Male,Yes,Yes,1
No,White,2000,40,Male,No,Yes,4
Yes,White,2000,18,Male,No,Yes,0
Yes,White,2000,32,Male,Yes,Yes,0
No,Black,1998,18,Male,No,Yes,3
Yes,White,1997,18,Male,Yes,Yes,2
Yes,White,1999,14,Male,Yes,Yes,2
No,White,2002,30,Male,No,Yes,2
Yes,Black,2001,22,Male,Yes,Yes,0
Yes,White,1999,35,Male,Yes,Yes,2
Yes,White,1999,22,Male,Yes,Yes,1
Yes,Black,1998,20,Male,Yes,Yes,3
Yes,White,2000,16,Male,No,Yes,1
No,White,1998,21,Male,No,Yes,5
Yes,White,2001,30,Male,Yes,No,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2000,24,Male,No,Yes,3
Yes,Black,2000,27,Male,Yes,No,1
No,White,2001,16,Male,Yes,Yes,3
No,White,1998,46,Male,Yes,Yes,3
Yes,Black,1999,31,Male,No,Yes,3
Yes,White,2001,22,Male,Yes,Yes,3
No,White,1999,28,Male,Yes,Yes,4
Yes,White,2000,48,Male,Yes,Yes,3
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,2000,14,Male,Yes,Yes,0
Yes,White,1999,30,Male,Yes,Yes,0
Yes,White,2000,31,Male,Yes,Yes,0
Yes,White,2001,27,Male,No,Yes,1
Yes,White,2002,16,Male,Yes,Yes,0
No,White,1999,15,Male,Yes,Yes,1
No,White,2002,15,Male,Yes,Yes,0
Yes,White,1997,42,Male,Yes,No,0
Yes,Black,2001,28,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,No,4
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,1997,22,Male,Yes,No,2
Yes,White,1999,21,Male,Yes,Yes,3
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2000,32,Male,Yes,Yes,3
Yes,White,2002,21,Male,No,Yes,3
Yes,Black,2000,16,Female,Yes,Yes,0
Yes,White,1999,39,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,Black,2000,16,Male,Yes,Yes,2
Yes,Black,1999,19,Male,Yes,Yes,0
No,Black,1997,17,Male,Yes,Yes,5
Yes,Black,1998,23,Male,Yes,Yes,3
Yes,White,2001,24,Male,No,Yes,2
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,2001,19,Female,Yes,Yes,1
Yes,White,1999,42,Male,Yes,Yes,1
Yes,White,1998,22,Male,Yes,Yes,3
Yes,White,2000,16,Male,Yes,Yes,3
Yes,White,1998,18,Female,Yes,Yes,1
Yes,Black,2002,29,Male,Yes,Yes,1
Yes,Black,2001,37,Male,Yes,Yes,0
Yes,White,2001,31,Male,No,Yes,0
Yes,White,1998,33,Female,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
No,Black,1997,20,Male,No,No,1
Yes,White,2000,17,Male,No,Yes,1
Yes,Black,2000,25,Male,Yes,Yes,1
No,Black,1997,20,Male,Yes,Yes,1
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,2
Yes,White,2001,20,Male,Yes,Yes,2
Yes,White,2001,30,Male,Yes,Yes,0
Yes,White,1999,16,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,1999,28,Female,No,Yes,4
Yes,White,2002,16,Female,Yes,Yes,0
No,Black,1999,32,Male,No,Yes,0
Yes,Black,2001,23,Male,Yes,Yes,0
No,Black,1997,41,Male,No,No,4
Yes,White,2001,45,Male,Yes,Yes,3
Yes,Black,1999,26,Male,No,Yes,3
Yes,White,2000,30,Male,Yes,Yes,1
Yes,White,2000,31,Male,Yes,Yes,2
Yes,Black,1999,23,Male,Yes,Yes,0
Yes,White,2000,21,Female,Yes,Yes,0
No,White,2001,42,Male,Yes,Yes,4
Yes,White,2001,23,Male,Yes,Yes,1
Yes,White,2000,32,Male,Yes,Yes,0
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,2000,21,Male,No,Yes,4
Yes,Black,2001,24,Male,No,Yes,1
Yes,White,1998,14,Male,Yes,Yes,1
No,Black,1998,23,Male,No,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2002,20,Male,Yes,Yes,2
Yes,White,2001,21,Male,Yes,Yes,3
No,Black,1998,21,Male,Yes,Yes,3
Yes,Black,2001,30,Male,Yes,No,3
Yes,White,1998,34,Male,Yes,Yes,0
No,White,2001,17,Female,No,Yes,0
No,White,1998,20,Male,Yes,Yes,4
Yes,White,1997,19,Male,No,Yes,5
Yes,White,1997,18,Male,Yes,Yes,1
Yes,White,1999,20,Female,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,4
Yes,White,1998,23,Male,Yes,Yes,3
Yes,White,1999,17,Male,No,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1998,23,Male,Yes,Yes,3
Yes,Black,1998,20,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,Black,2000,21,Male,Yes,Yes,3
No,Black,2001,19,Male,No,Yes,3
Yes,White,1999,46,Male,Yes,Yes,1
No,White,2001,19,Male,No,Yes,2
Yes,White,1998,24,Female,Yes,Yes,0
No,White,2002,24,Female,Yes,Yes,0
Yes,White,2002,25,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,1999,39,Male,Yes,Yes,3
Yes,Black,1999,36,Male,No,No,4
No,Black,1998,23,Male,No,No,1
No,White,1998,40,Male,Yes,Yes,3
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2000,21,Male,No,Yes,0
Yes,White,1999,16,Female,Yes,Yes,0
Yes,White,1997,17,Male,Yes,No,2
No,Black,1997,18,Male,Yes,Yes,5
Yes,White,1999,37,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,1997,37,Female,Yes,No,0
Yes,Black,2000,34,Male,No,No,0
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,1998,14,Male,Yes,Yes,0
Yes,Black,2001,16,Male,Yes,Yes,0
Yes,Black,1999,43,Male,Yes,Yes,4
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,2001,19,Male,No,Yes,1
Yes,Black,1999,25,Male,No,Yes,2
Yes,Black,2001,27,Male,No,Yes,1
No,White,1998,24,Male,No,Yes,0
No,White,1998,29,Male,No,Yes,4
Yes,White,2000,15,Male,Yes,Yes,3
Yes,White,1997,21,Male,Yes,No,0
Yes,White,2000,16,Male,Yes,Yes,4
Yes,Black,2000,24,Male,No,Yes,3
No,White,1997,21,Male,No,No,4
Yes,White,1998,18,Male,Yes,Yes,1
No,White,2002,19,Male,No,Yes,3
No,Black,2000,23,Male,No,Yes,4
Yes,White,2001,36,Male,Yes,Yes,1
Yes,White,2001,22,Male,Yes,No,2
Yes,Black,2001,27,Male,Yes,Yes,2
No,White,1997,24,Male,Yes,Yes,1
Yes,White,1997,29,Male,No,Yes,1
Yes,White,2001,41,Male,Yes,Yes,3
Yes,White,1997,22,Male,Yes,No,4
Yes,White,2000,21,Male,Yes,Yes,4
Yes,Black,2000,21,Male,Yes,No,5
Yes,Black,2000,24,Male,Yes,Yes,3
Yes,White,1999,27,Male,Yes,Yes,4
Yes,Black,1999,21,Male,Yes,Yes,3
No,White,2000,42,Male,No,Yes,4
Yes,White,1997,24,Male,Yes,No,2
Yes,Black,1999,22,Male,Yes,Yes,1
Yes,White,2001,21,Male,Yes,Yes,1
Yes,White,1999,18,Female,Yes,Yes,2
Yes,White,2000,34,Male,Yes,Yes,3
No,White,2000,32,Male,No,Yes,4
Yes,White,1999,39,Male,No,Yes,0
Yes,White,2000,24,Male,Yes,Yes,2
Yes,White,1999,27,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,2
Yes,White,2000,24,Male,Yes,Yes,0
No,Black,1998,22,Male,Yes,Yes,2
Yes,White,2001,29,Male,Yes,Yes,2
Yes,White,1999,20,Male,Yes,Yes,1
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2000,26,Male,No,Yes,4
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2000,36,Male,Yes,Yes,2
Yes,White,1999,19,Male,Yes,Yes,1
Yes,Black,2001,22,Male,Yes,No,0
Yes,White,1997,16,Male,Yes,No,0
Yes,White,2000,30,Male,No,Yes,4
Yes,White,1999,23,Male,No,Yes,3
Yes,White,1997,31,Male,No,Yes,1
Yes,Black,1998,30,Male,Yes,Yes,0
Yes,White,1998,14,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,4
Yes,White,1997,19,Male,Yes,No,0
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,2000,28,Male,Yes,Yes,0
No,White,1997,17,Male,Yes,Yes,4
Yes,White,1998,20,Male,No,Yes,0
No,Black,1998,22,Male,No,Yes,3
Yes,White,2002,45,Male,Yes,Yes,1
Yes,White,1998,18,Male,Yes,Yes,1
No,White,1998,18,Male,No,Yes,2
Yes,White,1997,26,Female,Yes,No,0
Yes,Black,1997,15,Male,Yes,No,1
Yes,White,2000,28,Male,No,Yes,3
Yes,Black,1999,21,Male,Yes,Yes,3
No,White,1998,18,Male,Yes,Yes,1
Yes,White,2000,25,Male,Yes,Yes,2
Yes,White,1999,44,Male,Yes,No,2
Yes,White,2000,37,Male,Yes,Yes,3
No,Black,1999,18,Male,Yes,Yes,2
No,Black,1997,34,Male,Yes,No,4
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,4
No,Black,2001,33,Male,No,No,4
Yes,White,2000,16,Male,Yes,Yes,2
Yes,Black,1999,34,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
No,White,2001,33,Female,No,Yes,3
Yes,White,2001,36,Male,Yes,Yes,0
Yes,White,1999,19,Male,No,Yes,0
Yes,White,2002,21,Male,Yes,Yes,2
Yes,Black,1997,20,Male,Yes,No,0
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1997,22,Male,Yes,No,1
Yes,White,2000,16,Female,No,Yes,2
Yes,White,2000,26,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,2
Yes,Black,1997,15,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,2
No,White,1997,41,Male,No,No,2
Yes,Black,2000,34,Male,No,No,3
Yes,White,2001,16,Male,Yes,Yes,4
Yes,Black,2000,19,Male,Yes,No,3
Yes,Black,1998,17,Female,No,Yes,1
Yes,White,1999,18,Male,Yes,Yes,1
No,White,2000,23,Male,Yes,Yes,1
No,Black,2002,26,Male,Yes,Yes,2
No,Black,2000,19,Male,Yes,Yes,3
Yes,White,1998,30,Male,No,Yes,0
Yes,White,1997,18,Female,No,No,0
Yes,Black,2000,23,Male,No,No,0
Yes,White,2001,20,Male,Yes,Yes,0
Yes,Black,1998,24,Male,Yes,Yes,1
Yes,White,2001,39,Male,Yes,No,2
Yes,White,1999,16,Male,Yes,Yes,1
No,Black,2000,26,Male,No,No,0
Yes,Black,1999,16,Male,Yes,Yes,0
No,White,1997,17,Male,No,Yes,4
Yes,Black,2000,21,Male,Yes,Yes,3
Yes,White,1999,20,Male,Yes,Yes,4
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,44,Male,Yes,Yes,0
Yes,White,1999,25,Female,Yes,Yes,2
Yes,White,2000,18,Female,Yes,Yes,0
No,White,2001,23,Male,Yes,Yes,1
Yes,White,1999,43,Male,Yes,Yes,0
Yes,White,1999,23,Male,No,Yes,0
Yes,White,2000,37,Male,Yes,Yes,4
Yes,White,1999,23,Male,No,Yes,3
Yes,Black,2001,18,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,Black,1999,17,Male,Yes,Yes,3
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,1999,21,Male,No,Yes,3
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
No,Black,1998,29,Male,Yes,Yes,4
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,4
Yes,White,2000,24,Male,Yes,Yes,0
Yes,Black,2002,16,Male,Yes,No,0
Yes,White,2001,27,Male,Yes,Yes,0
Yes,Black,2002,42,Male,Yes,Yes,0
Yes,White,1999,16,Female,No,Yes,1
Yes,White,1998,52,Male,No,Yes,5
Yes,White,1999,22,Male,Yes,Yes,2
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1997,31,Male,Yes,Yes,1
Yes,White,1999,33,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,2
Yes,White,2000,20,Male,No,Yes,1
Yes,Black,2000,27,Male,No,Yes,3
No,Black,1998,40,Male,Yes,Yes,5
Yes,Black,1998,38,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,3
Yes,White,2002,14,Female,Yes,Yes,0
Yes,Black,1999,19,Male,Yes,Yes,1
Yes,Black,2001,23,Female,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,2
Yes,White,1999,34,Female,Yes,Yes,3
Yes,Black,1998,18,Male,Yes,Yes,0
Yes,Black,2001,24,Male,Yes,Yes,3
Yes,White,1999,26,Male,Yes,Yes,2
No,Black,1999,20,Male,No,Yes,4
Yes,Black,2000,21,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2000,31,Male,Yes,Yes,3
No,White,2000,28,Male,Yes,Yes,2
Yes,White,2000,44,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,0
No,White,2001,20,Male,Yes,Yes,2
Yes,Black,2002,20,Female,No,No,3
No,Black,1997,22,Male,Yes,No,2
Yes,White,2000,23,Male,Yes,Yes,1
Yes,White,1998,17,Male,Yes,Yes,0
No,White,1999,43,Male,Yes,Yes,2
No,Black,1997,37,Male,No,No,3
Yes,White,1998,25,Male,Yes,Yes,0
Yes,White,2000,15,Male,Yes,Yes,3
Yes,White,1997,23,Male,Yes,No,0
Yes,White,1997,18,Male,Yes,Yes,4
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,1999,42,Male,Yes,Yes,1
Yes,White,1999,20,Male,Yes,Yes,2
Yes,Black,1998,32,Male,Yes,Yes,0
Yes,Black,2000,23,Male,Yes,No,2
Yes,White,1999,18,Female,Yes,Yes,0
Yes,White,2000,14,Male,Yes,Yes,1
No,Black,2001,22,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,2
No,Black,1998,22,Male,No,Yes,3
Yes,White,1999,21,Male,Yes,Yes,4
Yes,White,2002,26,Male,Yes,Yes,3
Yes,White,2001,38,Male,Yes,Yes,2
No,White,1997,17,Male,No,No,3
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,3
Yes,White,1999,32,Male,Yes,Yes,4
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,No,3
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,1
No,White,1999,21,Female,No,Yes,4
No,White,1999,21,Female,No,Yes,4
No,Black,2001,16,Male,Yes,No,1
Yes,White,1997,16,Male,Yes,Yes,0
Yes,White,2002,27,Male,No,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1999,26,Male,Yes,Yes,0
Yes,White,1998,18,Male,No,Yes,4
Yes,White,1998,28,Male,Yes,Yes,0
Yes,White,1998,33,Male,No,Yes,2
Yes,White,1999,17,Female,Yes,Yes,4
Yes,White,2000,25,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,1
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,Yes,2
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,2002,20,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,2
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2001,18,Female,No,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,30,Male,No,Yes,4
Yes,White,1999,34,Male,Yes,Yes,1
No,White,1997,39,Male,Yes,No,4
Yes,White,1998,18,Male,Yes,Yes,2
Yes,Black,1998,17,Male,Yes,Yes,0
No,White,1999,35,Male,Yes,Yes,3
Yes,Black,2001,20,Male,Yes,No,3
Yes,White,1998,29,Male,Yes,Yes,1
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1999,34,Male,Yes,Yes,0
Yes,White,1999,31,Male,Yes,Yes,3
Yes,White,1999,23,Male,Yes,Yes,3
Yes,White,2002,16,Female,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,5
Yes,White,2001,19,Male,Yes,Yes,2
Yes,White,1998,17,Male,Yes,Yes,3
Yes,White,1999,37,Male,No,No,2
Yes,White,1998,35,Male,No,No,4
No,Black,1998,21,Male,Yes,Yes,3
Yes,White,1999,31,Male,Yes,Yes,2
Yes,White,2000,30,Male,Yes,Yes,1
Yes,White,2000,21,Male,Yes,Yes,2
Yes,Black,1999,18,Male,Yes,Yes,3
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,No,1
Yes,White,2001,22,Male,No,Yes,3
Yes,White,1999,24,Male,Yes,Yes,0
Yes,Black,2000,22,Male,Yes,Yes,3
Yes,Black,1998,24,Male,Yes,Yes,2
Yes,White,1998,41,Male,No,Yes,0
Yes,White,1999,33,Male,Yes,Yes,0
Yes,Black,2001,21,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2000,26,Male,Yes,Yes,1
Yes,White,1997,17,Male,Yes,No,0
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1998,32,Male,No,Yes,3
No,Black,1997,23,Male,No,Yes,3
Yes,White,1998,29,Male,No,Yes,2
Yes,White,1999,23,Male,Yes,Yes,3
Yes,White,1998,34,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,Black,1999,33,Male,Yes,No,0
No,White,2001,26,Male,Yes,Yes,1
Yes,White,2000,33,Male,Yes,Yes,0
Yes,White,2001,20,Male,Yes,Yes,4
Yes,White,1999,36,Male,Yes,Yes,2
No,Black,2000,21,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1998,17,Male,No,Yes,1
Yes,White,2002,15,Male,Yes,Yes,1
Yes,White,2000,18,Male,Yes,Yes,4
Yes,White,2001,36,Male,Yes,Yes,2
Yes,White,1998,22,Male,No,Yes,2
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,1998,19,Female,Yes,Yes,1
Yes,White,2000,18,Female,Yes,Yes,1
Yes,Black,2001,24,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,1998,17,Male,Yes,Yes,3
Yes,White,1998,16,Male,Yes,Yes,2
Yes,White,2001,30,Male,No,Yes,1
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,1998,39,Male,Yes,Yes,0
Yes,White,1999,16,Male,Yes,Yes,0
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,2000,27,Male,Yes,Yes,0
Yes,Black,2000,17,Male,Yes,Yes,0
Yes,White,1998,26,Female,Yes,Yes,0
Yes,Black,1997,23,Male,No,No,4
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2002,29,Male,Yes,Yes,5
Yes,Black,2001,15,Female,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,1998,36,Male,Yes,Yes,1
No,Black,2000,35,Male,Yes,Yes,3
Yes,White,2000,26,Male,No,Yes,2
Yes,White,1998,53,Male,No,Yes,5
Yes,White,1997,18,Male,Yes,No,1
Yes,White,2000,17,Female,Yes,Yes,1
No,Black,1999,28,Male,No,Yes,2
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1998,15,Female,Yes,Yes,0
Yes,White,2000,22,Male,No,Yes,1
Yes,White,2001,17,Male,Yes,Yes,5
Yes,White,1997,20,Male,Yes,Yes,1
Yes,White,1997,21,Male,Yes,No,2
Yes,White,2001,15,Male,Yes,Yes,1
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,1997,17,Male,Yes,Yes,2
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,1999,24,Male,Yes,Yes,2
Yes,Black,1998,30,Male,Yes,Yes,4
Yes,White,2001,26,Female,Yes,Yes,0
Yes,White,1999,25,Female,Yes,Yes,0
Yes,Black,2001,24,Male,Yes,Yes,1
Yes,White,1997,15,Male,Yes,No,0
Yes,Black,2000,24,Male,Yes,No,2
Yes,Black,2001,19,Male,Yes,Yes,3
Yes,White,2000,34,Male,Yes,Yes,3
No,Black,1999,39,Male,No,Yes,4
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1999,17,Female,Yes,Yes,3
Yes,White,2001,15,Male,Yes,Yes,2
Yes,White,1998,23,Male,Yes,Yes,1
Yes,White,1998,18,Male,No,Yes,4
Yes,White,1997,21,Male,Yes,Yes,3
No,White,1998,34,Female,No,Yes,2
Yes,White,1998,18,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,20,Male,No,Yes,3
Yes,White,2001,22,Male,Yes,Yes,1
Yes,White,2002,26,Male,Yes,Yes,4
Yes,White,2001,17,Male,Yes,Yes,0
No,White,2001,22,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,4
Yes,White,2001,36,Male,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1998,33,Male,Yes,No,0
Yes,White,2000,16,Male,Yes,Yes,2
Yes,Black,2001,20,Male,Yes,Yes,2
Yes,White,1997,14,Female,Yes,Yes,0
Yes,White,2000,17,Female,Yes,Yes,0
Yes,White,1998,46,Male,Yes,Yes,2
No,White,2001,16,Male,Yes,Yes,1
Yes,Black,1998,20,Female,No,Yes,1
No,White,1997,28,Male,No,No,5
No,White,1998,40,Male,No,Yes,3
Yes,White,1998,14,Male,Yes,Yes,0
Yes,White,2000,24,Male,Yes,Yes,4
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,2
Yes,White,1998,33,Male,No,Yes,3
Yes,Black,1998,33,Male,Yes,No,1
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1999,35,Male,Yes,Yes,3
Yes,Black,1998,55,Male,Yes,Yes,3
No,White,2001,27,Male,Yes,Yes,4
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2000,27,Male,Yes,Yes,2
Yes,Black,2002,59,Male,No,Yes,3
Yes,White,2000,35,Male,Yes,Yes,2
Yes,Black,2001,19,Female,Yes,Yes,1
Yes,White,2001,35,Male,Yes,Yes,3
Yes,White,1997,28,Male,Yes,Yes,2
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,1999,18,Male,No,Yes,3
Yes,White,2001,22,Male,No,Yes,2
Yes,White,1998,27,Male,Yes,Yes,1
No,Black,2000,24,Male,Yes,Yes,3
No,White,1997,29,Male,No,Yes,4
Yes,White,2001,43,Male,Yes,Yes,3
Yes,White,1998,16,Female,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,2
No,Black,1998,27,Male,No,Yes,2
Yes,White,2001,22,Male,Yes,Yes,0
No,Black,1998,38,Male,Yes,No,3
Yes,White,2001,36,Male,Yes,Yes,4
Yes,White,2000,26,Male,Yes,Yes,0
Yes,Black,2000,22,Male,No,Yes,0
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,0
No,White,1999,21,Male,No,Yes,4
Yes,White,1999,15,Male,Yes,Yes,2
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,2000,18,Male,Yes,Yes,0
No,White,2002,17,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,No,0
Yes,White,1999,35,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,0
No,Black,2000,49,Male,No,No,5
Yes,Black,2002,19,Male,Yes,No,1
Yes,White,1999,15,Male,Yes,Yes,2
Yes,Black,2001,16,Female,Yes,Yes,0
Yes,White,1999,19,Male,No,Yes,1
Yes,White,2001,41,Female,No,Yes,1
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2000,23,Male,Yes,Yes,0
Yes,White,1997,22,Male,Yes,Yes,0
Yes,Black,2001,18,Male,Yes,Yes,0
Yes,White,2000,39,Male,Yes,Yes,2
Yes,Black,2002,26,Male,Yes,Yes,2
Yes,White,1997,23,Male,No,No,0
Yes,White,1998,33,Male,Yes,Yes,1
Yes,White,1997,16,Male,Yes,Yes,1
Yes,Black,2001,23,Male,No,Yes,2
Yes,White,2001,54,Male,Yes,Yes,3
No,Black,2001,42,Male,No,Yes,4
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,2
Yes,White,2002,38,Male,Yes,Yes,1
Yes,White,1999,22,Male,Yes,Yes,3
Yes,Black,1998,20,Male,Yes,Yes,3
Yes,White,1998,40,Male,Yes,Yes,0
Yes,Black,2001,32,Male,Yes,No,3
No,White,1999,18,Male,Yes,Yes,4
No,Black,2001,21,Male,Yes,Yes,3
Yes,White,1999,42,Male,No,Yes,0
Yes,Black,1998,18,Male,No,Yes,0
No,Black,2000,17,Male,Yes,Yes,3
Yes,Black,1998,39,Male,Yes,No,3
No,White,1997,40,Male,No,Yes,4
Yes,White,2001,20,Male,No,Yes,0
Yes,Black,2002,17,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,3
Yes,Black,2002,28,Male,Yes,No,4
Yes,White,1999,36,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,1998,26,Male,Yes,Yes,0
Yes,Black,1999,36,Male,Yes,Yes,2
Yes,White,2000,37,Male,Yes,No,0
Yes,White,2000,22,Male,No,Yes,1
Yes,Black,2001,30,Male,Yes,Yes,1
Yes,White,2002,21,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,3
No,Black,2001,29,Male,No,Yes,3
No,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,44,Male,Yes,Yes,0
No,White,2001,28,Female,No,Yes,5
Yes,White,2001,41,Male,No,Yes,2
Yes,White,2000,21,Male,No,Yes,3
Yes,White,2000,22,Male,Yes,Yes,3
Yes,White,1999,30,Male,Yes,Yes,1
Yes,Black,2000,17,Male,Yes,Yes,2
No,Black,2002,16,Male,Yes,Yes,5
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,1998,27,Male,Yes,Yes,5
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1998,18,Male,No,Yes,3
Yes,White,1998,30,Male,Yes,Yes,2
Yes,White,2001,36,Male,Yes,Yes,1
No,White,2000,23,Male,Yes,Yes,4
Yes,White,1997,15,Male,Yes,No,4
Yes,White,1998,17,Male,Yes,Yes,3
Yes,Black,2002,21,Male,Yes,Yes,1
No,White,1998,17,Male,No,Yes,4
Yes,White,2000,14,Male,Yes,Yes,0
Yes,Black,1997,20,Male,Yes,No,0
Yes,White,1999,33,Male,Yes,Yes,3
Yes,Black,1998,25,Male,Yes,Yes,0
Yes,Black,2001,18,Male,Yes,Yes,1
Yes,White,2001,38,Male,Yes,Yes,3
Yes,White,2001,33,Male,Yes,Yes,4
No,White,2001,27,Male,Yes,Yes,3
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,1997,32,Male,Yes,Yes,4
Yes,Black,2000,20,Male,Yes,No,2
Yes,White,1999,21,Male,Yes,Yes,3
No,Black,1999,33,Male,No,No,2
No,White,1997,20,Male,Yes,Yes,0
Yes,White,2002,14,Female,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
No,White,2001,24,Male,Yes,Yes,4
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,2002,17,Male,Yes,No,0
Yes,Black,1998,52,Male,Yes,No,0
Yes,White,2001,23,Male,Yes,Yes,4
No,Black,2000,17,Male,No,No,5
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,1998,18,Female,Yes,Yes,2
Yes,White,1999,22,Male,No,Yes,0
Yes,White,1998,17,Male,No,Yes,0
Yes,White,2000,18,Male,Yes,Yes,2
Yes,Black,2000,61,Male,Yes,Yes,1
Yes,Black,2002,17,Male,Yes,Yes,0
No,White,2001,24,Male,No,Yes,3
Yes,Black,2001,60,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,1999,23,Male,Yes,Yes,1
Yes,White,2002,21,Male,Yes,Yes,4
Yes,White,1997,16,Male,Yes,No,2
Yes,White,1998,27,Male,No,Yes,3
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1998,30,Male,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,3
Yes,Black,1998,28,Male,No,Yes,3
No,White,2000,19,Male,No,Yes,0
Yes,White,1997,21,Male,Yes,No,0
Yes,Black,1998,25,Male,No,Yes,4
Yes,White,1999,39,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
No,Black,1998,38,Male,No,Yes,1
Yes,White,2000,17,Male,No,Yes,4
No,White,1998,18,Male,Yes,Yes,5
Yes,Black,1999,21,Male,Yes,Yes,3
No,White,2001,19,Male,Yes,Yes,0
No,Black,2001,28,Male,Yes,No,2
Yes,Black,2001,15,Male,Yes,Yes,5
Yes,White,1999,24,Male,Yes,Yes,0
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,0
No,White,2002,17,Male,Yes,Yes,3
Yes,White,1999,17,Male,Yes,Yes,3
Yes,White,2000,22,Male,Yes,Yes,1
No,White,2001,46,Male,Yes,No,2
Yes,White,1999,40,Male,Yes,Yes,0
Yes,White,2000,25,Male,Yes,Yes,0
Yes,Black,1999,32,Male,Yes,Yes,4
No,Black,1999,17,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,No,0
Yes,White,1997,23,Male,No,Yes,3
No,Black,1997,21,Male,No,No,2
Yes,Black,1998,53,Male,Yes,Yes,2
No,White,1997,20,Male,No,Yes,2
Yes,Black,1998,36,Male,No,Yes,3
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1997,15,Male,Yes,No,2
Yes,White,1999,19,Male,Yes,Yes,0
No,White,1998,17,Female,No,Yes,2
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1998,26,Male,Yes,Yes,5
No,Black,2000,36,Male,Yes,No,2
No,White,1999,21,Male,Yes,Yes,1
Yes,Black,1997,33,Female,Yes,No,3
Yes,White,1999,25,Female,Yes,Yes,0
No,White,1998,32,Male,Yes,Yes,2
Yes,White,1998,15,Male,Yes,Yes,3
No,White,2000,15,Female,Yes,Yes,1
No,White,1999,35,Male,Yes,No,1
No,White,1999,35,Male,Yes,No,1
Yes,White,2000,13,Male,Yes,Yes,0
Yes,Black,2000,22,Male,Yes,Yes,2
Yes,White,2001,27,Male,Yes,Yes,0
Yes,White,1999,26,Male,Yes,Yes,3
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1998,23,Male,Yes,Yes,4
Yes,White,2001,39,Male,No,Yes,4
Yes,Black,1998,17,Female,Yes,Yes,1
Yes,Black,2000,39,Male,Yes,Yes,3
Yes,Black,2001,25,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,1
Yes,White,1998,20,Female,Yes,Yes,0
Yes,White,1999,38,Male,Yes,Yes,1
No,Black,1998,22,Male,Yes,No,5
Yes,White,2001,23,Male,Yes,Yes,2
No,White,1997,19,Male,Yes,Yes,4
Yes,Black,1997,27,Male,No,No,1
Yes,Black,1998,40,Male,No,Yes,4
Yes,White,2001,17,Female,Yes,Yes,3
Yes,White,1999,21,Male,Yes,Yes,4
Yes,White,2000,16,Male,Yes,Yes,4
Yes,White,2000,31,Male,Yes,Yes,0
No,White,2002,19,Male,No,No,0
Yes,Black,1998,35,Male,No,Yes,2
Yes,White,2000,36,Female,No,Yes,3
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,2000,22,Male,No,Yes,2
No,Black,1999,17,Male,No,Yes,3
No,White,1999,19,Male,Yes,Yes,3
Yes,Black,2000,19,Male,Yes,Yes,3
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,2002,26,Male,Yes,Yes,2
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,3
Yes,White,1997,17,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
No,White,1997,17,Male,Yes,Yes,4
Yes,White,2000,17,Female,Yes,Yes,4
Yes,White,2000,54,Male,No,Yes,3
No,Black,1997,16,Male,No,No,0
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,0
No,White,2001,23,Male,Yes,Yes,2
No,White,2002,22,Male,Yes,Yes,0
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,0
Yes,Black,1998,19,Male,Yes,Yes,0
Yes,White,2000,29,Male,Yes,Yes,0
Yes,White,2000,32,Male,Yes,Yes,4
Yes,White,1998,41,Male,Yes,Yes,0
Yes,Black,1999,23,Male,Yes,Yes,1
Yes,White,2000,21,Male,No,Yes,5
Yes,White,2001,22,Male,Yes,Yes,0
No,White,1997,32,Male,No,No,4
Yes,White,1998,28,Male,Yes,Yes,2
Yes,White,2000,26,Male,Yes,Yes,1
Yes,White,1998,19,Male,Yes,Yes,1
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,2
Yes,White,2001,37,Male,Yes,Yes,2
Yes,White,1999,28,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,1
Yes,White,1999,22,Male,No,No,2
Yes,White,2000,15,Male,No,Yes,1
No,White,2000,29,Male,Yes,Yes,4
Yes,Black,2002,20,Male,Yes,Yes,2
Yes,Black,1997,23,Male,Yes,No,1
Yes,White,1997,32,Male,Yes,Yes,4
Yes,White,1999,31,Male,No,Yes,4
No,Black,1999,23,Male,No,No,4
Yes,Black,1999,21,Male,No,Yes,4
Yes,Black,2001,19,Male,No,Yes,2
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1998,20,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,0
No,Black,2000,20,Male,No,Yes,4
Yes,White,1997,17,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,3
No,Black,2000,20,Male,Yes,Yes,3
Yes,White,2000,17,Female,Yes,Yes,1
Yes,White,2000,41,Male,Yes,Yes,4
Yes,White,1998,33,Male,Yes,No,3
Yes,Black,1999,38,Male,Yes,No,6
Yes,White,1999,22,Female,Yes,Yes,2
Yes,Black,1998,40,Male,Yes,Yes,3
No,White,2001,45,Male,No,Yes,3
Yes,White,2001,14,Male,Yes,Yes,1
Yes,Black,1998,40,Female,No,No,0
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,2002,17,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,1
Yes,Black,1998,18,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,3
Yes,White,2001,34,Male,Yes,Yes,0
No,White,2000,36,Male,No,Yes,4
Yes,White,1999,32,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,42,Male,Yes,Yes,3
Yes,White,1999,26,Male,No,Yes,2
Yes,Black,1998,28,Male,Yes,Yes,4
No,White,2001,24,Male,Yes,Yes,4
Yes,Black,2001,21,Male,No,Yes,4
Yes,White,2001,21,Male,Yes,Yes,4
Yes,White,2000,15,Female,Yes,Yes,0
Yes,Black,1999,24,Female,Yes,Yes,0
No,Black,1998,24,Male,Yes,Yes,3
Yes,Black,2000,18,Male,Yes,Yes,1
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,2000,39,Male,Yes,Yes,0
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,2
Yes,White,2000,32,Male,Yes,Yes,2
Yes,White,1997,47,Male,Yes,No,0
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,1997,62,Male,No,No,2
Yes,White,1999,28,Male,Yes,Yes,3
Yes,White,1999,26,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,2001,22,Male,No,Yes,2
Yes,White,1998,40,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,3
Yes,White,2001,41,Male,Yes,Yes,5
Yes,White,2000,29,Male,Yes,Yes,2
Yes,White,2001,23,Male,Yes,Yes,2
Yes,White,2000,36,Female,Yes,Yes,0
Yes,White,1999,20,Male,No,No,2
No,Black,1999,33,Male,No,No,0
Yes,White,1999,13,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,No,0
Yes,Black,1998,23,Male,Yes,Yes,3
Yes,White,2000,20,Female,Yes,Yes,1
Yes,White,2001,40,Male,Yes,Yes,0
No,Black,1999,16,Male,Yes,Yes,5
Yes,White,2001,31,Male,Yes,Yes,3
Yes,Black,2002,18,Male,Yes,Yes,2
Yes,Black,2000,17,Male,Yes,Yes,1
Yes,Black,2000,25,Male,Yes,Yes,4
Yes,Black,2001,16,Female,Yes,Yes,1
Yes,Black,1999,21,Male,Yes,Yes,0
Yes,White,1999,28,Male,No,Yes,4
No,White,2000,19,Male,Yes,Yes,4
Yes,White,1998,23,Male,Yes,Yes,2
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2001,16,Male,Yes,Yes,4
No,White,2001,20,Female,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,2
Yes,White,2000,44,Female,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,Black,2001,15,Male,Yes,Yes,0
No,White,1999,21,Male,Yes,Yes,2
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1997,37,Male,Yes,Yes,0
No,Black,2002,27,Male,Yes,No,4
No,White,1998,26,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,0
No,Black,2001,19,Male,No,Yes,3
Yes,White,1998,39,Female,No,Yes,2
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,1999,16,Male,Yes,Yes,0
Yes,White,1997,15,Male,Yes,No,2
Yes,White,1999,20,Male,Yes,Yes,2
No,White,1998,21,Male,Yes,Yes,0
No,Black,2000,36,Male,Yes,No,3
No,White,1999,19,Male,Yes,Yes,1
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,3
Yes,Black,1997,64,Male,Yes,No,0
Yes,White,2001,26,Male,No,Yes,0
Yes,White,1999,19,Male,Yes,Yes,1
Yes,Black,1999,18,Male,Yes,Yes,4
Yes,White,1999,21,Male,Yes,Yes,0
Yes,Black,1999,19,Male,Yes,No,2
Yes,White,1998,27,Male,Yes,Yes,1
Yes,White,2001,22,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,2
No,Black,2002,34,Male,Yes,No,4
Yes,White,1998,17,Female,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,1999,17,Female,Yes,Yes,2
Yes,White,1997,21,Male,No,Yes,0
Yes,White,1999,36,Male,Yes,Yes,1
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,Black,1998,32,Male,Yes,No,3
Yes,Black,1997,47,Male,No,No,0
Yes,White,2001,43,Male,No,Yes,5
Yes,White,1997,14,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,5
Yes,Black,2000,22,Male,Yes,Yes,2
Yes,White,1998,24,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,3
No,Black,1999,19,Male,No,Yes,3
Yes,White,2001,22,Male,Yes,Yes,2
Yes,White,2001,15,Male,Yes,Yes,1
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,Black,2001,29,Male,Yes,Yes,3
No,White,1998,17,Female,Yes,Yes,4
Yes,White,2001,35,Male,No,Yes,2
No,Black,1998,28,Male,No,Yes,0
No,Black,1999,37,Male,Yes,Yes,2
Yes,White,2001,21,Female,No,Yes,0
No,White,1999,21,Male,No,Yes,4
Yes,White,1998,20,Male,Yes,Yes,4
No,White,2001,14,Male,Yes,Yes,3
No,White,1998,28,Female,No,Yes,3
Yes,White,2001,23,Male,Yes,Yes,1
Yes,Black,2002,22,Male,No,Yes,0
No,Black,2001,19,Male,No,Yes,4
Yes,White,1999,20,Male,No,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1999,22,Male,No,Yes,3
Yes,White,1998,24,Male,Yes,Yes,0
Yes,White,2000,29,Female,Yes,Yes,5
No,White,1999,21,Male,Yes,Yes,1
Yes,White,2002,22,Male,Yes,Yes,4
Yes,White,1997,21,Male,Yes,No,1
Yes,White,2000,29,Male,Yes,Yes,2
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,1
Yes,White,2001,19,Male,No,Yes,3
Yes,White,1997,26,Male,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,3
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2002,15,Male,Yes,Yes,0
No,White,1997,30,Male,No,No,3
No,White,2001,33,Male,Yes,Yes,4
No,White,1999,23,Male,No,Yes,0
No,White,2002,19,Male,Yes,Yes,4
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1998,41,Male,Yes,Yes,3
Yes,White,2000,30,Male,Yes,Yes,0
Yes,White,1998,24,Male,Yes,Yes,0
Yes,White,1999,18,Male,No,Yes,4
Yes,White,2001,46,Male,No,Yes,1
Yes,White,1999,17,Female,Yes,Yes,0
No,Black,1998,20,Male,No,Yes,0
No,White,1997,35,Male,Yes,No,2
Yes,Black,1999,34,Male,No,Yes,4
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,1999,37,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,1998,14,Male,Yes,Yes,3
Yes,White,1997,23,Male,Yes,No,3
Yes,White,1998,16,Female,Yes,Yes,4
No,Black,1998,16,Male,Yes,No,2
Yes,White,1997,21,Male,Yes,Yes,2
No,White,1999,18,Male,Yes,Yes,0
Yes,Black,1998,25,Male,Yes,Yes,4
Yes,White,1998,36,Female,Yes,Yes,1
Yes,White,1999,25,Male,Yes,Yes,4
No,Black,2000,19,Male,No,No,4
No,White,1997,16,Male,No,Yes,3
No,Black,1998,20,Male,Yes,Yes,4
Yes,White,1997,16,Male,Yes,No,0
Yes,White,2002,23,Male,No,Yes,3
Yes,White,2000,31,Male,Yes,Yes,0
No,Black,2000,19,Male,No,Yes,4
Yes,White,1999,33,Male,No,No,3
No,Black,1999,19,Male,Yes,No,4
Yes,White,2000,17,Female,Yes,Yes,1
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,Black,2000,24,Male,Yes,Yes,0
Yes,White,2001,26,Female,Yes,Yes,0
Yes,Black,2001,37,Male,Yes,No,2
Yes,Black,1998,21,Male,No,Yes,1
Yes,White,2000,20,Male,Yes,No,1
No,White,2000,44,Male,Yes,Yes,0
No,White,2000,21,Male,No,Yes,4
Yes,Black,1999,18,Male,Yes,Yes,0
Yes,White,1997,39,Male,No,Yes,2
Yes,White,1998,22,Male,Yes,Yes,1
Yes,White,2001,16,Male,Yes,Yes,4
No,Black,2002,20,Male,Yes,No,3
Yes,Black,2001,38,Female,No,Yes,3
Yes,White,2001,40,Male,Yes,Yes,4
Yes,White,2000,20,Female,Yes,Yes,2
Yes,White,2000,31,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1998,33,Male,Yes,Yes,1
No,Black,2001,39,Male,Yes,No,6
Yes,Black,2001,18,Male,No,Yes,1
Yes,Black,2000,23,Male,Yes,Yes,1
Yes,Black,1999,19,Female,No,Yes,0
Yes,White,1999,30,Male,Yes,Yes,3
Yes,White,1997,20,Male,Yes,Yes,4
Yes,White,2001,30,Male,No,Yes,1
Yes,White,2001,47,Male,Yes,Yes,0
No,White,1999,28,Male,Yes,Yes,0
Yes,White,1998,15,Male,Yes,Yes,3
Yes,White,1997,21,Male,Yes,No,0
No,Black,1997,16,Male,No,No,0
Yes,White,1997,17,Male,Yes,No,0
Yes,White,1998,16,Female,Yes,Yes,0
Yes,White,2000,16,Male,No,Yes,2
Yes,White,2000,22,Male,Yes,Yes,4
Yes,White,2002,16,Male,Yes,Yes,1
No,White,2001,40,Male,Yes,Yes,2
Yes,White,2000,16,Female,Yes,Yes,0
Yes,White,1999,36,Male,Yes,Yes,3
Yes,White,2000,14,Male,Yes,Yes,0
Yes,White,2000,26,Male,Yes,Yes,0
Yes,White,1999,30,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2000,19,Male,No,Yes,0
No,White,1997,19,Male,Yes,Yes,3
Yes,White,2001,21,Male,No,Yes,4
Yes,Black,2001,27,Male,Yes,Yes,4
Yes,White,1999,29,Male,No,Yes,4
Yes,Black,1998,23,Male,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,4
Yes,White,2001,23,Male,Yes,Yes,2
Yes,White,2000,33,Male,Yes,Yes,0
Yes,White,1997,20,Male,Yes,No,3
No,Black,2001,20,Male,Yes,Yes,0
Yes,White,1999,26,Male,Yes,Yes,2
Yes,White,2001,17,Female,Yes,Yes,0
No,Black,2001,16,Male,Yes,No,1
Yes,Black,2000,26,Male,Yes,Yes,2
Yes,White,1998,15,Male,Yes,Yes,4
No,White,1997,24,Male,Yes,No,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,4
Yes,White,1997,20,Male,Yes,Yes,1
Yes,White,1999,18,Male,Yes,Yes,4
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,4
Yes,White,1999,39,Female,Yes,Yes,0
Yes,Black,2001,16,Male,Yes,Yes,4
Yes,White,1999,24,Male,Yes,Yes,4
Yes,Black,1997,40,Male,Yes,No,3
No,White,2002,20,Male,No,Yes,3
Yes,White,2000,19,Male,No,Yes,2
Yes,White,2001,14,Male,Yes,Yes,2
Yes,Black,1999,18,Female,No,Yes,3
Yes,Black,1999,20,Male,Yes,No,2
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,2000,28,Male,Yes,Yes,0
No,White,2000,33,Male,Yes,Yes,3
Yes,White,1998,15,Male,Yes,Yes,0
No,Black,1998,24,Male,No,Yes,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
No,White,1999,28,Male,Yes,Yes,3
Yes,White,1999,20,Male,No,Yes,4
Yes,White,2001,16,Male,Yes,Yes,3
Yes,White,2001,20,Male,Yes,Yes,2
No,Black,2001,23,Male,Yes,Yes,2
No,Black,2000,23,Male,No,Yes,4
Yes,White,2001,34,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,2001,26,Male,Yes,Yes,0
No,Black,1998,19,Male,No,No,3
No,White,1999,37,Female,No,Yes,3
Yes,White,2001,20,Male,Yes,Yes,3
Yes,White,2001,25,Male,No,Yes,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,3
Yes,Black,1999,20,Male,Yes,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,1
Yes,White,2001,20,Male,Yes,Yes,1
No,White,1999,21,Male,Yes,Yes,4
No,Black,2002,24,Male,No,Yes,3
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,2002,21,Male,No,Yes,1
Yes,Black,1997,29,Male,No,No,2
Yes,White,1998,22,Male,Yes,No,1
No,White,1997,27,Male,Yes,No,0
No,Black,1999,21,Male,Yes,Yes,2
Yes,Black,2001,18,Male,Yes,Yes,3
Yes,White,1999,33,Male,Yes,Yes,3
Yes,White,1997,16,Male,No,No,0
No,White,1999,19,Male,Yes,Yes,3
Yes,Black,2001,16,Male,Yes,Yes,1
Yes,White,1997,18,Female,Yes,No,0
Yes,White,2002,18,Male,Yes,Yes,1
Yes,Black,2001,17,Male,Yes,Yes,1
No,Black,1997,19,Male,No,No,4
Yes,White,1997,20,Female,Yes,No,0
Yes,Black,1997,15,Male,Yes,No,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,Black,1999,23,Male,Yes,No,2
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,21,Male,No,Yes,0
Yes,Black,1998,19,Male,No,Yes,4
No,Black,1999,15,Male,Yes,Yes,5
Yes,White,1999,19,Male,Yes,Yes,0
Yes,Black,2000,16,Male,Yes,No,0
Yes,White,2000,21,Male,Yes,Yes,1
Yes,Black,2002,20,Male,No,No,4
Yes,White,1999,29,Male,Yes,Yes,0
Yes,Black,1999,24,Male,Yes,Yes,2
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,3
Yes,White,1999,29,Male,Yes,Yes,0
Yes,White,2000,28,Male,Yes,Yes,3
No,White,1998,22,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,2
Yes,White,1998,19,Male,Yes,Yes,2
No,White,1999,25,Male,No,Yes,2
Yes,White,1998,38,Male,Yes,Yes,0
Yes,White,1998,25,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,1999,16,Male,Yes,Yes,1
No,Black,2000,19,Male,No,No,4
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,1999,17,Female,Yes,Yes,0
Yes,Black,1998,22,Female,Yes,Yes,0
No,Black,2000,17,Male,Yes,Yes,4
Yes,Black,2001,20,Male,No,No,1
Yes,White,1999,17,Male,Yes,Yes,2
Yes,White,1998,30,Male,Yes,Yes,3
Yes,White,1998,22,Male,Yes,Yes,0
No,White,1999,16,Male,No,Yes,4
Yes,White,1997,17,Male,Yes,Yes,1
Yes,White,2000,23,Male,Yes,Yes,0
No,White,2000,21,Male,Yes,Yes,1
No,White,1998,16,Male,No,Yes,4
Yes,White,2001,24,Male,Yes,Yes,4
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2000,21,Male,No,Yes,0
Yes,Black,1997,27,Male,Yes,Yes,2
Yes,White,1999,17,Male,Yes,Yes,0
No,White,1999,19,Male,No,Yes,4
Yes,White,2001,38,Male,No,Yes,3
Yes,White,1998,19,Male,Yes,Yes,2
No,Black,2001,26,Male,No,No,2
Yes,White,2000,31,Male,Yes,Yes,4
Yes,White,1997,21,Male,No,No,4
Yes,White,1999,19,Male,Yes,No,1
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,0
No,Black,2000,21,Male,No,Yes,5
Yes,White,2000,24,Male,Yes,Yes,3
Yes,Black,1999,24,Male,Yes,Yes,5
Yes,White,2001,17,Male,No,Yes,1
Yes,White,1999,48,Male,No,Yes,4
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,1
No,White,1997,17,Male,No,No,4
No,White,2001,18,Female,Yes,Yes,0
No,White,2001,18,Female,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,0
Yes,Black,2001,20,Male,Yes,Yes,2
Yes,Black,2000,47,Male,Yes,Yes,1
Yes,White,1997,44,Male,No,No,3
No,Black,1999,22,Male,No,Yes,3
Yes,White,1998,19,Female,Yes,Yes,0
Yes,White,2002,24,Male,No,Yes,4
Yes,White,1997,26,Male,Yes,No,0
No,White,2001,40,Female,No,Yes,4
Yes,White,2000,19,Female,Yes,Yes,3
Yes,Black,2001,25,Male,Yes,Yes,3
Yes,White,1998,31,Male,Yes,Yes,3
Yes,Black,1998,24,Male,Yes,Yes,0
Yes,White,2000,22,Male,No,Yes,2
Yes,White,2001,19,Male,Yes,Yes,0
Yes,Black,1999,22,Male,Yes,Yes,3
No,White,2000,28,Male,Yes,Yes,4
Yes,Black,1999,23,Male,No,Yes,3
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,1997,26,Male,Yes,No,4
Yes,Black,2001,18,Male,Yes,Yes,3
No,Black,2001,19,Male,Yes,Yes,2
No,White,1999,43,Male,No,Yes,4
Yes,White,2001,20,Male,Yes,Yes,1
Yes,Black,1998,22,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2000,22,Female,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,2000,27,Male,Yes,Yes,2
No,White,2002,27,Male,Yes,Yes,4
Yes,White,1999,33,Male,Yes,Yes,3
Yes,White,2000,25,Male,Yes,Yes,4
Yes,White,2001,26,Male,Yes,Yes,2
Yes,White,1998,18,Male,Yes,Yes,2
Yes,White,1999,34,Male,Yes,Yes,5
Yes,White,1997,19,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,1998,15,Female,Yes,Yes,0
Yes,Black,2000,26,Male,Yes,No,1
No,White,1999,32,Male,No,Yes,2
Yes,White,1999,18,Male,Yes,No,0
Yes,White,1999,35,Male,Yes,Yes,3
Yes,White,1997,22,Female,Yes,Yes,0
Yes,Black,1997,51,Male,No,No,3
Yes,Black,1999,33,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,1999,19,Male,No,Yes,4
Yes,Black,1998,19,Female,Yes,Yes,0
Yes,White,1998,22,Male,Yes,No,0
Yes,White,2001,20,Male,No,Yes,0
No,White,1998,20,Male,Yes,Yes,2
Yes,White,2000,15,Male,Yes,Yes,4
Yes,White,2002,26,Male,Yes,Yes,1
Yes,White,1997,27,Female,Yes,Yes,0
No,White,1999,16,Male,Yes,Yes,0
Yes,White,2000,20,Female,Yes,Yes,0
Yes,White,1999,27,Male,Yes,Yes,2
Yes,Black,1999,18,Female,No,Yes,0
No,White,1999,23,Male,No,Yes,3
Yes,Black,1999,20,Male,Yes,Yes,2
Yes,Black,2002,32,Male,Yes,Yes,1
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1998,18,Male,No,Yes,4
Yes,White,2001,23,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2000,40,Male,Yes,Yes,0
Yes,Black,2001,61,Male,Yes,Yes,3
Yes,Black,1998,23,Male,Yes,Yes,3
Yes,Black,2000,49,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,2
No,White,1998,18,Male,Yes,Yes,5
Yes,White,2000,32,Male,No,Yes,2
Yes,White,2001,17,Male,Yes,Yes,0
No,Black,1997,22,Male,No,No,1
Yes,White,1999,16,Female,Yes,Yes,0
Yes,White,2002,15,Male,Yes,Yes,0
Yes,White,2001,45,Male,No,Yes,4
Yes,Black,2000,21,Male,No,Yes,1
Yes,White,1999,18,Male,No,Yes,1
Yes,White,2001,22,Male,Yes,Yes,0
Yes,Black,1999,24,Male,Yes,Yes,0
Yes,White,2000,19,Male,No,Yes,0
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,1999,30,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
No,White,1999,43,Male,No,Yes,3
Yes,White,1999,28,Male,Yes,Yes,4
Yes,White,2000,39,Male,No,Yes,0
Yes,Black,2001,21,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2002,19,Male,Yes,Yes,3
Yes,Black,1998,23,Male,No,Yes,2
Yes,White,2001,41,Male,Yes,Yes,0
Yes,Black,2001,21,Male,Yes,No,0
Yes,Black,2000,22,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,0
Yes,White,1998,35,Male,Yes,Yes,3
Yes,Black,2001,21,Male,Yes,Yes,5
Yes,White,2001,26,Male,Yes,Yes,3
Yes,Black,2001,25,Male,Yes,Yes,1
Yes,White,2000,20,Female,Yes,Yes,0
Yes,Black,2001,30,Male,No,No,3
Yes,White,1999,19,Male,Yes,Yes,2
Yes,White,1997,25,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2000,20,Female,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,5
Yes,White,1998,23,Male,No,Yes,2
Yes,White,1999,29,Male,Yes,Yes,2
Yes,Black,2001,18,Male,Yes,Yes,2
No,White,2001,25,Male,Yes,No,0
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,2
No,White,1998,21,Male,No,Yes,4
Yes,Black,1999,20,Male,Yes,No,0
No,White,1999,27,Male,Yes,Yes,2
Yes,White,1999,20,Male,No,Yes,4
Yes,White,1997,20,Male,Yes,Yes,1
Yes,White,1999,28,Male,Yes,Yes,4
Yes,White,2000,42,Male,Yes,Yes,4
No,Black,1999,24,Male,Yes,Yes,4
Yes,White,2002,16,Male,Yes,No,0
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1998,27,Female,Yes,Yes,0
Yes,Black,1999,30,Male,Yes,Yes,4
No,Black,1998,22,Male,Yes,Yes,3
Yes,White,2001,26,Male,Yes,Yes,0
Yes,White,2002,18,Male,Yes,Yes,2
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,1998,26,Male,Yes,Yes,1
No,Black,2001,31,Male,Yes,Yes,4
Yes,Black,2000,19,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,1
Yes,White,2000,28,Female,Yes,Yes,1
Yes,White,1998,20,Male,Yes,Yes,3
Yes,Black,2000,23,Male,Yes,No,4
No,White,2000,16,Male,Yes,Yes,3
Yes,White,2002,21,Male,No,No,1
Yes,White,2001,17,Male,No,Yes,4
Yes,White,1998,14,Male,No,Yes,1
No,Black,2001,15,Male,No,No,4
Yes,White,1999,17,Male,Yes,Yes,3
Yes,Black,1999,25,Male,Yes,Yes,0
Yes,White,1999,21,Female,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,2001,25,Male,Yes,Yes,3
Yes,White,1997,27,Male,Yes,No,0
Yes,White,2000,34,Male,No,Yes,4
Yes,White,2000,25,Male,Yes,Yes,0
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,1999,43,Male,No,Yes,5
Yes,White,2001,17,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2000,29,Female,Yes,Yes,0
Yes,White,1998,17,Female,Yes,Yes,3
Yes,Black,1998,23,Male,Yes,Yes,4
Yes,Black,1999,19,Male,Yes,No,6
Yes,Black,2000,37,Male,Yes,Yes,0
Yes,White,1999,43,Male,No,Yes,3
Yes,White,1997,34,Male,Yes,Yes,2
Yes,White,1999,45,Male,Yes,Yes,2
Yes,Black,2002,15,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,1
Yes,Black,1998,44,Male,No,Yes,0
Yes,White,1997,17,Male,Yes,No,0
Yes,Black,1998,15,Female,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,2
Yes,White,1999,38,Female,Yes,Yes,4
Yes,Black,2000,18,Male,Yes,Yes,0
No,White,2001,21,Male,No,Yes,3
No,White,2001,15,Male,Yes,Yes,2
Yes,White,2000,21,Female,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,2
Yes,White,1998,22,Male,Yes,Yes,4
Yes,Black,1999,25,Male,No,Yes,3
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,18,Female,Yes,Yes,0
No,White,2001,30,Male,Yes,Yes,0
Yes,White,1997,27,Male,Yes,Yes,1
Yes,White,2000,14,Male,Yes,Yes,1
Yes,Black,1997,23,Male,Yes,No,4
Yes,White,2001,44,Male,Yes,No,3
Yes,Black,1998,28,Male,Yes,Yes,2
Yes,Black,1999,19,Male,Yes,Yes,2
Yes,White,2001,24,Male,Yes,Yes,1
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,0
Yes,Black,1999,18,Male,Yes,Yes,2
Yes,Black,1999,22,Male,Yes,No,3
Yes,White,2001,24,Male,No,Yes,4
Yes,White,2001,16,Male,Yes,Yes,0
Yes,Black,1998,40,Male,Yes,Yes,5
Yes,White,2000,17,Male,No,Yes,2
Yes,White,1998,18,Male,Yes,Yes,2
Yes,White,1999,17,Male,Yes,Yes,0
Yes,Black,1998,36,Male,No,Yes,1
Yes,Black,1998,36,Male,No,Yes,3
No,Black,2001,47,Female,No,No,2
No,White,2001,37,Male,Yes,Yes,3
Yes,White,1998,36,Male,Yes,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1998,34,Male,Yes,Yes,5
Yes,White,1999,19,Male,Yes,Yes,1
Yes,Black,2001,20,Male,Yes,No,2
Yes,White,1998,27,Male,Yes,Yes,3
Yes,White,1998,38,Male,No,Yes,1
No,White,2001,48,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,3
Yes,White,1998,35,Male,Yes,Yes,2
No,White,1999,39,Male,No,Yes,0
Yes,White,2001,16,Male,Yes,Yes,0
Yes,Black,1999,37,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,3
Yes,White,1999,37,Male,Yes,Yes,3
No,Black,1998,37,Male,Yes,No,0
No,Black,1997,24,Male,No,No,3
Yes,White,1997,19,Male,Yes,Yes,4
Yes,White,1997,19,Male,Yes,No,0
Yes,White,1999,31,Male,Yes,Yes,1
Yes,White,1998,49,Male,Yes,Yes,0
Yes,White,2002,22,Male,Yes,Yes,0
Yes,White,1999,27,Male,No,Yes,4
Yes,White,2000,23,Male,Yes,Yes,2
No,White,1997,30,Male,No,Yes,2
Yes,White,1998,20,Male,Yes,Yes,1
No,White,2000,16,Male,Yes,Yes,0
Yes,Black,1999,23,Male,Yes,Yes,0
No,White,1998,26,Male,Yes,Yes,1
Yes,Black,1999,21,Male,No,Yes,3
Yes,White,1997,19,Male,No,Yes,2
No,White,1999,17,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,0
No,White,1999,20,Male,Yes,Yes,4
Yes,White,1998,41,Male,Yes,Yes,2
Yes,White,1998,36,Male,Yes,Yes,0
Yes,Black,2001,24,Male,Yes,Yes,2
No,Black,1998,23,Male,Yes,Yes,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,Black,2002,18,Male,Yes,Yes,0
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,White,2002,25,Male,Yes,Yes,0
Yes,White,2001,36,Male,Yes,Yes,3
Yes,White,2001,44,Male,Yes,Yes,1
Yes,White,1999,15,Male,Yes,Yes,1
Yes,White,2002,21,Male,No,Yes,2
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,2000,16,Female,Yes,Yes,1
Yes,Black,2001,20,Male,No,Yes,4
Yes,White,2002,18,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,2000,25,Male,Yes,Yes,1
No,White,1998,36,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,2
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,2002,31,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,3
Yes,White,2002,21,Male,Yes,Yes,2
Yes,White,1998,15,Female,Yes,Yes,0
Yes,Black,2000,36,Male,Yes,No,2
Yes,Black,1997,20,Male,Yes,No,4
No,White,2000,19,Male,Yes,No,2
Yes,White,1999,48,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,2002,20,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,2
Yes,White,2000,26,Male,Yes,Yes,1
No,Black,1997,17,Male,Yes,No,3
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,34,Male,No,Yes,3
Yes,White,2001,36,Male,Yes,Yes,1
Yes,Black,1998,18,Male,Yes,No,3
Yes,Black,2000,24,Male,No,No,0
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,1999,16,Male,No,Yes,3
Yes,White,1999,22,Male,Yes,Yes,1
Yes,White,2000,21,Female,Yes,Yes,0
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,Black,2000,24,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,3
No,White,2001,17,Male,Yes,Yes,4
Yes,Black,2000,19,Male,Yes,Yes,2
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,3
Yes,White,1998,19,Male,Yes,Yes,1
Yes,White,1998,27,Female,No,Yes,4
Yes,White,1997,22,Male,Yes,No,1
Yes,White,1999,34,Male,Yes,Yes,0
Yes,White,2001,29,Male,Yes,Yes,3
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
No,Black,1999,20,Male,Yes,No,3
Yes,Black,2001,20,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,2000,15,Male,Yes,Yes,3
No,Black,1998,18,Male,No,No,2
No,Black,1997,35,Male,Yes,No,3
No,Black,1999,18,Male,Yes,Yes,2
Yes,Black,2001,59,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
No,White,2001,37,Male,Yes,Yes,3
Yes,Black,1998,21,Male,Yes,Yes,3
Yes,Black,1998,25,Male,Yes,Yes,2
Yes,Black,1997,20,Male,Yes,No,0
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,1998,20,Male,Yes,Yes,3
Yes,Black,1997,20,Male,No,No,2
Yes,White,2000,45,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
No,Black,2001,27,Male,Yes,No,2
Yes,White,2001,31,Male,Yes,Yes,0
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1999,42,Female,Yes,Yes,0
Yes,White,2000,37,Female,No,Yes,3
Yes,White,1998,34,Male,Yes,No,0
Yes,Black,2001,25,Male,Yes,Yes,2
Yes,Black,2000,30,Female,Yes,Yes,3
Yes,Black,2001,29,Male,Yes,Yes,0
Yes,Black,2001,36,Male,Yes,Yes,2
Yes,White,1999,20,Male,No,Yes,2
No,White,2001,28,Male,Yes,No,0
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,1998,16,Male,Yes,Yes,1
Yes,White,1999,22,Male,No,Yes,4
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,2002,35,Female,No,Yes,2
No,Black,1998,30,Female,No,Yes,3
Yes,White,2001,19,Male,No,Yes,2
Yes,White,1997,19,Male,Yes,No,2
Yes,White,1999,15,Male,Yes,Yes,0
No,White,2002,25,Male,No,Yes,0
Yes,White,1997,30,Male,Yes,Yes,4
Yes,White,1999,16,Female,Yes,Yes,0
Yes,White,1999,39,Male,Yes,Yes,0
Yes,White,2001,16,Male,No,Yes,3
No,White,2001,15,Male,Yes,Yes,3
Yes,White,1999,21,Male,Yes,No,0
Yes,Black,1997,30,Male,Yes,Yes,3
Yes,White,2000,16,Male,Yes,Yes,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,4
Yes,Black,2001,19,Male,Yes,Yes,1
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,4
No,Black,2000,17,Male,No,No,2
Yes,White,1999,22,Male,Yes,Yes,0
Yes,Black,1998,17,Female,Yes,Yes,0
No,White,1998,18,Male,Yes,No,0
Yes,White,2000,22,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,No,3
Yes,White,1999,21,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,0
Yes,Black,1999,37,Male,No,No,1
Yes,White,2000,18,Male,Yes,Yes,2
Yes,White,2001,24,Male,Yes,Yes,1
Yes,White,1998,20,Male,No,No,4
Yes,White,2000,35,Male,Yes,Yes,0
Yes,White,2001,40,Male,Yes,Yes,0
No,White,1999,21,Male,Yes,Yes,2
Yes,White,2000,25,Male,No,Yes,3
Yes,Black,2002,19,Male,No,Yes,4
Yes,White,1999,23,Male,Yes,Yes,3
Yes,White,1998,31,Male,Yes,Yes,0
Yes,White,2001,17,Female,Yes,Yes,4
No,Black,1999,38,Male,Yes,Yes,4
Yes,White,1998,19,Male,No,Yes,2
Yes,Black,1997,18,Male,No,No,5
Yes,White,2001,19,Male,No,Yes,0
No,White,1999,20,Male,Yes,Yes,0
No,White,2001,17,Male,No,Yes,5
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1999,34,Male,Yes,Yes,4
Yes,White,1997,24,Male,Yes,No,3
No,White,2000,15,Male,Yes,Yes,4
Yes,White,1997,27,Male,No,No,3
Yes,White,2001,20,Male,No,Yes,3
No,White,2001,18,Male,Yes,Yes,0
No,Black,1999,32,Male,Yes,Yes,4
Yes,White,1999,20,Male,Yes,Yes,4
Yes,White,1999,19,Male,Yes,Yes,0
Yes,Black,1997,16,Male,Yes,No,0
Yes,White,2000,52,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1997,18,Male,Yes,No,0
Yes,White,1997,16,Male,Yes,No,0
No,Black,2000,21,Male,No,No,3
Yes,Black,2000,45,Male,Yes,No,1
No,Black,2001,17,Female,Yes,Yes,0
Yes,White,1998,40,Male,Yes,Yes,1
Yes,White,1998,18,Male,Yes,Yes,0
Yes,Black,1998,31,Male,Yes,Yes,1
Yes,White,2000,18,Female,No,Yes,2
Yes,White,1999,16,Male,No,Yes,1
Yes,White,2000,20,Male,Yes,Yes,0
Yes,Black,2001,20,Male,Yes,No,0
Yes,White,2001,25,Male,Yes,Yes,0
Yes,Black,1997,17,Male,Yes,Yes,4
Yes,White,2002,56,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,1998,19,Male,Yes,Yes,4
Yes,White,1997,18,Male,Yes,No,5
Yes,Black,1999,23,Male,Yes,Yes,0
No,White,2000,27,Male,No,Yes,4
Yes,White,1998,22,Male,Yes,Yes,4
Yes,White,1999,51,Male,Yes,Yes,4
No,Black,1998,15,Male,Yes,Yes,5
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,1999,22,Male,Yes,Yes,2
Yes,Black,2001,27,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,1
Yes,Black,2002,17,Male,Yes,Yes,1
Yes,White,1999,25,Male,No,Yes,0
No,White,1999,14,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,No,0
Yes,White,2000,25,Male,Yes,Yes,2
Yes,White,1997,15,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,Black,2000,16,Male,Yes,No,0
No,White,1998,19,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
No,White,1998,32,Male,No,Yes,4
Yes,Black,1997,27,Male,Yes,Yes,0
Yes,White,2001,30,Male,Yes,Yes,0
No,Black,1998,23,Male,Yes,Yes,3
Yes,White,2001,20,Male,Yes,Yes,2
Yes,White,2000,22,Male,Yes,Yes,0
Yes,Black,1999,20,Male,No,No,0
Yes,Black,1998,15,Male,No,Yes,5
Yes,White,1998,19,Male,No,Yes,0
Yes,White,2000,19,Male,Yes,Yes,1
Yes,Black,2000,17,Male,No,Yes,1
Yes,Black,1999,19,Female,Yes,Yes,0
Yes,White,1999,17,Male,No,Yes,1
Yes,Black,1998,37,Male,Yes,Yes,3
Yes,White,2002,19,Male,Yes,Yes,2
Yes,White,1997,21,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,1999,21,Male,No,Yes,0
No,Black,1998,21,Male,No,No,3
Yes,Black,1998,25,Male,Yes,No,2
Yes,Black,2000,37,Female,No,Yes,2
No,Black,1999,27,Male,Yes,Yes,3
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,2
Yes,White,1997,19,Male,Yes,Yes,3
Yes,White,1999,40,Male,Yes,Yes,3
Yes,Black,2000,38,Male,No,Yes,4
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,2000,28,Male,Yes,Yes,3
Yes,Black,1999,25,Male,Yes,No,0
No,Black,2001,18,Male,No,Yes,2
Yes,White,1999,20,Male,Yes,Yes,1
Yes,White,2000,16,Male,Yes,Yes,1
Yes,Black,2000,13,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,4
Yes,Black,2001,21,Male,No,Yes,3
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,1998,40,Male,Yes,Yes,1
Yes,White,2000,39,Male,Yes,No,2
Yes,White,2001,28,Male,No,Yes,0
Yes,White,1997,21,Female,Yes,Yes,1
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,2001,20,Male,Yes,Yes,2
Yes,White,2002,14,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,3
Yes,White,1998,26,Male,Yes,Yes,0
Yes,Black,2000,23,Male,No,Yes,4
Yes,White,1999,45,Male,No,Yes,0
Yes,Black,1999,25,Male,No,Yes,3
Yes,White,2001,22,Male,Yes,Yes,2
Yes,White,1998,22,Female,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1998,20,Male,No,Yes,0
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,2001,23,Male,No,Yes,0
Yes,White,1999,34,Male,Yes,Yes,1
Yes,Black,2000,52,Female,No,No,3
Yes,Black,1999,19,Male,No,Yes,1
Yes,White,1999,20,Male,Yes,No,0
Yes,White,2000,33,Male,Yes,Yes,0
Yes,White,1997,18,Male,No,No,3
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2001,39,Male,Yes,Yes,2
Yes,White,1998,20,Male,No,Yes,3
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2001,26,Male,Yes,Yes,5
No,White,1999,20,Male,Yes,Yes,0
No,White,1999,20,Male,Yes,Yes,4
Yes,White,1998,21,Male,Yes,Yes,1
Yes,White,1999,21,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2001,24,Female,Yes,Yes,0
No,White,2001,32,Male,No,Yes,3
Yes,White,2000,22,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,1998,26,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,4
Yes,White,1998,36,Male,Yes,Yes,3
Yes,Black,2000,32,Male,Yes,No,4
Yes,Black,2001,21,Male,Yes,Yes,2
Yes,White,2000,25,Male,Yes,Yes,0
No,White,2002,37,Male,Yes,Yes,2
No,White,1997,12,Male,Yes,No,5
Yes,White,1999,19,Male,Yes,Yes,4
No,White,2000,39,Male,No,Yes,4
Yes,White,1998,19,Male,No,Yes,3
No,White,1997,18,Female,No,No,0
Yes,White,2000,23,Male,Yes,Yes,4
Yes,White,1998,34,Male,Yes,Yes,2
Yes,White,1997,18,Male,Yes,No,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1998,48,Female,Yes,Yes,0
No,White,1997,17,Male,Yes,No,1
Yes,White,1997,19,Male,Yes,No,0
Yes,White,1998,17,Male,Yes,Yes,3
Yes,White,1999,23,Male,Yes,Yes,0
Yes,White,2001,13,Female,Yes,Yes,0
Yes,White,1999,31,Male,Yes,Yes,1
Yes,White,1998,18,Male,No,Yes,1
No,White,1998,19,Male,No,Yes,4
No,Black,2000,21,Male,No,Yes,1
Yes,Black,1998,27,Male,Yes,Yes,3
Yes,White,1999,24,Male,Yes,Yes,3
Yes,White,2002,33,Male,Yes,Yes,0
Yes,White,1997,19,Female,Yes,No,1
Yes,White,1998,19,Male,Yes,Yes,5
Yes,Black,2002,22,Male,No,Yes,0
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
No,White,2001,19,Male,Yes,Yes,2
Yes,White,1997,19,Male,Yes,Yes,4
No,Black,1998,20,Male,No,Yes,1
Yes,White,2001,15,Female,Yes,Yes,0
Yes,White,2000,32,Male,Yes,Yes,1
No,White,2001,16,Male,No,Yes,3
Yes,White,2000,19,Male,Yes,No,0
Yes,Black,2001,23,Male,Yes,Yes,0
Yes,Black,2001,15,Male,No,No,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,20,Male,No,Yes,0
Yes,Black,2001,19,Male,Yes,Yes,2
Yes,White,1998,21,Male,Yes,No,1
Yes,White,2001,19,Male,No,No,0
Yes,White,2000,26,Male,Yes,Yes,0
Yes,White,1999,25,Male,Yes,Yes,1
Yes,White,2002,33,Male,Yes,Yes,2
Yes,White,2001,20,Male,Yes,Yes,1
Yes,Black,2000,36,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,0
Yes,Black,1999,36,Male,Yes,No,1
Yes,White,2000,27,Male,Yes,Yes,1
No,White,1998,16,Male,No,No,3
Yes,White,1998,17,Male,Yes,Yes,5
No,Black,1997,21,Male,No,No,4
Yes,White,1998,28,Male,Yes,Yes,2
No,White,1998,17,Male,Yes,Yes,4
No,Black,1999,24,Male,No,Yes,3
Yes,White,1997,17,Male,Yes,Yes,0
Yes,White,2001,23,Female,Yes,Yes,0
No,White,2001,19,Male,Yes,Yes,3
Yes,White,2002,19,Male,Yes,Yes,1
Yes,White,1997,17,Male,Yes,No,0
No,White,2001,21,Male,Yes,Yes,1
Yes,Black,1999,28,Male,No,Yes,3
No,Black,2002,18,Male,Yes,Yes,1
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1997,31,Male,Yes,Yes,3
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1998,44,Female,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,3
Yes,White,1997,31,Female,Yes,No,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,1
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,1999,14,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,No,0
Yes,White,2000,23,Male,Yes,Yes,2
No,White,1997,33,Male,Yes,Yes,3
Yes,White,1997,34,Male,No,No,4
Yes,White,1997,17,Male,Yes,Yes,3
Yes,White,2002,20,Male,Yes,Yes,0
Yes,White,2000,18,Female,Yes,Yes,0
No,White,1999,33,Male,No,Yes,3
No,White,1997,23,Male,No,No,4
No,White,2000,22,Male,Yes,No,4
Yes,White,1999,28,Male,Yes,No,0
Yes,White,1999,45,Male,Yes,Yes,0
No,White,2001,17,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,1
No,White,2001,16,Male,Yes,Yes,2
Yes,White,1998,37,Male,No,Yes,3
Yes,Black,2001,21,Male,No,Yes,2
Yes,White,2000,21,Male,No,Yes,0
Yes,White,1998,20,Male,Yes,Yes,3
Yes,Black,2002,35,Male,Yes,Yes,0
Yes,Black,2001,38,Male,Yes,No,3
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1999,23,Male,No,Yes,1
Yes,Black,1999,17,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,4
Yes,Black,1997,27,Male,Yes,No,0
Yes,White,2002,26,Male,Yes,Yes,3
Yes,White,1997,32,Male,No,No,2
No,Black,1998,28,Male,Yes,No,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,2001,22,Male,No,Yes,3
Yes,White,2001,17,Male,Yes,Yes,4
Yes,White,1998,14,Male,Yes,Yes,1
Yes,White,1999,17,Male,Yes,Yes,2
Yes,White,2001,35,Male,Yes,Yes,3
Yes,White,2001,19,Female,Yes,Yes,1
Yes,Black,2002,19,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,2
Yes,White,2000,19,Male,No,Yes,3
Yes,White,2000,24,Male,Yes,Yes,1
Yes,Black,1999,20,Male,Yes,Yes,0
Yes,White,2000,13,Male,Yes,Yes,0
Yes,White,2002,16,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2002,21,Male,No,No,3
Yes,White,1997,19,Male,Yes,No,0
Yes,White,1997,19,Male,Yes,No,0
Yes,White,1998,24,Male,No,Yes,2
Yes,White,2000,18,Male,Yes,Yes,2
Yes,White,2000,33,Male,No,Yes,3
Yes,White,1997,20,Male,Yes,No,0
Yes,White,1997,17,Male,Yes,No,4
Yes,White,2000,25,Male,No,Yes,0
Yes,White,1999,29,Male,Yes,Yes,4
Yes,Black,2000,16,Male,Yes,Yes,1
Yes,White,2001,27,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,33,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
Yes,Black,2000,17,Male,Yes,Yes,1
Yes,White,1999,24,Male,Yes,Yes,2
Yes,White,2000,22,Male,Yes,Yes,0
No,White,1998,19,Male,Yes,Yes,5
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,1999,15,Male,Yes,Yes,3
Yes,White,1997,25,Male,No,No,3
Yes,White,1999,16,Female,Yes,Yes,0
Yes,Black,1998,19,Male,Yes,Yes,2
No,Black,1997,17,Male,No,No,4
Yes,White,2001,23,Male,No,Yes,2
No,Black,2000,35,Male,Yes,No,2
Yes,White,2001,19,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,1
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,2
Yes,White,2001,40,Male,Yes,Yes,2
Yes,White,1999,20,Male,Yes,No,1
Yes,White,2002,29,Male,Yes,Yes,2
Yes,White,2000,22,Male,No,Yes,4
Yes,White,1999,39,Male,No,Yes,0
Yes,White,2001,19,Male,No,Yes,1
Yes,White,1999,45,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,2000,23,Male,Yes,Yes,1
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,1998,25,Male,Yes,Yes,1
Yes,Black,2002,27,Male,Yes,Yes,1
No,White,2001,22,Male,No,Yes,0
Yes,White,2001,15,Male,Yes,Yes,0
Yes,White,2001,37,Male,Yes,Yes,2
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,2002,25,Male,No,Yes,3
No,White,2002,20,Male,No,Yes,3
Yes,White,1997,19,Female,Yes,Yes,2
Yes,White,2002,18,Male,Yes,Yes,4
No,White,1998,16,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,1
Yes,Black,2000,22,Male,No,Yes,4
Yes,White,2000,23,Male,Yes,No,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,2001,53,Male,Yes,Yes,0
Yes,White,1999,22,Female,Yes,Yes,2
Yes,White,2001,30,Male,No,Yes,3
Yes,Black,1997,30,Male,Yes,No,2
Yes,White,1998,17,Male,Yes,Yes,2
Yes,Black,1997,31,Male,Yes,No,0
Yes,Black,1999,25,Male,Yes,Yes,0
Yes,White,2000,21,Female,Yes,Yes,1
No,White,1998,18,Male,Yes,Yes,4
Yes,Black,1999,30,Male,No,No,3
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,1998,20,Male,No,Yes,4
Yes,Black,2000,25,Male,No,No,1
Yes,Black,2000,42,Male,No,No,3
Yes,White,1998,20,Male,Yes,No,5
No,White,1998,24,Male,No,Yes,3
Yes,White,2000,25,Female,Yes,Yes,2
Yes,White,1999,22,Male,No,Yes,0
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,2001,18,Male,No,Yes,0
Yes,Black,2000,19,Male,Yes,No,1
Yes,White,1998,19,Male,Yes,Yes,4
Yes,White,2000,31,Male,Yes,Yes,2
Yes,White,1999,29,Male,Yes,Yes,0
Yes,White,1998,52,Female,Yes,Yes,1
No,White,2001,24,Male,Yes,Yes,2
Yes,White,2001,24,Male,No,Yes,0
No,White,2001,39,Male,No,Yes,4
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1998,45,Male,Yes,No,3
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,1
No,White,2000,38,Male,Yes,Yes,4
Yes,White,2002,21,Male,Yes,No,0
Yes,Black,1999,21,Male,Yes,Yes,0
Yes,Black,1998,22,Male,Yes,Yes,2
Yes,White,1997,13,Male,Yes,No,0
Yes,Black,1999,19,Male,Yes,Yes,0
Yes,White,1999,27,Male,No,Yes,3
No,Black,2001,17,Male,Yes,Yes,3
Yes,Black,1999,19,Male,Yes,Yes,3
Yes,White,1999,39,Male,Yes,No,0
Yes,White,2001,36,Male,Yes,Yes,0
Yes,White,1998,24,Male,Yes,Yes,3
Yes,White,1997,17,Male,Yes,Yes,0
Yes,White,2000,42,Male,No,Yes,3
No,White,1997,18,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,19,Male,No,Yes,0
Yes,White,2002,36,Male,Yes,Yes,0
Yes,Black,2001,35,Male,No,No,3
Yes,White,2002,17,Male,Yes,Yes,0
No,Black,1998,24,Male,No,No,3
No,White,2001,19,Male,Yes,Yes,0
Yes,White,1997,19,Male,Yes,No,0
Yes,White,2002,21,Male,Yes,Yes,1
No,Black,1998,20,Male,Yes,No,0
Yes,White,2001,19,Male,Yes,Yes,3
No,White,2000,19,Male,Yes,Yes,4
Yes,Black,2001,20,Male,Yes,Yes,1
No,White,1997,54,Male,Yes,No,0
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
No,White,1999,24,Female,No,Yes,4
Yes,White,1998,22,Female,No,Yes,0
Yes,Black,1999,20,Male,No,Yes,2
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,2002,18,Male,Yes,Yes,0
Yes,Black,2001,18,Male,Yes,Yes,1
Yes,White,1998,29,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
Yes,Black,2000,23,Male,Yes,Yes,4
Yes,White,1999,24,Male,Yes,Yes,2
Yes,White,1999,23,Male,Yes,Yes,0
No,Black,1999,19,Male,No,Yes,4
Yes,White,2000,38,Male,Yes,Yes,2
No,White,2000,19,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
No,Black,2001,18,Male,Yes,Yes,5
Yes,White,2000,18,Male,Yes,Yes,1
Yes,Black,1999,14,Male,Yes,Yes,4
Yes,Black,1997,33,Male,No,No,2
Yes,Black,2001,25,Male,Yes,Yes,3
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,1
Yes,White,1998,20,Male,Yes,Yes,5
Yes,Black,2001,16,Male,Yes,Yes,1
Yes,White,2000,22,Male,Yes,Yes,3
Yes,White,2000,27,Male,Yes,Yes,3
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2000,32,Male,Yes,Yes,1
Yes,White,2000,22,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,1
No,Black,1998,23,Male,Yes,Yes,1
Yes,Black,2001,18,Male,Yes,Yes,1
Yes,White,1999,28,Male,Yes,Yes,4
Yes,Black,2001,27,Male,Yes,No,3
Yes,White,2002,21,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,No,0
Yes,White,1998,15,Male,Yes,Yes,2
Yes,White,1999,27,Male,Yes,Yes,3
Yes,Black,1997,43,Male,Yes,No,1
Yes,White,1998,22,Male,Yes,Yes,5
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,Yes,1
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,1997,18,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
No,White,2001,45,Male,No,Yes,1
No,Black,1999,20,Male,No,No,4
Yes,White,1997,15,Male,Yes,No,2
Yes,White,1998,21,Male,Yes,Yes,2
Yes,White,1998,16,Male,Yes,Yes,4
No,Black,1998,20,Male,Yes,Yes,4
No,White,2001,16,Male,Yes,Yes,3
No,White,2000,26,Female,No,Yes,2
Yes,White,2001,32,Male,Yes,Yes,0
Yes,White,1999,34,Female,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,4
Yes,White,1997,20,Male,Yes,No,3
Yes,Black,1999,17,Male,Yes,Yes,1
Yes,White,1999,36,Male,Yes,Yes,2
No,White,2000,13,Female,Yes,Yes,1
Yes,Black,2000,25,Male,Yes,Yes,0
No,Black,2000,35,Male,Yes,No,2
No,White,1999,27,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,1
No,White,1998,38,Male,No,Yes,3
No,Black,1999,26,Female,Yes,Yes,4
Yes,White,2000,23,Male,Yes,Yes,0
Yes,Black,2001,40,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,1999,19,Female,Yes,Yes,0
Yes,Black,2001,39,Male,Yes,No,3
Yes,Black,1999,19,Male,Yes,Yes,3
Yes,Black,1999,40,Male,No,Yes,3
Yes,White,2000,39,Male,Yes,Yes,2
Yes,White,2001,30,Male,No,No,3
Yes,White,1998,23,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,1
No,White,2001,21,Male,Yes,No,0
Yes,White,1997,16,Male,Yes,Yes,0
No,White,2001,29,Male,Yes,Yes,1
Yes,Black,1999,26,Male,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2001,37,Male,No,Yes,4
Yes,White,1997,35,Male,Yes,No,3
Yes,White,2000,23,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,2001,21,Male,Yes,Yes,1
No,White,2000,29,Male,Yes,Yes,5
Yes,White,2001,21,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,1997,17,Male,Yes,No,5
Yes,White,2001,32,Male,Yes,Yes,5
Yes,White,2001,36,Male,Yes,Yes,3
Yes,Black,1998,23,Male,Yes,Yes,3
Yes,Black,2000,41,Male,No,No,0
Yes,White,1998,23,Male,Yes,No,0
Yes,White,2000,26,Male,Yes,Yes,3
Yes,White,1997,35,Male,No,Yes,1
Yes,White,2000,19,Male,No,Yes,3
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,2
No,Black,2000,23,Male,Yes,No,1
Yes,White,1999,41,Male,Yes,Yes,4
Yes,White,1999,41,Male,Yes,Yes,1
No,Black,1997,29,Male,Yes,No,0
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1999,34,Male,Yes,No,0
Yes,White,2000,22,Male,Yes,Yes,0
Yes,Black,1999,57,Male,No,No,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,1998,19,Male,No,Yes,4
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,2002,21,Male,Yes,Yes,0
No,Black,1998,16,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,2
No,Black,2002,39,Female,Yes,Yes,1
Yes,White,2000,20,Male,Yes,Yes,4
Yes,Black,2001,21,Male,Yes,Yes,3
Yes,Black,1999,29,Male,No,No,0
Yes,White,1998,16,Female,Yes,Yes,1
Yes,White,1998,26,Male,Yes,Yes,2
Yes,White,2000,29,Male,Yes,Yes,2
Yes,Black,2000,18,Male,Yes,No,4
Yes,Black,2002,22,Male,No,Yes,2
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,1997,19,Male,Yes,No,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,2000,25,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,3
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,35,Male,Yes,Yes,0
Yes,White,1997,46,Male,No,No,3
Yes,Black,2000,28,Male,Yes,No,0
Yes,Black,1998,51,Male,No,No,3
Yes,White,1998,17,Male,No,Yes,3
Yes,White,2001,17,Male,No,Yes,2
Yes,White,2001,18,Male,Yes,Yes,3
Yes,Black,1997,26,Male,Yes,Yes,2
No,Black,1998,17,Male,No,Yes,1
Yes,White,2001,20,Male,No,Yes,3
Yes,Black,1999,16,Male,Yes,Yes,5
Yes,Black,1998,18,Male,Yes,Yes,4
Yes,Black,1998,19,Male,No,Yes,0
Yes,White,1999,19,Female,Yes,Yes,0
Yes,White,2002,24,Male,Yes,Yes,0
Yes,Black,1998,18,Male,Yes,Yes,1
No,White,1997,19,Male,No,No,3
Yes,Black,1997,19,Male,Yes,No,0
Yes,White,2000,23,Male,No,Yes,0
No,Black,2000,22,Male,Yes,Yes,4
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
No,White,2001,33,Male,No,Yes,3
No,White,2001,47,Female,No,Yes,1
Yes,White,1999,16,Female,Yes,Yes,1
Yes,White,1999,18,Male,No,Yes,0
Yes,White,1997,16,Male,Yes,No,0
Yes,Black,1999,26,Male,No,Yes,0
Yes,White,1999,22,Male,Yes,Yes,0
No,Black,1998,19,Male,No,Yes,4
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,1
Yes,White,2002,21,Male,Yes,Yes,0
Yes,White,2000,21,Male,No,Yes,3
No,White,1998,18,Male,No,Yes,2
No,Black,1998,26,Male,Yes,No,1
Yes,White,1997,20,Female,Yes,Yes,0
Yes,Black,1999,36,Male,Yes,Yes,3
Yes,White,2001,29,Female,Yes,Yes,3
Yes,White,2001,27,Male,Yes,Yes,1
Yes,White,1998,14,Male,Yes,Yes,0
Yes,Black,2001,30,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,1
Yes,Black,1997,38,Male,No,No,1
Yes,White,2000,25,Male,Yes,Yes,3
No,Black,1999,17,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
Yes,Black,2000,22,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
No,White,1997,18,Male,No,No,2
Yes,White,2001,17,Male,Yes,No,0
Yes,White,2002,18,Male,Yes,Yes,0
Yes,Black,2001,28,Male,Yes,Yes,3
Yes,Black,1998,26,Male,Yes,Yes,3
Yes,White,1998,16,Female,No,Yes,3
Yes,White,2000,24,Male,No,Yes,4
Yes,White,1999,29,Male,Yes,Yes,3
Yes,White,1997,18,Male,Yes,Yes,2
Yes,White,2000,15,Male,Yes,Yes,1
Yes,White,2001,21,Male,No,Yes,1
Yes,White,1998,24,Male,Yes,Yes,1
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1999,35,Male,No,Yes,4
Yes,White,2000,22,Male,Yes,Yes,0
Yes,White,2000,32,Male,No,Yes,2
Yes,White,2001,26,Male,Yes,Yes,0
Yes,Black,1997,18,Male,Yes,Yes,0
Yes,White,1999,51,Male,Yes,Yes,0
No,White,1997,30,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,2000,33,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,2
Yes,White,1999,19,Male,Yes,Yes,2
Yes,White,1999,37,Male,No,Yes,3
Yes,White,2000,15,Male,Yes,No,1
No,White,1997,22,Male,No,No,4
Yes,White,1999,18,Male,No,Yes,3
Yes,Black,1998,17,Male,Yes,Yes,0
Yes,Black,1999,22,Male,Yes,Yes,4
Yes,White,1999,33,Male,Yes,Yes,2
Yes,White,1998,17,Male,Yes,Yes,1
Yes,White,1998,28,Male,No,Yes,3
Yes,White,1997,21,Male,Yes,No,1
No,White,1999,15,Male,Yes,Yes,0
Yes,White,1999,33,Male,Yes,Yes,0
No,Black,1998,26,Male,No,Yes,3
No,Black,2002,17,Male,No,Yes,4
Yes,White,2001,19,Male,Yes,Yes,3
Yes,Black,2000,45,Male,Yes,Yes,0
Yes,Black,2002,30,Female,No,Yes,0
No,White,1999,20,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,4
Yes,White,2001,43,Female,No,Yes,4
Yes,White,1997,19,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,2
Yes,White,1999,14,Male,Yes,Yes,0
Yes,Black,2002,21,Male,Yes,Yes,3
Yes,White,2000,37,Male,No,Yes,3
Yes,White,1998,14,Female,Yes,Yes,0
Yes,White,2002,19,Male,Yes,Yes,4
Yes,Black,2001,25,Male,Yes,Yes,2
Yes,Black,2000,20,Male,Yes,Yes,2
Yes,Black,1998,25,Male,No,No,2
Yes,Black,1998,19,Male,Yes,Yes,2
Yes,White,2000,17,Male,Yes,Yes,2
Yes,Black,2002,33,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,No,0
Yes,Black,2002,19,Male,Yes,Yes,2
Yes,White,1999,29,Female,Yes,Yes,4
Yes,White,1999,24,Male,Yes,Yes,2
Yes,White,2000,43,Male,No,Yes,3
Yes,White,2001,35,Male,Yes,Yes,2
Yes,White,1998,40,Male,No,No,3
Yes,White,2000,15,Male,Yes,Yes,0
Yes,White,2000,14,Male,Yes,Yes,2
Yes,White,1999,21,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,0
Yes,Black,1998,30,Male,Yes,Yes,0
Yes,White,1999,47,Male,Yes,Yes,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2002,35,Male,Yes,Yes,2
No,Black,1998,21,Male,No,Yes,4
Yes,White,2002,22,Male,Yes,Yes,2
Yes,White,2001,18,Male,Yes,No,0
Yes,White,1999,17,Male,Yes,Yes,0
Yes,Black,2001,23,Male,Yes,Yes,0
No,Black,1997,24,Male,Yes,No,4
Yes,White,2000,16,Male,Yes,Yes,0
Yes,Black,2002,26,Male,Yes,Yes,3
Yes,White,2000,20,Male,No,Yes,0
Yes,White,1998,20,Female,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,20,Male,No,Yes,1
Yes,Black,1999,29,Male,No,Yes,3
Yes,White,2002,28,Male,Yes,Yes,1
No,White,1999,26,Male,Yes,Yes,3
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,0
Yes,White,2001,17,Male,No,Yes,1
Yes,Black,1999,22,Male,No,Yes,6
Yes,Black,1999,22,Male,Yes,No,0
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,1998,25,Male,Yes,Yes,1
Yes,White,1997,15,Female,Yes,No,1
Yes,Black,1997,23,Male,Yes,Yes,4
No,White,1999,27,Male,Yes,Yes,3
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1999,43,Male,Yes,Yes,1
Yes,Black,1997,23,Male,No,No,3
Yes,Black,1997,64,Male,Yes,Yes,2
Yes,White,1999,23,Male,Yes,No,1
No,White,2002,23,Male,Yes,Yes,3
Yes,White,1999,25,Male,Yes,Yes,1
Yes,White,2000,16,Male,Yes,Yes,1
Yes,White,1999,16,Male,Yes,Yes,2
Yes,White,2002,20,Male,Yes,No,0
Yes,Black,1999,17,Male,Yes,Yes,2
Yes,White,2000,23,Male,Yes,Yes,2
Yes,Black,2000,19,Male,Yes,No,1
Yes,White,1997,18,Male,Yes,Yes,4
Yes,White,1999,20,Male,Yes,Yes,2
No,White,2002,17,Male,Yes,Yes,0
No,White,1999,16,Male,Yes,Yes,3
Yes,Black,2002,18,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,0
Yes,Black,1999,55,Male,Yes,No,2
Yes,Black,2001,50,Male,Yes,Yes,3
No,White,1999,25,Female,No,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,Black,1998,17,Female,Yes,Yes,3
Yes,White,2000,26,Male,Yes,Yes,1
Yes,White,1999,16,Male,Yes,Yes,4
Yes,White,2000,25,Male,Yes,Yes,2
Yes,White,1998,18,Male,Yes,Yes,0
Yes,Black,2001,29,Male,Yes,No,3
Yes,Black,2001,16,Female,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,3
No,White,1997,48,Male,Yes,No,3
Yes,White,2000,23,Male,Yes,Yes,3
Yes,White,1999,36,Male,Yes,No,0
Yes,White,1998,18,Male,Yes,Yes,2
Yes,White,2002,53,Female,No,Yes,1
No,Black,2001,18,Male,No,Yes,4
Yes,Black,1998,26,Male,Yes,Yes,2
Yes,Black,2001,25,Male,Yes,Yes,0
Yes,Black,2000,24,Male,Yes,Yes,4
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1999,49,Female,No,Yes,3
No,White,1997,30,Male,No,No,0
No,White,1998,19,Male,No,Yes,3
Yes,White,2000,44,Male,No,Yes,0
No,White,2001,18,Male,No,Yes,0
No,White,2001,18,Male,Yes,No,3
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,2001,29,Male,Yes,Yes,0
Yes,White,1999,21,Male,No,No,3
Yes,Black,1999,22,Male,No,No,1
Yes,Black,2000,38,Female,Yes,Yes,0
Yes,White,2002,36,Male,Yes,Yes,4
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,1
Yes,White,2002,19,Male,Yes,No,1
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,2
No,White,1999,17,Male,Yes,Yes,1
Yes,White,2000,18,Male,No,Yes,2
Yes,White,1999,26,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1997,23,Male,Yes,No,0
Yes,White,2000,22,Male,Yes,Yes,0
Yes,White,2000,25,Male,No,Yes,2
Yes,Black,2000,31,Male,Yes,Yes,3
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,2000,31,Male,Yes,Yes,2
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,No,3
Yes,White,2000,31,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,White,1999,30,Male,Yes,Yes,2
Yes,White,1999,22,Male,No,Yes,3
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,1997,43,Male,No,Yes,1
Yes,Black,1999,18,Male,No,No,1
Yes,Black,1998,17,Male,No,No,2
Yes,Black,2001,16,Female,Yes,Yes,0
Yes,White,2002,17,Male,Yes,Yes,1
Yes,Black,1997,33,Male,No,No,3
No,White,2000,31,Male,Yes,Yes,3
No,White,2000,35,Male,Yes,Yes,3
Yes,Black,1999,22,Male,Yes,Yes,4
Yes,White,2001,33,Male,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,1
Yes,Black,2001,27,Male,Yes,Yes,1
Yes,White,2000,23,Male,Yes,Yes,0
No,White,1999,19,Male,Yes,Yes,0
Yes,Black,1997,20,Male,No,Yes,3
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,1998,42,Male,Yes,Yes,0
Yes,White,1998,19,Female,Yes,Yes,0
Yes,White,2001,37,Male,Yes,Yes,2
Yes,Black,2001,20,Male,Yes,Yes,1
No,Black,1998,22,Female,No,Yes,4
Yes,White,1998,18,Male,No,Yes,4
No,White,2001,34,Male,Yes,Yes,4
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,1998,16,Female,Yes,Yes,4
Yes,Black,1999,20,Male,Yes,Yes,1
Yes,White,1999,50,Male,No,Yes,3
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,2002,18,Male,Yes,Yes,0
Yes,Black,2000,22,Male,Yes,Yes,0
Yes,Black,1997,19,Male,Yes,No,2
Yes,White,2000,22,Male,Yes,Yes,4
Yes,Black,2000,22,Male,Yes,No,6
Yes,White,1999,35,Male,Yes,Yes,2
Yes,White,2000,23,Male,Yes,Yes,1
Yes,White,1997,19,Female,No,No,0
Yes,White,2000,24,Female,No,Yes,2
No,White,1997,22,Male,No,No,2
Yes,White,2000,23,Male,Yes,Yes,0
Yes,Black,1998,22,Male,Yes,Yes,2
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,2
No,White,2000,26,Male,Yes,Yes,4
Yes,White,2000,22,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,1
Yes,White,2000,48,Male,Yes,Yes,2
Yes,White,2000,25,Male,Yes,Yes,0
Yes,White,2001,28,Male,No,Yes,0
Yes,Black,2001,22,Female,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,1999,24,Male,Yes,Yes,1
No,White,2001,13,Male,Yes,Yes,3
Yes,Black,1998,18,Male,Yes,Yes,0
Yes,White,1997,15,Male,Yes,No,0
Yes,White,2002,23,Male,Yes,Yes,0
Yes,White,2002,15,Male,Yes,Yes,0
No,White,1999,15,Male,Yes,Yes,3
No,White,2000,17,Male,Yes,No,3
Yes,White,1999,24,Male,Yes,Yes,1
No,White,2001,51,Male,No,Yes,1
No,White,1997,41,Male,No,No,2
Yes,White,1998,17,Male,Yes,Yes,2
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,17,Male,No,Yes,0
Yes,White,2001,22,Male,Yes,Yes,4
Yes,White,2000,42,Male,Yes,Yes,3
Yes,White,2000,19,Male,Yes,Yes,3
Yes,White,1999,16,Male,Yes,Yes,3
No,Black,1999,25,Male,No,No,3
Yes,White,1999,14,Male,Yes,Yes,0
Yes,Black,1998,59,Male,No,Yes,2
Yes,White,2001,20,Female,No,No,0
Yes,White,2001,21,Female,Yes,Yes,0
Yes,White,1999,19,Male,No,Yes,0
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2000,18,Male,Yes,Yes,0
Yes,Black,1999,34,Male,No,Yes,3
No,Black,2000,20,Male,No,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
No,White,2002,20,Male,No,Yes,0
Yes,White,2000,44,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,No,0
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,2000,29,Male,Yes,Yes,1
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2001,21,Male,Yes,Yes,4
Yes,White,1999,35,Male,Yes,Yes,0
Yes,White,2000,33,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,2
Yes,Black,1998,22,Male,Yes,Yes,0
Yes,White,2002,16,Male,Yes,Yes,3
Yes,Black,2000,22,Male,Yes,No,3
Yes,White,1998,25,Male,Yes,Yes,0
Yes,White,2000,22,Male,Yes,Yes,3
Yes,White,1999,22,Female,No,Yes,4
Yes,White,1998,28,Male,Yes,Yes,2
Yes,White,1997,32,Male,No,No,3
Yes,White,2000,26,Male,Yes,Yes,0
Yes,White,2000,14,Male,Yes,Yes,2
Yes,White,1999,20,Male,No,Yes,1
Yes,White,2002,45,Male,Yes,Yes,3
No,Black,2001,33,Male,Yes,Yes,4
No,Black,2001,23,Male,Yes,Yes,5
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,2001,34,Female,Yes,Yes,0
Yes,Black,2001,28,Male,No,Yes,3
Yes,White,1999,23,Male,Yes,Yes,4
Yes,White,2000,45,Male,Yes,Yes,1
No,White,2000,27,Male,Yes,Yes,0
Yes,Black,1999,23,Male,Yes,Yes,0
Yes,White,2001,43,Male,Yes,Yes,0
Yes,Black,1998,17,Female,Yes,Yes,0
No,White,1997,28,Male,Yes,No,2
Yes,White,1998,18,Male,No,Yes,3
Yes,White,1998,14,Male,Yes,Yes,1
Yes,Black,1999,17,Male,Yes,Yes,4
No,Black,2000,22,Male,No,No,6
No,White,2002,18,Male,Yes,Yes,0
Yes,White,2001,33,Male,Yes,Yes,3
Yes,Black,2001,26,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
No,Black,1997,18,Male,Yes,No,0
Yes,Black,1997,17,Female,Yes,No,0
Yes,Black,1998,26,Male,Yes,Yes,4
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,Yes,0
No,White,1999,18,Male,Yes,Yes,3
Yes,White,1998,25,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,17,Female,Yes,Yes,3
Yes,Black,2001,28,Male,Yes,No,1
Yes,Black,1998,21,Male,No,Yes,2
Yes,Black,1997,23,Male,Yes,No,3
Yes,White,2001,15,Male,Yes,Yes,1
No,White,1998,24,Male,No,Yes,3
No,White,2001,15,Male,Yes,Yes,1
Yes,Black,1998,13,Male,Yes,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,2
Yes,Black,2000,17,Male,Yes,Yes,1
Yes,White,2001,23,Male,Yes,Yes,0
Yes,Black,1997,37,Male,Yes,Yes,4
Yes,White,2000,18,Female,Yes,Yes,0
Yes,White,2001,17,Male,Yes,Yes,2
Yes,Black,1998,29,Male,No,No,0
Yes,White,1997,34,Male,Yes,Yes,3
Yes,White,2000,34,Male,Yes,Yes,2
Yes,White,1999,17,Male,Yes,Yes,0
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,Black,2001,20,Male,Yes,Yes,3
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,1999,27,Male,Yes,Yes,1
Yes,White,1997,20,Male,Yes,No,2
No,Black,2001,22,Male,Yes,Yes,2
Yes,White,2001,20,Male,Yes,Yes,3
Yes,White,1998,22,Male,Yes,Yes,2
No,White,1999,33,Male,No,Yes,3
Yes,White,2000,15,Male,Yes,Yes,1
Yes,Black,2001,19,Male,No,Yes,1
No,Black,1997,26,Male,Yes,No,2
Yes,Black,2001,27,Male,No,Yes,3
Yes,White,1999,17,Male,Yes,Yes,2
Yes,White,1999,44,Female,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,4
Yes,Black,2001,17,Male,Yes,Yes,0
Yes,White,1999,16,Female,Yes,Yes,0
Yes,White,1999,21,Male,Yes,No,0
Yes,Black,2001,25,Male,Yes,Yes,1
Yes,Black,1999,26,Male,Yes,Yes,1
Yes,White,2000,27,Male,Yes,Yes,0
Yes,White,1997,22,Male,Yes,No,0
Yes,Black,2000,24,Male,Yes,Yes,0
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,2001,23,Male,No,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,0
Yes,White,2001,36,Male,Yes,Yes,0
No,Black,1999,19,Male,Yes,No,0
Yes,Black,2002,28,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,3
Yes,Black,1998,23,Male,Yes,No,3
No,White,2000,21,Male,Yes,Yes,4
Yes,White,1998,48,Male,Yes,Yes,1
No,Black,2000,24,Male,Yes,Yes,4
Yes,Black,2000,49,Male,No,Yes,3
No,White,1998,18,Male,Yes,Yes,2
Yes,Black,1999,22,Male,No,Yes,1
No,Black,1998,16,Male,Yes,No,1
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,2
No,White,1997,20,Male,Yes,No,5
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2002,18,Male,No,Yes,2
Yes,White,1998,18,Male,No,Yes,0
No,Black,1998,19,Male,Yes,No,0
Yes,Black,1998,22,Male,Yes,Yes,0
Yes,Black,1997,47,Male,Yes,No,0
Yes,White,2001,28,Male,Yes,No,4
Yes,White,2000,19,Male,Yes,Yes,0
Yes,White,2001,16,Female,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2001,22,Female,No,Yes,3
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2000,35,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,No,0
Yes,White,1998,20,Male,Yes,Yes,1
Yes,White,2001,21,Male,No,Yes,1
Yes,Black,2000,23,Male,No,Yes,3
No,Black,2002,40,Male,Yes,No,3
Yes,White,1998,26,Male,Yes,Yes,0
Yes,White,1997,14,Male,Yes,Yes,0
No,Black,1998,26,Male,Yes,No,1
Yes,White,2001,14,Male,Yes,Yes,0
Yes,White,1998,20,Male,Yes,Yes,3
Yes,Black,2002,22,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2001,40,Male,No,Yes,2
Yes,Black,2000,58,Male,No,Yes,3
Yes,White,2000,25,Male,Yes,Yes,1
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1999,21,Male,Yes,Yes,4
No,White,1997,28,Male,No,No,0
Yes,White,2001,25,Male,Yes,Yes,4
Yes,White,1999,20,Male,Yes,Yes,2
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,1998,28,Male,Yes,Yes,2
Yes,White,1997,21,Male,No,Yes,4
Yes,Black,2001,17,Male,Yes,Yes,1
Yes,Black,1999,26,Male,Yes,No,4
Yes,Black,1999,22,Male,Yes,Yes,1
No,White,2002,21,Male,No,Yes,2
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1997,31,Male,Yes,Yes,0
Yes,Black,2000,22,Male,Yes,Yes,0
Yes,Black,2000,20,Female,Yes,Yes,0
Yes,White,1997,17,Female,Yes,No,1
Yes,White,1998,22,Male,Yes,Yes,4
No,White,1998,19,Male,Yes,Yes,0
Yes,White,2000,37,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,0
Yes,Black,1998,26,Male,Yes,No,1
Yes,White,1999,23,Male,Yes,Yes,0
No,White,1997,19,Male,Yes,Yes,2
Yes,Black,1999,18,Male,No,No,4
Yes,White,2000,37,Male,Yes,Yes,2
Yes,White,2001,46,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,1998,41,Female,No,Yes,0
Yes,Black,2001,26,Male,Yes,Yes,4
Yes,White,1997,21,Male,Yes,No,0
Yes,White,1998,20,Male,Yes,Yes,3
Yes,White,2001,23,Male,No,Yes,3
Yes,White,2000,17,Male,No,Yes,0
Yes,White,2001,45,Male,Yes,Yes,3
Yes,White,1997,21,Male,Yes,No,1
Yes,White,2001,19,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,3
Yes,White,1999,28,Female,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,4
Yes,White,2000,30,Male,Yes,Yes,0
Yes,White,1998,28,Male,Yes,Yes,3
Yes,Black,1998,38,Female,No,Yes,0
Yes,White,2001,17,Male,Yes,Yes,1
Yes,White,2001,17,Male,Yes,Yes,0
No,White,1997,18,Male,Yes,Yes,5
Yes,White,2000,15,Male,Yes,Yes,1
Yes,White,2001,32,Male,No,Yes,4
No,White,1999,18,Male,Yes,Yes,4
No,White,2000,41,Male,Yes,Yes,2
Yes,White,1997,23,Male,Yes,Yes,3
No,White,2002,25,Male,No,Yes,2
Yes,Black,2002,20,Male,Yes,Yes,1
Yes,White,1999,21,Male,Yes,Yes,4
Yes,White,1999,44,Female,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2002,24,Male,No,Yes,0
Yes,White,1998,18,Male,Yes,Yes,2
No,White,1999,18,Male,No,Yes,0
Yes,White,1999,28,Male,No,Yes,5
Yes,White,2000,15,Male,Yes,Yes,4
Yes,White,1997,18,Male,Yes,No,0
No,White,1997,33,Male,Yes,No,5
Yes,Black,2000,30,Male,Yes,Yes,2
Yes,White,1999,24,Male,Yes,Yes,0
Yes,White,1998,21,Female,Yes,Yes,0
Yes,Black,1999,17,Male,No,Yes,3
No,White,2001,16,Male,No,Yes,4
Yes,White,1998,16,Female,Yes,Yes,0
Yes,White,1998,26,Male,Yes,Yes,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
No,Black,1999,39,Male,Yes,No,4
Yes,White,2000,17,Male,Yes,No,0
Yes,White,1998,35,Male,No,Yes,3
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,No,0
Yes,White,1999,23,Male,Yes,Yes,1
Yes,White,2001,22,Male,No,Yes,4
Yes,White,1998,25,Male,Yes,Yes,2
Yes,White,2002,23,Male,Yes,Yes,3
Yes,Black,1997,17,Male,Yes,Yes,0
Yes,White,2000,48,Male,Yes,Yes,4
No,White,2001,15,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,1
No,White,1999,34,Male,No,Yes,2
Yes,White,1997,26,Male,No,No,0
No,White,2001,37,Male,Yes,Yes,6
Yes,White,1999,27,Male,Yes,Yes,0
Yes,White,1998,20,Male,No,Yes,4
No,Black,2000,41,Male,No,Yes,4
Yes,Black,2000,18,Male,No,Yes,1
Yes,White,2000,18,Male,Yes,Yes,1
No,White,2001,45,Male,No,Yes,1
Yes,White,1997,21,Male,Yes,No,0
No,White,2001,32,Male,Yes,Yes,3
Yes,White,1999,21,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,3
Yes,White,1999,28,Male,No,Yes,3
Yes,White,1998,14,Male,Yes,Yes,0
Yes,White,2000,14,Male,Yes,Yes,1
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,2000,20,Female,Yes,Yes,1
Yes,Black,2000,14,Male,Yes,Yes,1
Yes,Black,1998,23,Female,No,No,4
Yes,Black,1999,15,Male,Yes,Yes,2
Yes,White,1998,25,Male,Yes,No,0
Yes,White,1999,27,Male,Yes,Yes,3
No,Black,1999,28,Male,Yes,No,3
Yes,White,1998,17,Male,Yes,Yes,0
Yes,Black,1997,41,Male,Yes,No,0
Yes,Black,1997,20,Male,No,No,3
Yes,White,1998,20,Male,Yes,Yes,4
Yes,White,2000,23,Male,Yes,Yes,0
Yes,White,1998,19,Male,Yes,Yes,0
Yes,White,1998,34,Male,Yes,Yes,1
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,2000,22,Male,Yes,Yes,2
Yes,White,2001,16,Male,Yes,No,2
No,White,2000,17,Male,Yes,No,5
Yes,White,2001,44,Female,No,Yes,0
No,White,2001,16,Male,No,Yes,4
Yes,White,1997,36,Male,No,No,2
No,Black,2000,21,Male,Yes,Yes,4
Yes,White,2002,24,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,4
Yes,Black,1998,21,Male,No,Yes,2
No,Black,2001,24,Male,No,No,1
No,White,2002,16,Male,Yes,Yes,1
Yes,Black,2000,18,Male,No,Yes,2
Yes,White,2001,24,Male,Yes,Yes,1
Yes,White,2000,30,Male,Yes,Yes,3
Yes,White,2002,19,Male,Yes,No,0
Yes,White,2000,18,Male,No,Yes,0
Yes,Black,2001,23,Male,Yes,No,4
Yes,Black,2001,32,Male,Yes,No,0
Yes,White,2001,27,Male,No,Yes,0
Yes,White,2001,17,Female,Yes,No,0
Yes,White,1998,24,Male,Yes,Yes,1
Yes,White,2001,36,Male,Yes,Yes,3
Yes,White,2001,19,Male,Yes,Yes,0
No,White,1998,34,Male,No,Yes,2
No,Black,2000,40,Male,Yes,No,0
Yes,White,2001,17,Male,Yes,Yes,5
Yes,White,2000,38,Female,Yes,Yes,2
Yes,White,2001,39,Male,Yes,Yes,3
Yes,Black,1999,50,Male,Yes,No,1
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2000,29,Male,Yes,Yes,0
Yes,White,2001,28,Male,No,Yes,2
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1998,17,Female,Yes,Yes,0
Yes,White,1999,34,Male,No,Yes,2
Yes,White,2001,18,Male,Yes,Yes,0
No,White,1999,17,Female,No,Yes,3
No,White,2001,24,Male,Yes,Yes,3
Yes,White,2000,31,Male,No,Yes,1
Yes,White,1999,19,Female,Yes,Yes,0
No,White,1998,34,Male,Yes,Yes,0
No,Black,2001,26,Male,Yes,Yes,4
Yes,White,1999,41,Male,Yes,No,2
Yes,White,1999,42,Male,Yes,Yes,2
Yes,White,1998,15,Male,Yes,Yes,1
No,White,1999,46,Male,Yes,Yes,2
No,Black,1999,25,Male,No,Yes,3
No,White,2002,31,Male,No,Yes,4
Yes,White,1999,26,Male,No,Yes,0
Yes,White,2000,18,Female,Yes,Yes,0
No,White,1999,20,Male,Yes,Yes,0
Yes,Black,2001,28,Male,Yes,Yes,2
Yes,Black,2000,21,Male,Yes,Yes,1
Yes,White,1998,17,Female,Yes,Yes,1
Yes,White,1999,22,Male,No,Yes,3
No,White,1999,41,Male,No,Yes,2
Yes,White,1998,18,Male,No,Yes,3
No,Black,2000,14,Male,Yes,No,1
No,White,1998,17,Female,Yes,Yes,0
Yes,Black,1998,15,Male,Yes,Yes,3
Yes,Black,2001,44,Male,Yes,No,0
No,White,2002,19,Male,No,Yes,2
Yes,White,1998,18,Male,Yes,Yes,0
Yes,Black,2002,30,Male,No,Yes,4
Yes,White,2001,18,Male,No,Yes,3
No,Black,1997,25,Male,No,No,3
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,5
Yes,Black,2000,18,Female,Yes,Yes,0
Yes,Black,2001,20,Male,Yes,No,2
Yes,White,2000,16,Male,No,Yes,2
Yes,Black,2001,23,Male,Yes,Yes,2
Yes,White,2000,21,Male,Yes,Yes,2
Yes,Black,2000,19,Male,Yes,Yes,3
Yes,White,2000,19,Male,Yes,No,0
Yes,White,1999,18,Male,Yes,Yes,2
Yes,White,1997,17,Male,No,Yes,4
Yes,White,2000,29,Male,Yes,Yes,1
Yes,Black,1998,38,Male,Yes,Yes,0
Yes,Black,2000,25,Male,Yes,Yes,1
Yes,White,2001,17,Male,No,Yes,3
No,Black,2001,33,Male,Yes,No,3
Yes,White,2001,14,Male,Yes,Yes,2
Yes,White,2001,19,Male,Yes,Yes,2
No,White,2001,25,Male,Yes,No,2
Yes,Black,2000,31,Male,Yes,Yes,2
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2001,21,Male,No,No,1
Yes,White,1998,18,Male,Yes,Yes,0
Yes,Black,1997,27,Male,No,No,5
Yes,White,2000,33,Male,Yes,Yes,3
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,2000,21,Female,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,3
Yes,Black,1999,37,Male,Yes,Yes,2
No,White,1999,29,Male,Yes,Yes,4
Yes,White,2001,15,Male,Yes,Yes,1
Yes,White,1999,25,Female,Yes,Yes,0
Yes,White,1999,28,Male,Yes,Yes,3
Yes,White,1997,15,Male,Yes,No,0
Yes,Black,2000,18,Male,Yes,Yes,3
Yes,Black,1999,17,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,Black,2000,20,Male,Yes,Yes,1
No,White,1998,18,Male,No,Yes,1
No,White,1998,35,Male,No,Yes,3
No,Black,2000,23,Male,No,Yes,3
Yes,Black,2001,15,Male,Yes,Yes,0
No,White,2001,23,Male,No,Yes,4
Yes,White,2000,18,Male,No,Yes,0
No,White,2001,20,Male,Yes,Yes,4
Yes,White,2001,19,Male,Yes,No,0
Yes,Black,1999,24,Male,Yes,Yes,0
Yes,White,1997,19,Male,Yes,No,0
Yes,White,1998,18,Male,Yes,Yes,0
Yes,Black,1998,21,Male,Yes,Yes,0
No,Black,2000,21,Male,Yes,No,2
Yes,White,2001,19,Male,Yes,Yes,0
No,White,2001,26,Male,No,Yes,3
Yes,White,1998,18,Female,Yes,Yes,1
No,Black,1997,33,Male,No,No,4
No,White,2000,23,Male,No,Yes,4
Yes,White,2002,16,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,0
Yes,Black,2002,18,Male,Yes,Yes,2
Yes,Black,1998,21,Male,Yes,Yes,1
Yes,White,2001,20,Male,No,Yes,0
Yes,White,2000,19,Male,Yes,Yes,1
No,Black,1999,24,Male,Yes,Yes,1
Yes,Black,1999,23,Male,Yes,Yes,1
Yes,Black,2001,44,Male,Yes,Yes,0
No,Black,1997,16,Male,No,No,4
Yes,White,2001,21,Male,Yes,Yes,2
No,White,1997,18,Male,Yes,No,0
No,Black,1998,22,Male,Yes,Yes,4
Yes,Black,2001,37,Male,Yes,Yes,4
No,White,1999,18,Male,Yes,Yes,0
Yes,White,1998,36,Male,Yes,No,3
Yes,White,1999,20,Female,No,Yes,0
No,White,2000,35,Male,Yes,Yes,3
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1998,24,Male,Yes,Yes,2
No,White,1997,18,Male,Yes,Yes,0
No,White,1999,19,Male,Yes,Yes,4
Yes,White,2000,31,Male,Yes,Yes,0
Yes,Black,2000,19,Male,Yes,Yes,4
Yes,Black,1999,21,Male,No,Yes,3
No,White,2000,16,Male,Yes,Yes,1
Yes,Black,2000,19,Male,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,1
Yes,White,1999,14,Female,Yes,Yes,0
Yes,White,1998,32,Male,Yes,Yes,2
Yes,White,2001,17,Female,Yes,Yes,4
Yes,Black,1997,29,Male,Yes,No,2
Yes,White,1999,20,Male,Yes,Yes,3
Yes,White,1998,39,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1997,17,Male,Yes,No,3
Yes,White,1998,43,Female,No,Yes,0
No,White,2001,24,Male,Yes,No,3
Yes,Black,2001,15,Male,Yes,Yes,1
No,Black,1998,25,Male,Yes,No,2
No,White,2001,21,Male,No,Yes,5
Yes,White,1998,17,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,4
Yes,White,2002,30,Male,Yes,Yes,0
Yes,Black,1999,27,Male,Yes,Yes,0
Yes,White,2000,24,Male,Yes,Yes,0
Yes,White,2000,41,Male,Yes,Yes,0
No,White,1999,28,Male,No,Yes,3
Yes,White,1999,17,Male,Yes,Yes,0
Yes,White,2001,29,Male,No,Yes,0
Yes,White,2001,17,Male,Yes,Yes,2
Yes,White,1997,23,Male,Yes,Yes,1
Yes,White,2001,36,Male,Yes,Yes,0
Yes,Black,2000,17,Male,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,1997,42,Male,Yes,No,3
Yes,White,1999,22,Male,Yes,Yes,3
Yes,White,2001,30,Male,Yes,Yes,0
Yes,White,2002,19,Male,Yes,Yes,0
Yes,Black,2001,23,Male,No,Yes,3
Yes,Black,2001,33,Male,Yes,Yes,0
Yes,White,2001,27,Male,Yes,Yes,2
Yes,White,2000,21,Male,Yes,Yes,1
Yes,White,1998,20,Male,Yes,Yes,0
Yes,White,2000,37,Male,Yes,Yes,3
Yes,White,2000,15,Male,Yes,Yes,3
No,Black,1999,14,Male,Yes,Yes,3
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1998,23,Male,Yes,No,4
Yes,White,2001,18,Male,Yes,Yes,2
Yes,White,2002,27,Male,Yes,Yes,4
Yes,White,1999,24,Male,No,Yes,0
No,Black,1999,29,Male,Yes,Yes,4
Yes,White,2002,34,Male,Yes,Yes,4
Yes,White,2000,32,Female,No,Yes,0
Yes,Black,2000,15,Male,Yes,Yes,0
Yes,Black,1999,23,Male,Yes,Yes,0
Yes,White,2000,55,Male,Yes,Yes,2
No,White,2001,41,Female,No,Yes,4
Yes,White,2002,25,Male,Yes,Yes,1
Yes,White,2001,28,Male,Yes,Yes,0
Yes,Black,2000,18,Male,Yes,No,3
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,2001,27,Male,Yes,Yes,2
Yes,White,1997,21,Male,Yes,No,1
Yes,White,1999,20,Male,Yes,Yes,5
Yes,Black,1998,41,Male,Yes,Yes,2
Yes,White,1998,24,Male,Yes,Yes,1
Yes,White,2002,30,Male,Yes,Yes,0
Yes,White,1998,16,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,0
Yes,White,1998,12,Male,Yes,Yes,0
Yes,Black,1997,28,Male,Yes,No,4
No,White,1997,34,Male,Yes,No,0
No,White,2002,37,Male,No,Yes,3
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,2001,20,Male,Yes,Yes,0
Yes,White,1997,18,Female,Yes,Yes,0
Yes,White,2000,19,Male,No,Yes,2
Yes,White,1998,21,Male,Yes,Yes,0
No,Black,2000,15,Male,Yes,Yes,1
No,White,2000,44,Male,Yes,Yes,3
Yes,White,2001,18,Male,Yes,Yes,0
No,White,2002,23,Male,Yes,Yes,4
Yes,Black,2000,20,Male,No,Yes,4
No,Black,2001,22,Male,No,No,0
Yes,White,2001,28,Male,No,No,0
No,White,1997,26,Male,Yes,Yes,2
Yes,White,2000,19,Male,Yes,Yes,4
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,2
Yes,White,2000,24,Male,No,Yes,3
Yes,White,1999,39,Male,Yes,Yes,3
Yes,White,2002,15,Male,Yes,Yes,2
Yes,Black,2000,34,Male,Yes,Yes,1
No,Black,2002,16,Male,No,Yes,4
Yes,Black,2001,39,Male,Yes,Yes,1
Yes,White,2000,18,Male,Yes,Yes,2
Yes,Black,1999,34,Male,Yes,Yes,3
Yes,White,2001,20,Male,Yes,Yes,1
Yes,White,1998,19,Female,Yes,Yes,0
Yes,Black,1999,30,Male,Yes,Yes,1
Yes,White,1998,21,Male,No,Yes,3
No,White,2000,15,Male,Yes,Yes,4
Yes,White,2001,39,Male,No,No,3
No,Black,2000,23,Male,No,Yes,4
Yes,White,2000,21,Male,Yes,Yes,4
Yes,White,1998,20,Male,Yes,Yes,2
Yes,Black,2000,27,Male,Yes,No,3
No,White,2001,37,Female,No,Yes,4
Yes,White,2000,27,Male,Yes,Yes,0
Yes,White,2000,23,Male,Yes,Yes,1
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2000,20,Male,No,Yes,1
Yes,White,2001,17,Male,Yes,No,4
Yes,White,1998,34,Male,Yes,Yes,3
Yes,White,1999,17,Male,Yes,Yes,1
Yes,White,1999,21,Male,Yes,Yes,1
Yes,White,2000,17,Male,Yes,Yes,5
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1997,25,Male,Yes,No,1
No,Black,2000,34,Male,Yes,No,3
Yes,White,2000,47,Male,Yes,Yes,3
Yes,Black,1997,16,Male,Yes,No,1
Yes,Black,2001,20,Male,Yes,Yes,1
Yes,White,2001,19,Male,Yes,Yes,1
Yes,White,1999,18,Male,Yes,Yes,0
Yes,White,2001,18,Male,Yes,Yes,0
Yes,Black,1997,27,Female,Yes,No,0
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1999,32,Male,No,Yes,4
Yes,White,1997,18,Male,No,Yes,2
Yes,White,2000,20,Male,Yes,Yes,4
Yes,White,2000,18,Male,Yes,Yes,3
Yes,White,2000,24,Male,Yes,Yes,2
Yes,White,2001,17,Male,No,Yes,0
Yes,White,2001,37,Male,Yes,Yes,0
No,White,1997,17,Male,Yes,Yes,3
Yes,White,1997,34,Male,Yes,No,4
No,White,2000,48,Male,Yes,Yes,1
Yes,White,1998,33,Female,No,Yes,0
Yes,White,1998,21,Male,Yes,Yes,0
Yes,Black,1999,21,Male,No,Yes,2
Yes,White,1998,20,Male,Yes,Yes,0
Yes,Black,2000,48,Male,No,Yes,3
Yes,White,2001,15,Female,Yes,Yes,0
Yes,White,1998,27,Male,Yes,Yes,0
Yes,White,2001,22,Male,Yes,No,1
Yes,White,1998,25,Male,Yes,Yes,2
Yes,White,2000,15,Male,Yes,Yes,1
Yes,White,2001,21,Male,Yes,No,1
Yes,Black,2000,28,Male,No,Yes,4
No,Black,2000,25,Male,Yes,No,0
No,White,2001,20,Male,No,Yes,4
Yes,White,1999,22,Male,Yes,Yes,0
Yes,White,1997,18,Male,Yes,No,0
Yes,White,1998,25,Male,Yes,Yes,0
Yes,White,1998,29,Male,Yes,Yes,2
Yes,White,2000,28,Male,Yes,Yes,0
Yes,White,1998,20,Male,Yes,No,1
Yes,White,1998,18,Male,Yes,Yes,0
No,White,2001,15,Male,Yes,Yes,0
Yes,White,1999,23,Male,Yes,Yes,3
Yes,White,1999,17,Male,No,Yes,1
Yes,White,2000,20,Male,Yes,Yes,1
Yes,White,2000,50,Male,Yes,Yes,1
Yes,Black,2000,29,Male,No,Yes,3
Yes,White,2001,18,Male,Yes,Yes,5
Yes,White,2000,25,Male,Yes,Yes,3
Yes,Black,2001,31,Male,Yes,Yes,2
Yes,White,1998,18,Male,Yes,Yes,0
Yes,White,2000,16,Male,No,Yes,4
Yes,White,2001,30,Male,Yes,Yes,3
Yes,White,2001,21,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1998,35,Male,Yes,Yes,3
No,White,1997,42,Male,Yes,Yes,0
No,White,1997,42,Male,Yes,Yes,0
Yes,White,1997,43,Male,Yes,Yes,4
No,Black,2000,18,Male,Yes,Yes,4
Yes,White,1999,39,Male,Yes,Yes,3
No,White,1999,25,Male,Yes,Yes,0
Yes,Black,1999,17,Male,Yes,No,1
Yes,White,2000,32,Male,Yes,Yes,2
No,White,2001,29,Female,Yes,Yes,0
Yes,Black,2001,24,Male,No,Yes,4
Yes,Black,1998,33,Male,No,No,3
Yes,Black,1999,22,Male,Yes,Yes,2
Yes,White,1999,35,Male,Yes,Yes,5
Yes,White,1999,14,Male,Yes,Yes,1
Yes,Black,2001,20,Male,Yes,Yes,4
Yes,White,2000,15,Male,Yes,Yes,4
Yes,Black,1998,16,Male,Yes,Yes,1
Yes,Black,1999,19,Male,Yes,Yes,2
Yes,White,1999,20,Male,Yes,Yes,0
Yes,White,1999,18,Male,Yes,Yes,1
Yes,White,1999,30,Female,Yes,Yes,0
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2000,16,Male,No,Yes,1
No,White,1999,32,Male,No,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,2001,19,Male,No,Yes,0
Yes,Black,2000,48,Male,Yes,Yes,2
Yes,White,1999,12,Male,Yes,Yes,0
Yes,White,2000,19,Male,Yes,Yes,0
Yes,Black,2000,25,Male,Yes,Yes,3
Yes,White,2000,22,Male,Yes,Yes,1
Yes,Black,1999,20,Male,No,Yes,4
No,White,2002,16,Female,No,Yes,2
Yes,White,1998,17,Male,No,Yes,3
No,White,2000,40,Male,Yes,Yes,1
Yes,White,1999,35,Male,Yes,Yes,0
Yes,White,2001,23,Male,Yes,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,1998,22,Male,Yes,Yes,0
Yes,White,2000,28,Female,No,Yes,4
No,Black,1998,27,Male,Yes,Yes,3
Yes,White,2001,21,Male,Yes,Yes,3
No,White,2000,18,Male,Yes,No,3
Yes,White,2000,17,Male,Yes,Yes,1
No,White,1998,20,Male,No,Yes,0
Yes,White,1997,17,Male,Yes,Yes,2
Yes,White,1997,43,Male,Yes,No,4
Yes,White,1998,15,Male,Yes,Yes,0
Yes,White,2001,32,Female,No,Yes,3
Yes,White,2001,20,Male,Yes,Yes,2
Yes,White,1999,22,Male,Yes,Yes,2
Yes,White,1999,13,Male,Yes,Yes,0
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,2001,24,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,0
Yes,White,1999,17,Male,Yes,Yes,4
Yes,White,2001,17,Male,Yes,Yes,0
Yes,Black,1999,20,Male,Yes,Yes,4
Yes,White,1999,15,Male,Yes,Yes,0
Yes,White,2002,31,Male,No,Yes,0
Yes,White,2000,16,Male,Yes,Yes,0
Yes,White,2001,21,Female,Yes,Yes,0
Yes,Black,2001,19,Male,No,Yes,3
No,Black,2000,21,Male,Yes,No,0
Yes,Black,1999,21,Male,Yes,No,1
Yes,White,2001,13,Male,Yes,Yes,1
Yes,White,2001,19,Male,No,Yes,4
Yes,White,2000,15,Male,Yes,Yes,1
Yes,White,1998,21,Male,Yes,Yes,2
Yes,Black,1998,19,Female,Yes,Yes,1
Yes,White,2001,23,Male,Yes,Yes,1
Yes,White,2001,46,Male,Yes,Yes,1
Yes,White,2000,19,Male,Yes,Yes,2
Yes,White,1998,32,Male,Yes,Yes,3
Yes,Black,2002,35,Male,No,No,2
Yes,Black,1997,25,Male,No,Yes,3
Yes,White,1997,19,Male,No,No,2
Yes,White,1998,34,Male,Yes,Yes,0
Yes,White,1997,15,Female,Yes,No,1
Yes,White,2000,23,Male,No,Yes,2
Yes,White,1999,24,Female,No,Yes,5
Yes,White,2001,22,Male,Yes,Yes,0
Yes,White,1999,38,Male,No,Yes,3
Yes,White,1998,24,Male,Yes,Yes,3
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,1998,26,Female,Yes,Yes,0
Yes,White,1999,37,Male,Yes,Yes,0
Yes,White,1999,18,Male,No,Yes,0
Yes,White,2001,21,Male,Yes,Yes,1
Yes,White,2000,26,Female,Yes,Yes,0
Yes,White,2001,15,Male,Yes,Yes,1
Yes,Black,2000,22,Male,Yes,No,1
Yes,Black,2002,34,Male,Yes,Yes,3
Yes,Black,2001,32,Male,Yes,No,0
Yes,Black,1997,22,Male,Yes,Yes,3
Yes,Black,2001,16,Male,Yes,Yes,1
No,Black,2001,24,Male,No,Yes,3
Yes,Black,1998,21,Male,No,No,2
No,White,2002,16,Male,Yes,Yes,0
Yes,White,2001,25,Male,Yes,Yes,0
Yes,White,2000,20,Male,Yes,Yes,0
Yes,Black,1998,23,Female,No,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1997,16,Male,Yes,No,2
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,2000,24,Male,Yes,Yes,1
Yes,Black,1998,14,Male,Yes,Yes,1
Yes,Black,2001,23,Male,No,Yes,4
Yes,White,2000,22,Male,Yes,Yes,3
Yes,White,1999,19,Male,Yes,Yes,0
Yes,White,1998,15,Male,Yes,Yes,0
Yes,Black,2002,16,Male,Yes,Yes,0
Yes,White,2000,17,Female,No,Yes,3
Yes,White,2000,47,Male,Yes,Yes,0
Yes,White,2000,21,Male,Yes,Yes,0
Yes,White,1999,37,Male,Yes,Yes,2
Yes,White,2000,28,Male,Yes,Yes,0
Yes,White,1998,27,Male,Yes,Yes,0
Yes,White,2000,18,Male,Yes,Yes,0
Yes,White,1997,27,Male,Yes,Yes,4
Yes,White,1998,19,Male,Yes,Yes,2
Yes,White,2001,19,Male,Yes,Yes,3
No,White,1998,16,Male,Yes,Yes,3
Yes,White,2000,38,Male,Yes,No,2
Yes,White,2001,16,Male,Yes,Yes,0
Yes,White,1997,18,Male,Yes,No,2
No,White,1999,15,Male,Yes,Yes,2
Yes,White,1998,19,Male,Yes,Yes,3
Yes,White,1997,16,Male,Yes,No,0
Yes,White,2002,45,Male,No,Yes,3
Yes,White,2000,20,Male,Yes,Yes,1
Yes,Black,2001,17,Male,Yes,Yes,0
No,White,2000,27,Male,Yes,Yes,2
Yes,White,2002,46,Male,Yes,Yes,1
Yes,White,2000,19,Female,Yes,Yes,3
Yes,White,2002,30,Male,Yes,Yes,3
Yes,White,2001,42,Male,No,Yes,3
Yes,White,2000,36,Male,Yes,Yes,2
Yes,White,1999,16,Male,No,Yes,0
No,Black,2001,27,Male,Yes,Yes,3
Yes,Black,1998,19,Male,Yes,Yes,3
Yes,White,2002,19,Male,Yes,Yes,1
No,Black,1999,42,Male,Yes,Yes,5
Yes,White,1998,21,Male,Yes,Yes,0
Yes,White,1998,17,Male,Yes,Yes,2
Yes,White,2001,16,Male,No,Yes,3
Yes,White,2000,24,Male,Yes,Yes,2
Yes,White,2002,22,Male,Yes,Yes,0
Yes,White,2000,17,Male,Yes,Yes,0
Yes,White,2000,21,Female,Yes,Yes,0
Yes,Black,1999,21,Female,Yes,Yes,1
No,Black,1998,24,Male,Yes,Yes,4
Yes,White,1999,16,Male,Yes,Yes,3
;



